#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "funct_codes.h"
#include "pkt_types.h"

#define MACSZ 14
#define PROTSZ 6
#define MAX_DATA_SZ 8994
#define DATA_INC 1
#define NWRTFF 13
#define NRDFF 20


extern char *wbuf;
extern int nwbuf;
extern char rbuf[];
extern int nrbuf;


int flash_cmds(int nwrds)
{
  int n,l,lcnt;
  wbuf[0]=0x20;
  wbuf[1]=Flash_R_W;
  nwbuf=2*nwrds+2;
  //  for(l=0;l<nwbuf;l++){
  //    printf("%02X",wbuf[l]&0xFF);
  //  }
  //  printf("\n");
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return n;
}
int vme_cmds(int nwrds)
{
  int n,l,lcnt;
  wbuf[0]=0x20;
  wbuf[1]=VME_Cmds;
  nwbuf=2*nwrds+2;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return n;
}

int wrt_ff(int nwrds)
{
  int n,l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Wrt_Ext_FF;
  nwbuf=2*nwrds+2;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return n;
}


int rd_ff(int nwrds, int retrans, unsigned short int *buf)
{
  int i,l,n,numwrds,totwrds;
  enum pkt_t pkt_type;

  wbuf[0]=0x00;
  wbuf[1]=(retrans==1)?RT_Ext_FF:Rd_Ext_FF;
  wbuf[2]=(nwrds>>24)&0XFF;
  wbuf[3]=(nwrds>>16)&0XFF;
  wbuf[4]=(nwrds>>8)&0XFF;
  wbuf[5]=nwrds&0XFF;
  nwbuf=6;
  n=eth_write();
  for(i=0;i<nwrds;i++) buf[i] = 0;
  totwrds = 0;
  while(totwrds<nwrds){
    n=eth_read();
    pkt_type = rbuf[PKT_TYP_OFF] & 0xFF;
    if(pkt_type==EXFIFO_PKT){
      numwrds = ((rbuf[WRD_CNT_OFF]&0xff)<<8)|(rbuf[WRD_CNT_OFF+1]&0xff);
      for(i=0;i<numwrds;i++){
	buf[i] = ((rbuf[2*i+DATA_OFF]&0xFF)<<8)|(rbuf[2*i+DATA_OFF+1]&0xFF);
      }
      totwrds += numwrds;
    }
    else if(pkt_type>INFO_PKT){
      return -totwrds;
    }
    else {
      printf("Received unexpected packet type\n");
      return -totwrds;
    }
  }
  return totwrds;
}

void prst_ff()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=PRst_Ext_FF;
  nwbuf=2;
  n=eth_write();
  printf("Partial reset of FIFO done.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void mrst_ff()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=MRst_Ext_FF;
  nwbuf=2;
  n=eth_write();
  printf("Full reset of FIFO done.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void set_mark()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=ST_MK_Ext_FF;
  nwbuf=2;
  n=eth_write();
  printf("Mark set at current read pointer.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void rst_mark()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=RST_MK_Ext_FF;
  nwbuf=2;
  n=eth_write();
  printf("Reset mark -- Back to normal mode.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void set_ff_test_mode()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Set_FF_Test;
  nwbuf=2;
  n=eth_write();
  printf("Controller is in FIFO test mode.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void set_VME_mode()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Set_FF_VME;
  nwbuf=2;
  n=eth_write();
  printf("Controller is in VME mode.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void enable_ECC()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=ECC_enable;
  nwbuf=2;
  n=eth_write();
  printf("Error Correcting Code is enabled.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}
void disable_ECC()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=ECC_disable;
  nwbuf=2;
  n=eth_write();
  printf("Error Correcting Code is disabled.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void rst_err_cnt()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Rst_Ext_Err_Cnt;
  nwbuf=2;
  n=eth_write();
  printf("Reset error counters.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}
void enable_inj_errs()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Set_Inj_Err;
  nwbuf=2;
  n=eth_write();
  printf("Set inject error mode.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}
void disable_inj_errs()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Rst_Inj_Err;
  nwbuf=2;
  n=eth_write();
  printf("Error injecting is disabled.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void enable_warn_on_shutdown()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Warn_On_Shdwn;
  nwbuf=2;
  n=eth_write();
  printf("Shutdown warnings will be transmitted.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}
void disable_warn_on_shutdown()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=No_Warn_On_Shdwn;
  nwbuf=2;
  n=eth_write();
  printf("Warnings of pending shutdowns are being disabled!\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void snd_startup_pkt()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Snd_Startup_Pkt;
  nwbuf=2;
  n=eth_write();
  printf("An Info packet will be sent on start-up.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}
void no_startup_pkt()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=No_Startup_Pkt;
  nwbuf=2;
  n=eth_write();
  printf("Disabling Info packet on start-up\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}
void force_reload()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Force_Reload;
  nwbuf=2;
  n=eth_write();
  printf("Forcing Reload!\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

int rd_err_cnts(unsigned int *cor_p, unsigned int *uncor_p)
{
  int n;
  int i,l,lcnt;
  enum pkt_t pkt_type;
  wbuf[0]=0x60;
  wbuf[1]=Rd_Ext_Err_Cnts;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  pkt_type = rbuf[PKT_TYP_OFF] & 0xFF;
  if(pkt_type==EXFIFO_PKT){
    *uncor_p = 0;
    *cor_p   = 0;
    for(i=0;i<4;i++){
      *uncor_p |= ((rbuf[DATA_OFF+i]&0xff)<<(24-8*i));
      *cor_p   |= ((rbuf[DATA_OFF+4+i]&0xff)<<(24-8*i));
    }
  }
  else {
    return -1;
  }
  return 0;
}




int prg_off(unsigned int full_off, unsigned int mt_off)
{
  int i,n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Prg_Ext_Off;
  nwbuf=10;
  wbuf[2]=(full_off>>24)&0xff;
  wbuf[3]=(full_off>>16)&0xff;
  wbuf[4]=(full_off>>8)&0xff;
  wbuf[5]=(full_off)&0xff;
  wbuf[6]=(mt_off>>24)&0xff;
  wbuf[7]=(mt_off>>16)&0xff;
  wbuf[8]=(mt_off>>8)&0xff;
  wbuf[9]=(mt_off)&0xff;
  n=eth_write();
  //  printf("Offsets programmed\n");
  for(l=0;l<8000;l++)lcnt++;
  return n;
}


int rdbk_off(unsigned int *full_p, unsigned int *mt_p)
{
  int i,n;
  enum pkt_t pkt_type;
  wbuf[0]=0x00;
  wbuf[1]=Rdbk_Ext_Off;
  nwbuf=2 ;
  n=eth_write();
  n=eth_read();
  pkt_type = rbuf[PKT_TYP_OFF] & 0xFF;
  if(pkt_type==EXFIFO_PKT){
    *full_p = 0;
    *mt_p = 0;
    for(i=0;i<4;i++){
      *full_p |= ((rbuf[DATA_OFF+i]&0xff)<<(24-8*i));
      *mt_p   |= ((rbuf[DATA_OFF+4+i]&0xff)<<(24-8*i));
    }
  }
  else {
    return -1;
  }
  return 0;
}

void ld_usr_reg(int user)
{
  int n;
  wbuf[0]=0x00;
  wbuf[1]=Load_User_Reg;
  wbuf[2]=(user>>24)&0xFF;
  wbuf[3]=(user>>16)&0xFF;
  wbuf[4]=(user>>8)&0xFF;
  wbuf[5]=user&0xFF;
  nwbuf=6;
  n=eth_write();
  return;
}
