#ifndef HAVE_CODES_INI
#define HAVE_CODES_INI

struct ucw ucwtab[] = {
  {0x000, "INF", "G_No_Info",       "No information."},
  {0x001, "ERR", "CP_Un_Asgn",      "Command has not been assigned to a module."},
  {0x002, "ERR", "CP_Not_Def",      "Command is not defined in this module."},
  {0x003, "ERR", "CP_No_Data",      "Expected data was not present."},
  {0x004, "ERR", "CP_Not_Exec",     "Command was not executed."},
  {0x100, "ERR", "VD_Dat_WtErr",    "VME Direct Data FIFO Write error\n\t\t\t\t"
                                    "(written to while full)."},
  {0x101, "WRN", "VD_Dat_AF",       "VME Direct Data FIFO Almost Full\n\t\t\t\t"
                                    "(stop sending VME Direct Commands)."},
  {0x102, "ERR", "VD_Hdr_WtErr",    "VME Direct MAC/Hdr FIFO Write error\n\t\t\t\t"
                                    "(written to while full)."},
  {0x103, "WRN", "VD_Hdr_AF",       "VME Direct MAC/Hdr FIFO Almost Full\n\t\t\t\t"
                                    "(stop sending VME Direct Commands)."},
  {0x110, "ERR", "VC_Unkn_Addr",    "Unknown VME address."},
  {0x111, "ERR", "VC_Unkn_Dly",     "Unknown VME delay type."},
  {0x112, "ERR", "VC_Incomp_Opt",   "Incompatible options specified in VME cntrl word."},
  {0x113, "ERR", "VC_RdEr_Units",   "Read error -- number of VME units."},
  {0x114, "ERR", "VC_RdEr_CtrlWrd", "Read error -- VME control word."},
  {0x115, "ERR", "VC_RdEr_Addr",    "Read error -- VME address."},
  {0x116, "ERR", "VC_RdEr_Dcnt",    "Read error -- VME data count."},
  {0x117, "ERR", "VC_RdEr_Data",    "Read error -- VME data word."},
  {0x118, "ERR", "VC_MTEr_Fifo",    "FIFO Empty error\n\t\t\t\t"
                                    "(timed-out while waiting to read)."},
  {0x120, "ERR", "VM_BERR_Slv",     "VME Master: Bus error initiated by slave."},
  {0x121, "ERR", "VM_BTO",          "VME Master: Bus time out."},
  {0x122, "ERR", "VM_Not_Sup",      "VME Master: command is not supported."},
  {0x130, "ERR", "VR_Mis_SOP",      "VME Read Controller: Missing start of packet."},
  {0x131, "ERR", "VR_Wrng_Typ",     "VME Read Controller: Wrong packet type seen."},
  {0x132, "ERR", "VR_Rd_TMO",       "VME Read Controller: Timed-out waiting for data."},
  {0x140, "ERR", "VI_BERR_Slv",     "VME Intrpt Hndlr: Bus error initiated by slave."},
  {0x141, "ERR", "VI_BTO",          "VME Intrpt Hndlr: Bus time out."},
  {0x142, "WRN", "VI_Msk_Chg",      "IRQ mask has changed."},
  {0x161, "ERR", "VA_BGTO",         "VME Bus Grant time out"},
  {0x200, "ERR", "EF_Rd_Err",       "External FIFO went empty after read started."},
  {0x201, "ERR", "EF_MT_Err",       "External FIFO was empty when read was requested."},
  {0x202, "ERR", "EF_Rt_Err",       "External FIFO empty or Mark not set when\n\t\t\t\t"
                                    "retransmit read was requested."},
  {0x203, "ERR", "EF_Mk_Err",       "External FIFO attempt to set Mark when\n\t\t\t\t"
                                    "almost empty."},
  {0x204, "ERR", "EF_Wrt_Err",      "External FIFO went full after\n\t\t\t\t"
                                    "write sequence started."},
  {0x205, "WRN", "EF_FF_PAF",       "External FIFO is almost full\n\t\t\t\t"
                                    "(stop sending FIFO or VME commands)."},
  {0x206, "WRN", "EF_V_wrt_Wrn",    "VME command received while in FIFO TEST mode\n\t\t\t\t"
                                    "(data written to FIFO)."},
  {0x207, "ERR", "EF_Rd_V_Err",     "FIFO read command received while inn VME mode\n\t\t\t\t"
                                    "(no data read from FIFO)."},
  {0x208, "ERR", "EF_Mltp_Err",     "Multiple FIFO errors."},
  {0x209, "WRN", "EF_Wrt_Wrn",      "Write command received while in VME mode\n\t\t\t\t"
                                    "(data written to FIFO)."},
  {0x210, "ERR", "ER_Rcv_Err",      "Ethernet receive FIFO went empty before\n\t\t\t\t"
                                    "all packet data was read."},
  {0x230, "WRN", "JT_Buf_AF",       "JTAG buffer is almost full\n\t\t\t\t"
                                    "(stop sending JTAG commands)."},
  {0x231, "ERR", "JT_Buf_Ovfl",     "JTAG buffer overflowed\n\t\t\t\t"
                                    "(some JTAG commands are lost)."},
  {0x232, "INF", "JT_Buf_AMT",      "JTAG buffer is almost MT\n\t\t\t\t"
                                    "(start sending JTAG commands)."},
  {0x233, "ERR", "JT_Buf_RdErr",    "JTAG Buffer Read error."},
  {0x234, "ERR", "JT_Unk_Cmd",      "Unknown JTAG Instruction in memory."},
  {0x235, "ERR", "JT_Ver_Fail",     "PROM Verification Failed."},
  {0x236, "ERR", "JT_Prg_Fail",     "PROM Programming Failed."},
  {0x240, "WRN", "FL_In_AF",        "Flash Control Input FIFO is almost full\n\t\t\t\t"
                                    "(stop sending Flash or Config commands)."},
  {0x241, "ERR", "FL_In_WtErr",     "Flash Control Input FIFO Write error\n\t\t\t\t"
                                    "(attempted write when full; some info lost)."},
  {0x242, "ERR", "FL_In_RdErr",     "Flash Control Input FIFO Read error\n\t\t\t\t"
                                    "(attempted read when empty; data invalid)."},
  {0x243, "ERR", "FL_TRDS_WtErr",   "Flash Control Total Reads FIFO Write error\n\t\t\t\t"
                                    "(attempted write when full; some info lost)."},
  {0x244, "ERR", "FL_TRDS_RdErr",   "Flash Control Total Reads FIFO Read error\n\t\t\t\t"
                                    "(attempted read when empty; data invalid)."},
  {0x245, "ERR", "FL_PgRd_WtErr",   "Flash Control Page/Read FIFO Write error\n\t\t\t\t"
                                    "(attempted write when full; some info lost)."},
  {0x246, "ERR", "FL_PgRd_RdErr",   "Flash Control Page/Read FIFO Read error\n\t\t\t\t"
                                    "(attempted read when empty; data invalid)."},
  {0x247, "ERR", "FL_ADFF_WtErr",   "Flash Control Address FIFO Write error\n\t\t\t\t"
                                    "(attempted write when full; some info lost)."},
  {0x248, "ERR", "FL_ADFF_RdErr",   "Flash Control Address FIFO Read error\n\t\t\t\t"
                                    "(attempted read when empty; data invalid)."},
  {0x250, "ERR", "CF_Mltp_Flsh",    "Multiple errors from Flash Controller\n\t\t\t\t"
                                    "(see following data word for error bits)."},
  {0x251, "ERR", "CF_Crptd_Dat",    "Corrupted data from Flash Controller\n\t\t\t\t"
                                    "(uncorrected bit errors)."},
  {0x252, "WRN", "CF_Bit_Errs",     "Bit errors in data from Flash Controller\n\t\t\t\t"
                                    "were found and corrected."},
  {0x260, "WRN", "RH_xxx_xxx",      ""}, 
  {0x270, "WRN", "SS_Rld_Pndg",     "Controller is shuting down to reload firmware."},
  {0x271, "INF", "SS_Sys_Up",       "Controller system is back up."}
};


struct ak_st ak_status[] = {
  {"NO_ACK", "No acknowledgement requested or not implemented."},
  {"CC_S", "Command completed successfully."},
  {"CC_W", "Command completed with warnings."},
  {"CC_E", "Command completed with errors."},
  {"CE_I", "Command execution finished incomplete."},
  {"CIP", "Command in progress no warnings no errors."},
  {"CIP_W", "Command in progress with warnings."},
  {"CIP_E", "Command in progress with errors."}
};

struct ucw foptab[] = {
  {0x00,"CNFG","Funct_NoOp","No Operation"},
  {0x01,"CNFG","Set_FF_Test","Set external FIFO interface to test mode"},
  {0x02,"CNFG","Set_FF_VME","Set external FIFO interface to VME mode"},
  {0x03,"CNFG","ECC_enable","Enable error corrceting code in FIFO"},
  {0x04,"CNFG","ECC_disable","Disable error corrceting code in FIFO"},
  {0x05,"CNFG","Save_Cnfg_Num","Save cur. config as specifed config num."},
  {0x06,"CNFG","Read_Cnfg_Num_Dir","Read config direct from FLASH"},
  {0x07,"CNFG","Read_Cnfg_Num_Dcd","Read decoded config from FLASH"},
  {0x08,"CNFG","Rstr_Cnfg_Num","Restore config to specified config num"},
  {0x09,"CNFG","Set_Cnfg_Dflt","Set the default config. number"},
  {0x0A,"CNFG","Read_Cnfg_Dflt","Read cur. default config. number"},
  {0x0B,"CNFG","Set_MACs","Set MAC addresses"},
  {0x0C,"CNFG","Read_MACs_Dir","Read MAC address dircetly from FLASH"},
  {0x0D,"CNFG","Read_MACs_Dcd","Read decoded MAC address from FLASH"},
  {0x0E,"CNFG","Read_CRs","Read cur config register settings"},
  {0x0F,"CNFG","Wrt_Eth_CR","Write Ethernet config register."},
  {0x10,"CNFG","Wrt_Ext_CR","Write External FIFO config register."},
  {0x11,"CNFG","Wrt_Rst_CR","Write Reset config register."},
  {0x12,"CNFG","Wrt_VME_CR","Write VME config register."},
  {0x13,"CNFG","Wrt_BTO_CR","Write Bus Time Out config register."},
  {0x14,"CNFG","Wrt_BGTO_CR","Write Bus Grant Time Out config register."},
  {0x15,"CNFG","Wrt_All_CRs","Write all config registers"},
  {0x16,"CNFG","Set_Clr_CRs","Set or Clear config registers"},
  {0x17,"CNFG","Set_Inj_Err","Turn on error injection"},
  {0x18,"CNFG","Rst_Inj_Err","Turn off error injection"},
  {0x19,"CNFG","Warn_On_Shdwn","Enable warning packet on shutdown"},
  {0x1A,"CNFG","No_Warn_On_Shdwn","Disable warning packet on shutdown"},
  {0x1B,"CNFG","Snd_Startup_Pkt","Enable startup packet after reload"},
  {0x1C,"CNFG","No_Startup_Pkt","Disable startup packet after reload"},
  {0x1D,"CNFG","Wrt_Ser_Num","Write serial number to FLASH"},
  {0x1E,"CNFG","Rd_Ser_Num","Read serial number from FLASH"},
  {0x1F,"CNFG","Wrt_CR_ID","Write config reg. by specifying ID"},
  {0x20,"VME","VME_Cmds","Packet of VME commands buffered in FIFO"},
  {0x22,"VME","VME_Dir_Cmds","Packet of VME commands direct to VME cntrl."},
  {0x40,"FLASH","Flash_R_W","Packet of FLASH read or write commands"},
  {0xE0,"EXFF","Wrt_Ext_FF","Write data to external FIFO"},
  {0xE1,"EXFF","Prg_Ext_Off","Program offsets in external FIFO"},
  {0xE2,"EXFF","Rdbk_Ext_Off","Readback offsets from external FIFO"},
  {0xE3,"EXFF","PRst_Ext_FF","Partial reset of external FIFO"},
  {0xE4,"EXFF","Rd_Ext_FF","Read data from external FIFO"},
  {0xE5,"EXFF","RT_Ext_FF","Retransmit data from external FIFO"},
  {0xE6,"EXFF","MRst_Ext_FF","Master reset of external FIFO"},
  {0xE7,"EXFF","ST_MK_Ext_FF","Set Mark in external FIFO"},
  {0xE8,"EXFF","RST_MK_Ext_FF","Reset Mark in external FIFO"},
  {0xE9,"EXFF","Rst_Ext_Err_Cnt","Reset FIFO error counter"},
  {0xEA,"EXFF","Rd_Ext_Err_Cnts","Read FIFO error counter"},
  {0xEF,"EXFF","Flush_2_BOD","Flush FIFO to Begining of Data"},
  {0xF0,"TST","Rst_Seq_ID","Reset Sequencial ID counter"},
  {0xF7,"SLVTST","Gen_Intr","Generate Interrupt on Slave test board"},
  {0xF8,"SLVTST","Gen_Hard_Rst","Generate Hard Reset on Slave test board"},
  {0xF9,"TST","Force_Reload","Force a Reload"},
  {0xFD,"TST","Send_N_Words","Return n words"},
  {0xFE,"TST","Load_User_Reg","Load User Reg (LEDs)"},
  {0xFF,"TST","Loopback","Retrun data to sender."}
};

struct ucw pkttab[] = {
  {0x00,"MISC","NO_DATA_PKT","No data with this packet"},
  {0x01,"DIAG","LPBCK_PKT","Loopback data"},
  {0x02,"DIAG","TXNWRDS_PKT","Transmit n-words data"},
  {0x03,"FIFO","EXFIFO_PKT","External FIFO data"},
  {0x04,"VME","VMED08_PKT","VME data bytes"},
  {0x05,"VME","VMED16_PKT","VME data words"},
  {0x06,"VME","VMED32_PKT","VME data long words"},
  {0x07,"VME","VMED64_PKT","VME data quad words"},
  {0x08,"JTAG","JTAG_MOD_PKT","JTAG module data packet"},
  {0x0A,"CNFG","CNFG_MOD_PKT","Config module data packet"},
  {0x0B,"FLSH","FLSH_RBK_PKT","FLASH module data packet"},
  {0x10,"ETHN","ETH_NET_PKT","Ethernet module data packet"},
  {0xF8,"INTR","IHD08_Stat_ID_PKT","Interrupt with 8-bit status word"},
  {0xF9,"INTR","IHD16_Stat_ID_PKT","Interrupt with 16-bit status word"},
  {0xFA,"INTR","IHD32_Stat_ID_PKT","Interrupt with 32-bit status word"},
  {0xFD,"TST","Info_PKT","Information packet"},
  {0xFE,"TST","Warn_PKT","Warning packet"},
  {0xFF,"TST","Err_PKT","Error packet"}
};

#define NERRCODES (sizeof ucwtab / sizeof(struct ucw))
#define NOPCODES (sizeof foptab / sizeof(struct ucw))
#define NPKTCODES (sizeof pkttab / sizeof(struct ucw))

int nerrcodes;
int nopcodes;
int npktcodes;

#endif
