#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cnfg_defs.h"
#include "codes.h"
#include "pkt_info.h"

extern char *wbuf;
extern int nwbuf;
extern char rbuf[];
extern int nrbuf;

extern FILE *fplog;

CNFG_ptr load_cnfg(char *fn)
{
  int i;
  char line[CNFG_MAXLINE],key_wrd[24];
static  char macfmt[] = "%2hx-%2hx-%2hx-%2hx-%2hx-%2hx";
  unsigned short tmp[6];
  CNFG_ptr cp;
  FILE *fp;
  if((fp=fopen(fn,"r"))==0){
    return((CNFG_ptr)(-1));
  }
  cp=(CNFG_ptr)malloc(sizeof(CNFG_t));
  while(fscanf(fp,"%s",key_wrd)>0){
    if(key_wrd[0]!='#'&&(strncmp(key_wrd,"//",2)!=0)){
      if(strcmp(key_wrd,"Device:")==0){
        fscanf(fp,macfmt,tmp,tmp+1,tmp+2,tmp+3,tmp+4,tmp+5);
        for(i=0;i<6;i++) cp->mac.device[i] = (unsigned char)tmp[i];
      }
      else if(strcmp(key_wrd,"Mcast1:")==0){
        fscanf(fp,macfmt,tmp,tmp+1,tmp+2,tmp+3,tmp+4,tmp+5);
        for(i=0;i<6;i++) cp->mac.mcast1[i] = (unsigned char)tmp[i];
      }
      else if(strcmp(key_wrd,"Mcast2:")==0){
        fscanf(fp,macfmt,tmp,tmp+1,tmp+2,tmp+3,tmp+4,tmp+5);
        for(i=0;i<6;i++) cp->mac.mcast2[i] = (unsigned char)tmp[i];
      }
      else if(strcmp(key_wrd,"Mcast3:")==0){
        fscanf(fp,macfmt,tmp,tmp+1,tmp+2,tmp+3,tmp+4,tmp+5);
        for(i=0;i<6;i++) cp->mac.mcast3[i] = (unsigned char)tmp[i];
      }
      else if(strcmp(key_wrd,"Dflt_Srv:")==0){
        fscanf(fp,macfmt,tmp,tmp+1,tmp+2,tmp+3,tmp+4,tmp+5);
        for(i=0;i<6;i++) cp->mac.dflt_srv[i] = (unsigned char)tmp[i];
      }
      else if(strcmp(key_wrd,"Ether:")==0){
        fscanf(fp,"%hX",&cp->ether);
      }
      else if(strcmp(key_wrd,"Ext_FIFO:")==0){
        fscanf(fp,"%hX",&cp->ext_fifo);
      }
      else if(strcmp(key_wrd,"Reset:")==0){
        fscanf(fp,"%hX",&cp->reset);
      }
      else if(strcmp(key_wrd,"VME:")==0){
        fscanf(fp,"%X",&cp->vme);
      }
      else if(strcmp(key_wrd,"VME_BTO:")==0){
        fscanf(fp,"%hX",&cp->vme_bto);
      }
      else if(strcmp(key_wrd,"VME_BGTO:")==0){
        fscanf(fp,"%hX",&cp->vme_bgto);
      }
      else {
        printf("\nUnrecognized Keyword: %s\n",key_wrd);
        fgets(line,CNFG_MAXLINE,fp);
      }
    }
    else {
      fgets(line,CNFG_MAXLINE,fp);
    }
  }
  fclose(fp);
  return(cp);
}
int write_cnfg(CNFG_ptr cp, char *fn)
{
  int i;
  FILE *fp;
  if((fp=fopen(fn,"w"))==0){
    printf("Error could not open %s\n");
    return(-1);
  }
  fprintf(fp,"Device:   ");
  for(i=0;i<5;i++){
    fprintf(fp,"%02X-",cp->mac.device[i]);
  }
  fprintf(fp,"%02X\n",cp->mac.device[5]);
  fprintf(fp,"Mcast1:   ");
  for(i=0;i<5;i++){
    fprintf(fp,"%02X-",cp->mac.mcast1[i]);
  }
  fprintf(fp,"%02X\n",cp->mac.mcast1[5]);
  fprintf(fp,"Mcast2:   ");
  for(i=0;i<5;i++){
    fprintf(fp,"%02X-",cp->mac.mcast2[i]);
  }
  fprintf(fp,"%02X\n",cp->mac.mcast2[5]);
  fprintf(fp,"Mcast3:   ");
  for(i=0;i<5;i++){
    fprintf(fp,"%02X-",cp->mac.mcast3[i]);
  }
  fprintf(fp,"%02X\n",cp->mac.mcast3[5]);
  fprintf(fp,"Dflt_srv: ");
  for(i=0;i<5;i++){
    fprintf(fp,"%02X-",cp->mac.dflt_srv[i]);
  }
  fprintf(fp,"%02X\n",cp->mac.dflt_srv[5]);

  fprintf(fp,"Ether:        %04hX\n",cp->ether);
  fprintf(fp,"Ext_fifo:     %04hX\n",cp->ext_fifo);
  fprintf(fp,"Reset:        %04hX\n",cp->reset);
  fprintf(fp,"VME:      %08X\n",cp->vme);
  fprintf(fp,"VME_BTO:      %04hX\n",cp->vme_bto);
  fprintf(fp,"VME_BGTO:     %04hX\n",cp->vme_bgto);
  fclose(fp);
  return(0);
}

int set_cnfg_dflt(int dflt)
{
  int n,l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Set_Cnfg_Dflt;
  wbuf[2]=0x00;
  wbuf[3]=(dflt&0x1f);
  nwbuf=4;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return(n);
}

int read_cnfg_dflt()
{
  int n;
  enum pkt_t ptyp;
  wbuf[0]=0x20;
  wbuf[1]=Read_Cnfg_Dflt;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  ptyp = rbuf[PKT_TYP_OFF]&0xff;
  if(ptyp>=INFO_PKT){
    dcode_msg_pkt(rbuf);
    return(-(((rbuf[22]&0xFF)<<8)|(rbuf[23]&0xFF)));
  }
  return(rbuf[23]&0xFF);
}

int save_cnfg_num(int cnum)
{
  int n,l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Save_Cnfg_Num;
  wbuf[2]=0x00;
  wbuf[3]=(cnum&0x1f);  // cnum must be <= 20
  nwbuf=4;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return(n);
}

int rstr_cnfg_num(int cnum)
{
  int n,l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Rstr_Cnfg_Num;
  wbuf[2]=0x00;
  wbuf[3]=(cnum&0x1f);  // cnum must be <= 20
  nwbuf=4;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return(n);
}

int read_cnfg_num_dir(int cnum, char **dpp)
{
  int n,numwrds;
  enum pkt_t ptyp;
  wbuf[0]=0x20;
  wbuf[1]=Read_Cnfg_Num_Dir;
  wbuf[2]=0x00;
  wbuf[3]=(cnum&0x1f);  // cnum must be <= 20
  nwbuf=4;
  n=eth_write();
  n=eth_read();
  ptyp = rbuf[PKT_TYP_OFF]&0xff;
  if(ptyp>=INFO_PKT){
    dcode_msg_pkt(rbuf);
    return(-(((rbuf[22]&0xFF)<<8)|(rbuf[23]&0xFF)));
  }
  numwrds = ((rbuf[20]&0xff)<<8)|(rbuf[21]&0xff);
  *dpp = &rbuf[22];
  return(numwrds);
}

CNFG_ptr read_cnfg_num_dcd(int cnum)
{
  int i,n;
  enum pkt_t ptyp;
  CNFG_ptr cp;
  wbuf[0]=0x00;
  wbuf[1]=Read_Cnfg_Num_Dcd;
  wbuf[2]=0x00;
  wbuf[3]=(cnum&0x1f);  // cnum must be <= 20
  nwbuf=4;
  n=eth_write();
  n=eth_read();
  ptyp = rbuf[PKT_TYP_OFF]&0xff;
  if(ptyp>=INFO_PKT){
    dcode_msg_pkt(rbuf);
    return((CNFG_ptr)(-(((rbuf[22]&0xFF)<<8)|(rbuf[23]&0xFF))));
  }
  cp=(CNFG_ptr)malloc(sizeof(CNFG_t));
  cp->ether = ((rbuf[22]&0xFF)<<8)|(rbuf[23]&0xFF);
  cp->ext_fifo = ((rbuf[24]&0xFF)<<8)|(rbuf[25]&0xFF);
  cp->reset = ((rbuf[26]&0xFF)<<8)|(rbuf[27]&0xFF);
  cp->vme = ((rbuf[28]&0xFF)<<24)|((rbuf[29]&0xFF)<<16)|((rbuf[30]&0xFF)<<8)|(rbuf[31]&0xFF);
  cp->vme_bto = ((rbuf[32]&0xFF)<<8)|(rbuf[33]&0xFF);
  cp->vme_bgto = ((rbuf[34]&0xFF)<<8)|(rbuf[35]&0xFF);
  return(cp);
}

CNFG_ptr read_crs()
{
  int n;
  enum pkt_t ptyp;
  CNFG_ptr cp;
  wbuf[0]=0x20;
  wbuf[1]=Read_CRs;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  ptyp = rbuf[PKT_TYP_OFF]&0xff;
  if(ptyp>=INFO_PKT){
    dcode_msg_pkt(rbuf);
    return((CNFG_ptr)(-(((rbuf[22]&0xFF)<<8)|(rbuf[23]&0xFF))));
  }
  cp=(CNFG_ptr)malloc(sizeof(CNFG_t));
  cp->ether = ((rbuf[22]&0xFF)<<8)|(rbuf[23]&0xFF);
  cp->ext_fifo = ((rbuf[24]&0xFF)<<8)|(rbuf[25]&0xFF);
  cp->reset = ((rbuf[26]&0xFF)<<8)|(rbuf[27]&0xFF);
  cp->vme = ((rbuf[28]&0xFF)<<24)|((rbuf[29]&0xFF)<<16)|((rbuf[30]&0xFF)<<8)|(rbuf[31]&0xFF);
  cp->vme_bto = ((rbuf[32]&0xFF)<<8)|(rbuf[33]&0xFF);
  cp->vme_bgto = ((rbuf[34]&0xFF)<<8)|(rbuf[35]&0xFF);
  return(cp);
}

int set_macs(enum MAC_ID mcid, CNFG_ptr cp)
{
  int i,n,l,lcnt,err;
  err=0;
  wbuf[0]=0x00;
  wbuf[1]=Set_MACs;
  wbuf[2]=0x00;
  wbuf[3]=mcid;
  nwbuf=4;
  switch(mcid){
    case DEVICE:
      for(i=0;i<6;i++)wbuf[4+i]=cp->mac.device[i];
      nwbuf+=6;
      break;
    case MCAST1:
      for(i=0;i<6;i++)wbuf[4+i]=cp->mac.mcast1[i];
      nwbuf+=6;
      break;
    case MCAST2:
      for(i=0;i<6;i++)wbuf[4+i]=cp->mac.mcast2[i];
      nwbuf+=6;
      break;
    case MCAST3:
      for(i=0;i<6;i++)wbuf[4+i]=cp->mac.mcast3[i];
      nwbuf+=6;
      break;
    case DFLT_SRV:
      for(i=0;i<6;i++)wbuf[4+i]=cp->mac.dflt_srv[i];
      nwbuf+=6;
      break;
    case ALL_MACS:
      for(i=0;i<6;i++)wbuf[4+i]=cp->mac.device[i];
      nwbuf+=6;
      for(i=0;i<6;i++)wbuf[10+i]=cp->mac.mcast1[i];
      nwbuf+=6;
      for(i=0;i<6;i++)wbuf[16+i]=cp->mac.mcast2[i];
      nwbuf+=6;
      for(i=0;i<6;i++)wbuf[22+i]=cp->mac.mcast3[i];
      nwbuf+=6;
      for(i=0;i<6;i++)wbuf[28+i]=cp->mac.dflt_srv[i];
      nwbuf+=6;
      break;
    default:
      printf("illeagal MAC ID\n");
      err=-1;
      break;
  }
  if(err!=0){
    return(err);
  }
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return(n);
}

int read_macs_dir(char **dpp)
{
  int n,numwrds;
  enum pkt_t ptyp;
  wbuf[0]=0x20;
  wbuf[1]=Read_MACs_Dir;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  ptyp = rbuf[PKT_TYP_OFF]&0xff;
  if(ptyp>=INFO_PKT){
    dcode_msg_pkt(rbuf);
    return(-(((rbuf[22]&0xFF)<<8)|(rbuf[23]&0xFF)));
  }
  numwrds = ((rbuf[20]&0xff)<<8)|(rbuf[21]&0xff);
  *dpp = &rbuf[22];
  return(numwrds);
}

CNFG_ptr read_macs_dcd()
{
  int i,n;
  enum pkt_t ptyp;
  CNFG_ptr cp;
  wbuf[0]=0x20;
  wbuf[1]=Read_MACs_Dcd;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  ptyp = rbuf[PKT_TYP_OFF]&0xff;
  if(ptyp>=INFO_PKT){
    dcode_msg_pkt(rbuf);
    return((CNFG_ptr)(-(((rbuf[22]&0xFF)<<8)|(rbuf[23]&0xFF))));
  }
  cp=(CNFG_ptr)malloc(sizeof(CNFG_t));
  for(i=0;i<6;i++)cp->mac.device[i] = rbuf[22+i];
  for(i=0;i<6;i++)cp->mac.mcast1[i] = rbuf[28+i];
  for(i=0;i<6;i++)cp->mac.mcast2[i] = rbuf[34+i];
  for(i=0;i<6;i++)cp->mac.mcast3[i] = rbuf[40+i];
  for(i=0;i<6;i++)cp->mac.dflt_srv[i] = rbuf[46+i];
  return(cp);
}


// wrt_crs the way I intend to do it
// as of Firmware revision 3.40 the command Wrt_CR_ID
// uses the CR_ID to specify the target register.
// The old implementation of individual commands for each
// register is still implemented.
//

int wrt_crs(enum CR_ID crid, CNFG_ptr cp)
{
  int i,n,l,lcnt,err;
  err=0;
  wbuf[0]=0x00;
  wbuf[1]=Wrt_CR_ID;
  wbuf[2]=0x00;
  wbuf[3]=crid;
  nwbuf=4;
  switch(crid){
    case ETHER:
      wbuf[4]=((cp->ether)>>8)&0xFF;
      wbuf[5]=(cp->ether)&0xFF;
      nwbuf+=2;
      break;
    case EXTFIFO:
      wbuf[4]=((cp->ext_fifo)>>8)&0xFF;
      wbuf[5]=(cp->ext_fifo)&0xFF;
      nwbuf+=2;
      break;
    case RESET:
      wbuf[4]=((cp->reset)>>8)&0xFF;
      wbuf[5]=(cp->reset)&0xFF;
      nwbuf+=2;
      break;
    case VME:
      wbuf[4]=((cp->vme)>>24)&0xFF;
      wbuf[5]=((cp->vme)>>16)&0xFF;
      wbuf[6]=((cp->vme)>>8)&0xFF;
      wbuf[7]=(cp->vme)&0xFF;
      nwbuf+=4;
      break;
    case BTO:
      wbuf[4]=((cp->vme_bto)>>8)&0xFF;
      wbuf[5]=(cp->vme_bto)&0xFF;
      nwbuf+=2;
      break;
    case BGTO:
      wbuf[4]=((cp->vme_bgto)>>8)&0xFF;
      wbuf[5]=(cp->vme_bgto)&0xFF;
      nwbuf+=2;
      break;
    case ALL_CRS:
      wbuf[4]=((cp->ether)>>8)&0xFF;
      wbuf[5]=(cp->ether)&0xFF;
      wbuf[6]=((cp->ext_fifo)>>8)&0xFF;
      wbuf[7]=(cp->ext_fifo)&0xFF;
      wbuf[8]=((cp->reset)>>8)&0xFF;
      wbuf[9]=(cp->reset)&0xFF;
      wbuf[10]=((cp->vme)>>24)&0xFF;
      wbuf[11]=((cp->vme)>>16)&0xFF;
      wbuf[12]=((cp->vme)>>8)&0xFF;
      wbuf[13]=(cp->vme)&0xFF;
      wbuf[14]=((cp->vme_bto)>>8)&0xFF;
      wbuf[15]=(cp->vme_bto)&0xFF;
      wbuf[16]=((cp->vme_bgto)>>8)&0xFF;
      wbuf[17]=(cp->vme_bgto)&0xFF;
      nwbuf+=14;
      break;
    default:
      printf("illeagal CR ID\n");
      err=-1;
      break;
  }
  if(err!=0){
    return(err);
  }
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return(n);
}



// wrt_crs the way it was implemented originally.
// (which still should work)
/*
int wrt_crs(enum CR_ID crid, CNFG_ptr cp)
{
  int i,n,l,lcnt,err;
  err=0;
  wbuf[0]=0x00;
  nwbuf=2;
  switch(crid){
    case ETHER:
      wbuf[1]=Wrt_Eth_CR;
      wbuf[2]=((cp->ether)>>8)&0xFF;
      wbuf[3]=(cp->ether)&0xFF;
      nwbuf+=2;
      break;
    case EXTFIFO:
      wbuf[1]=Wrt_Ext_CR;
      wbuf[2]=((cp->ext_fifo)>>8)&0xFF;
      wbuf[3]=(cp->ext_fifo)&0xFF;
      nwbuf+=2;
      break;
    case RESET:
      wbuf[1]=Wrt_Rst_CR;
      wbuf[2]=((cp->reset)>>8)&0xFF;
      wbuf[3]=(cp->reset)&0xFF;
      nwbuf+=2;
      break;
    case VME:
      wbuf[1]=Wrt_VME_CR;
      wbuf[2]=((cp->vme)>>24)&0xFF;
      wbuf[3]=((cp->vme)>>16)&0xFF;
      wbuf[4]=((cp->vme)>>8)&0xFF;
      wbuf[5]=(cp->vme)&0xFF;
      nwbuf+=4;
      break;
    case BTO:
      wbuf[1]=Wrt_BTO_CR;
      wbuf[2]=((cp->vme_bto)>>8)&0xFF;
      wbuf[3]=(cp->vme_bto)&0xFF;
      nwbuf+=2;
      break;
    case BGTO:
      wbuf[1]=Wrt_BGTO_CR;
      wbuf[2]=((cp->vme_bgto)>>8)&0xFF;
      wbuf[3]=(cp->vme_bgto)&0xFF;
      nwbuf+=2;
      break;
    case ALL_CRS:
      wbuf[1]=Wrt_All_CRs;
      wbuf[2]=((cp->ether)>>8)&0xFF;
      wbuf[3]=(cp->ether)&0xFF;
      wbuf[4]=((cp->ext_fifo)>>8)&0xFF;
      wbuf[5]=(cp->ext_fifo)&0xFF;
      wbuf[6]=((cp->reset)>>8)&0xFF;
      wbuf[7]=(cp->reset)&0xFF;
      wbuf[8]=((cp->vme)>>24)&0xFF;
      wbuf[9]=((cp->vme)>>16)&0xFF;
      wbuf[10]=((cp->vme)>>8)&0xFF;
      wbuf[11]=(cp->vme)&0xFF;
      wbuf[12]=((cp->vme_bto)>>8)&0xFF;
      wbuf[13]=(cp->vme_bto)&0xFF;
      wbuf[14]=((cp->vme_bgto)>>8)&0xFF;
      wbuf[15]=(cp->vme_bgto)&0xFF;
      nwbuf+=14;
      break;
    default:
      printf("illeagal CR ID\n");
      err=-1;
      break;
  }
  if(err!=0){
    return(err);
  }
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return(n);
}
*/


int set_clr_bits(enum SET_CLR sc, enum CR_ID crid, unsigned int mask)
{
  int i,n,l,lcnt,err;
  err=0;
  wbuf[0]=0x00;
  wbuf[1]=Set_Clr_CRs;
  wbuf[2]=sc;
  wbuf[3]=crid;
  nwbuf=4;
  switch(crid){
    case ETHER: case EXTFIFO: case RESET: case BTO: case BGTO:
      wbuf[4]=(mask>>8)&0xFF;
      wbuf[5]=mask&0xFF;
      nwbuf+=2;
      break;
    case VME:
      wbuf[4]=(mask>>24)&0xFF;
      wbuf[5]=(mask>>16)&0xFF;
      wbuf[6]=(mask>>8)&0xFF;
      wbuf[7]=(mask)&0xFF;
      nwbuf+=4;
      break;
    default:
      printf("illeagal CR ID\n");
      err=-1;
      break;
  }
  if(err!=0){
    return(err);
  }
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return(n);
}

int wrt_ser_num(int ser_num)
{
  int n,l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Wrt_Ser_Num;
  wbuf[2]=0x00;
  wbuf[3]=(ser_num>>16)&0xFF;
  wbuf[4]=(ser_num>>8)&0xFF;
  wbuf[5]=ser_num&0xFF;
  nwbuf=6;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return(n);
}

SN_t rd_ser_num()
{
  int i,n;
  enum pkt_t ptyp;
  SN_t sn;
  sn.status=0;
  sn.err_typ=0;
  sn.sn=0;
  wbuf[0]=0x20;
  wbuf[1]=Rd_Ser_Num;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  if(n<=6){
    sn.status=-1;
  }
  else {
    ptyp = rbuf[PKT_TYP_OFF]&0xff;
    if(ptyp>=INFO_PKT){
      dcode_msg_pkt(rbuf);
      sn.status=-2;
      sn.err_typ=(((rbuf[22]&0xFF)<<8)|(rbuf[23]&0xFF));
    }
    else{
      sn.sn = (int)((signed char)rbuf[23]); // sign extension
      sn.sn = (sn.sn&0xFF000000) | ((rbuf[23]&0xFF)<<16)|((rbuf[24]&0xFF)<<8)|(rbuf[25]&0xFF);
    }
  }
  return sn;
}

void cp_macs(CNFG_ptr to, CNFG_ptr from)
{
  int i;
  for(i=0;i<6;i++)to->mac.device[i]=from->mac.device[i];
  for(i=0;i<6;i++)to->mac.mcast1[i]=from->mac.mcast1[i];
  for(i=0;i<6;i++)to->mac.mcast2[i]=from->mac.mcast2[i];
  for(i=0;i<6;i++)to->mac.mcast3[i]=from->mac.mcast3[i];
  for(i=0;i<6;i++)to->mac.dflt_srv[i]=from->mac.dflt_srv[i];
  return;
}
void cp_crs(CNFG_ptr to, CNFG_ptr from)
{
  int i;
  to->ether    = from->ether;
  to->ext_fifo = from->ext_fifo;
  to->reset    = from->reset;
  to->vme      = from->vme;
  to->vme_bto  = from->vme_bto;
  to->vme_bgto = from->vme_bgto;
  return;
}

void cp_cnfg(CNFG_ptr to, CNFG_ptr from)
{
  cp_macs(to, from);
  cp_crs(to, from);
  return;
}

int cmp_macs(CNFG_ptr exp, CNFG_ptr rbk)
{
  int i,err;
  err=0;
  for(i=0;i<6;i++)if(rbk->mac.device[i]!=exp->mac.device[i])err++;
  for(i=0;i<6;i++)if(rbk->mac.mcast1[i]!=exp->mac.mcast1[i])err++;
  for(i=0;i<6;i++)if(rbk->mac.mcast2[i]!=exp->mac.mcast2[i])err++;
  for(i=0;i<6;i++)if(rbk->mac.mcast3[i]!=exp->mac.mcast3[i])err++;
  for(i=0;i<6;i++)if(rbk->mac.dflt_srv[i]!=exp->mac.dflt_srv[i])err++;
  return err;
}
int cmp_crs(CNFG_ptr exp, CNFG_ptr rbk)
{
  int i,err;
  err=0;
  if(rbk->ether    != exp->ether)err++;
  if(rbk->ext_fifo != exp->ext_fifo)err++;
  if(rbk->reset    != exp->reset)err++;
  // Must mask off auto reset bits before comparison!
  if(rbk->vme != ((exp->vme)&~(VME_CR_UPD_IRQ | VME_CR_FRC_SRST)))err++;
  if(rbk->vme_bto  != exp->vme_bto)err++;
  if(rbk->vme_bgto != exp->vme_bgto)err++;
  return err;
}

int cmp_cnfg(CNFG_ptr exp, CNFG_ptr rbk)
{
  int err;
  err = cmp_macs(exp, rbk);
  err += cmp_crs(exp, rbk);
  return err;
}

void print_macs(CNFG_ptr cp)
{
  int i;
  printf("              MAC address\n---------------------------\n");
  printf("Device:   ");
  for(i=0;i<5;i++)printf("%02X-",cp->mac.device[i]);
  printf("%02X\n",cp->mac.device[5]);
  printf("Mcast1:   ");
  for(i=0;i<5;i++)printf("%02X-",cp->mac.mcast1[i]);
  printf("%02X\n",cp->mac.mcast1[5]);
  printf("Mcast2:   ");
  for(i=0;i<5;i++)printf("%02X-",cp->mac.mcast2[i]);
  printf("%02X\n",cp->mac.mcast2[5]);
  printf("Mcast3:   ");
  for(i=0;i<5;i++)printf("%02X-",cp->mac.mcast3[i]);
  printf("%02X\n",cp->mac.mcast3[5]);
  printf("Dflt_Srv: ");
  for(i=0;i<5;i++)printf("%02X-",cp->mac.dflt_srv[i]);
  printf("%02X\n\n",cp->mac.dflt_srv[5]);
  return;
}
void print_crs(CNFG_ptr cp)
{
  printf("           Config Registers\n---------------------------\n");
  printf("Ether:       %04hX\n",cp->ether);
  printf("Ext_FIFO:    %04hX\n",cp->ext_fifo);
  printf("Reset:       %04hX\n",cp->reset);
  printf("VME:     %08X\n",cp->vme);
  printf("VME_BTO:     %04hX\n",cp->vme_bto);
  printf("VME_BGTO:    %04hX\n\n",cp->vme_bgto);
  return;
}
void print_cnfg(CNFG_ptr cp)
{
  print_macs(cp);
  print_crs(cp);
  return;
}

void log_mac_diffs(CNFG_ptr cp1, CNFG_ptr cp2)
{
  int i;
  char *fmt;
  char dsh[] = "%02X-"; 
  char nodshnr[] = "%02X"; 
  char nodsh[] = "%02X\n"; 
  fprintf(fplog,"    Device:   ");
  for(i=0;i<6;i++){
    fmt = (i<5)?dsh:nodshnr;
    fprintf(fplog,fmt,cp1->mac.device[i]);
  }
  fprintf(fplog," | ");
  for(i=0;i<6;i++){
    fmt = (i<5)?dsh:nodsh;
    fprintf(fplog,fmt,cp2->mac.device[i]);
  }
  fprintf(fplog,"    Mcast1:   ");
  for(i=0;i<6;i++){
    fmt = (i<5)?dsh:nodshnr;
    fprintf(fplog,fmt,cp1->mac.mcast1[i]);
  }
  fprintf(fplog," | ");
  for(i=0;i<6;i++){
    fmt = (i<5)?dsh:nodsh;
    fprintf(fplog,fmt,cp2->mac.mcast1[i]);
  }
  fprintf(fplog,"    Mcast2:   ");
  for(i=0;i<6;i++){
    fmt = (i<5)?dsh:nodshnr;
    fprintf(fplog,fmt,cp1->mac.mcast2[i]);
  }
  fprintf(fplog," | ");
  for(i=0;i<6;i++){
    fmt = (i<5)?dsh:nodsh;
    fprintf(fplog,fmt,cp2->mac.mcast2[i]);
  }
  fprintf(fplog,"    Mcast3:   ");
  for(i=0;i<6;i++){
    fmt = (i<5)?dsh:nodshnr;
    fprintf(fplog,fmt,cp1->mac.mcast3[i]);
  }
  fprintf(fplog," | ");
  for(i=0;i<6;i++){
    fmt = (i<5)?dsh:nodsh;
    fprintf(fplog,fmt,cp2->mac.mcast3[i]);
  }
  fprintf(fplog,"    Dflt_Srv: ");
  for(i=0;i<6;i++){
    fmt = (i<5)?dsh:nodshnr;
    fprintf(fplog,fmt,cp1->mac.dflt_srv[i]);
  }
  fprintf(fplog," | ");
  for(i=0;i<6;i++){
    fmt = (i<5)?dsh:nodsh;
    fprintf(fplog,fmt,cp2->mac.dflt_srv[i]);
  }
  return;
}
void log_cr_diffs(CNFG_ptr cp1, CNFG_ptr cp2)
{
  fprintf(fplog,"    Ether:                 %04hX",cp1->ether);
  fprintf(fplog," | ");
  fprintf(fplog,"    %04hX\n",cp2->ether);

  fprintf(fplog,"    Ext_FIFO:              %04hX",cp1->ext_fifo);
  fprintf(fplog," | ");
  fprintf(fplog,"    %04hX\n",cp2->ext_fifo);

  fprintf(fplog,"    Reset:                 %04hX",cp1->reset);
  fprintf(fplog," | ");
  fprintf(fplog,"    %04hX\n",cp2->reset);

  fprintf(fplog,"    VME:               %08X",cp1->vme);
  fprintf(fplog," | ");
  fprintf(fplog,"%08X\n",cp2->vme);

  fprintf(fplog,"    VME_BTO:               %04hX",cp1->vme_bto);
  fprintf(fplog," | ");
  fprintf(fplog,"    %04hX\n",cp2->vme_bto);

  fprintf(fplog,"    VME_BGTO:              %04hX",cp1->vme_bgto);
  fprintf(fplog," | ");
  fprintf(fplog,"    %04hX\n\n",cp2->vme_bgto);
  return;
}
void log_cnfg_diffs(CNFG_ptr cp1, CNFG_ptr cp2)
{
  log_mac_diffs(cp1,cp2);
  log_cr_diffs(cp1,cp2);
  return;
}
