#ifndef HAVE_CODES
#define HAVE_CODES
struct ucw {
  int code;
  char *type;
  char *mnem;
  char *msg;
};
struct ak_st {
  char *mnem;
  char *status;
};

extern struct ucw ucwtab[];
extern struct ucw foptab[];
extern struct ucw pkttab[];
extern struct ak_st ak_status[];

extern int nerrcodes;
extern int nopcodes;
extern int npktcodes;


// Universal Message Code Words

#define G_No_Info       0x000
#define CP_Un_Asgn      0x001
#define CP_Not_Def      0x002
#define CP_No_Data      0x003
#define CP_Not_Exec     0x004
#define VD_Dat_WtErr    0x100
#define VD_Dat_AF       0x101
#define VD_Hdr_WtErr    0x102
#define VD_Hdr_AF       0x103
#define VC_Unkn_Addr    0x110
#define VC_Unkn_Dly     0x111
#define VC_Incomp_Opt   0x112
#define VC_RdEr_Units   0x113
#define VC_RdEr_CtrlWrd 0x114
#define VC_RdEr_Addr    0x115
#define VC_RdEr_Dcnt    0x116
#define VC_RdEr_Data    0x117
#define VC_MTEr_Fifo    0x118
#define VM_BERR_Slv     0x120
#define VM_BTO          0x121
#define VM_Not_Sup      0x122
#define VR_Mis_SOP      0x130
#define VR_Wrng_Typ     0x131
#define VR_Rd_TMO       0x132
#define VI_BERR_Slv     0x140
#define VI_BTO          0x141
#define VI_Msk_Chg      0x142
#define VA_BGTO         0x161
#define EF_Rd_Err       0x200
#define EF_MT_Err       0x201
#define EF_Rt_Err       0x202
#define EF_Mk_Err       0x203
#define EF_Wrt_Err      0x204
#define EF_FF_PAF       0x205
#define EF_V_wrt_Wrn    0x206
#define EF_Rd_V_Err     0x207
#define EF_Mltp_Err     0x208
#define EF_Wrt_Wrn      0x209
#define EF_MHAF_Wrn     0x20A
#define EF_Drp_Err      0x20B
#define EF_MHAMT_Inf    0x20C
#define EF_AMT_Inf      0x20D
#define ER_Rcv_Err      0x210
#define JT_Buf_AF       0x230
#define JT_Buf_Ovfl     0x231
#define JT_Buf_AMT      0x232
#define JT_Buf_RdErr    0x233
#define JT_Unk_Cmd      0x234
#define JT_Ver_Fail     0x235
#define JT_Prg_Fail     0x236
#define FL_In_AF        0x240
#define FL_In_WtErr     0x241
#define FL_In_RdErr     0x242
#define FL_TRDS_WtErr   0x243
#define FL_TRDS_RdErr   0x244
#define FL_PgRd_WtErr   0x245
#define FL_PgRd_RdErr   0x246
#define FL_ADFF_WtErr   0x247
#define FL_ADFF_RdErr   0x248
#define CF_Mltp_Flsh    0x250
#define CF_Crptd_Dat    0x251
#define CF_Bit_Errs     0x252
#define RH_xxx_xxx      0x260
#define SS_Rld_Pndg     0x270
#define SS_Sys_Up       0x271

// Function Op Code Words

#define        Funct_NoOp 0x00
#define       Set_FF_Test 0x01
#define        Set_FF_VME 0x02
#define        ECC_enable 0x03
#define       ECC_disable 0x04
#define     Save_Cnfg_Num 0x05
#define Read_Cnfg_Num_Dir 0x06
#define Read_Cnfg_Num_Dcd 0x07
#define     Rstr_Cnfg_Num 0x08
#define     Set_Cnfg_Dflt 0x09
#define    Read_Cnfg_Dflt 0x0A
#define          Set_MACs 0x0B
#define     Read_MACs_Dir 0x0C
#define     Read_MACs_Dcd 0x0D
#define          Read_CRs 0x0E
#define        Wrt_Eth_CR 0x0F
#define        Wrt_Ext_CR 0x10
#define        Wrt_Rst_CR 0x11
#define        Wrt_VME_CR 0x12
#define        Wrt_BTO_CR 0x13
#define       Wrt_BGTO_CR 0x14
#define       Wrt_All_CRs 0x15
#define       Set_Clr_CRs 0x16
#define       Set_Inj_Err 0x17
#define       Rst_Inj_Err 0x18
#define     Warn_On_Shdwn 0x19
#define  No_Warn_On_Shdwn 0x1A
#define   Snd_Startup_Pkt 0x1B
#define    No_Startup_Pkt 0x1C
#define       Wrt_Ser_Num 0x1D
#define        Rd_Ser_Num 0x1E
#define         Wrt_CR_ID 0x1F
#define          VME_Cmds 0x20
#define      VME_Dir_Cmds 0x22
#define         Rd_Dev_ID 0x30
#define      Rd_User_Code 0x31
#define      Rd_Cust_Code 0x32
#define      Rd_Back_PROM 0x33
#define        Erase_PROM 0x34
#define      Program_PROM 0x35
#define       Reload_FPGA 0x36
#define       Verify_PROM 0x37
#define     Chk_JTAG_Conn 0x38
#define      Exec_Routine 0x39
#define  Ld_Rtn_Base_Addr 0x3A
#define     Module_Status 0x3B
#define   Write_JTAG_FIFO 0x3C
#define   Write_Prg_Space 0x3D
#define    Read_Prg_Space 0x3E
#define  Abort_JTAG_Cmnds 0x3F
#define         Flash_R_W 0x40
#define        Wrt_Ext_FF 0xE0
#define       Prg_Ext_Off 0xE1
#define      Rdbk_Ext_Off 0xE2
#define       PRst_Ext_FF 0xE3
#define         Rd_Ext_FF 0xE4
#define         RT_Ext_FF 0xE5
#define       MRst_Ext_FF 0xE6
#define      ST_MK_Ext_FF 0xE7
#define     RST_MK_Ext_FF 0xE8
#define   Rst_Ext_Err_Cnt 0xE9
#define   Rd_Ext_Err_Cnts 0xEA
#define       Flush_2_BOD 0xEF
#define        Rst_Seq_ID 0xF0
#define          Gen_Intr 0xF7 //for slave configuration only
#define      Gen_Hard_Rst 0xF8 //for slave configuration only
#define      Force_Reload 0xF9
#define      Send_N_Words 0xFD
#define     Load_User_Reg 0xFE
#define          Loopback 0xFF

// Return Packet Data Type Code Words
// are defined in an enum in pkt_info.h

extern char *dcode_msg_pkt(char *);
extern void *ptr_bin_srch(int, struct ucw *, int);
extern struct rspn_t flush_pkts();

#endif
