#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h> 
#include <netinet/if_ether.h> 
#include <netinet/in.h> 
#include <netinet/ip.h> 
#include <net/if.h> 
#include <sys/ioctl.h> 
#include <netpacket/packet.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include "eth.h"

int  eth_open();
void eth_get_src_mac();
int  eth_register_mac(unsigned char *mac);
void eth_close(void);
int  eth_reset(void);
int  eth_read(int count,char *buf);
int  eth_write();
/*  int  eth_enableblock(void); */
/*  int  eth_disableblock(void); */
int  eth_read_timeout(int rd_tmo);

extern unsigned char wbuf[];
extern int nwbuf;
extern int cur_mac;
extern int nmacs;
extern unsigned char rbuf[];
extern int nrbuf;

unsigned char ebuf[MAX_EBUF_SIZE];
struct ethhdr *ether_header[NMAX_MACS];
unsigned char hw_source_addr[ETH_ALEN]; 

/*  unsigned char fake [ETH_ALEN] = {0x22,0x22,0x33,0x33,0x44,0x44}; */
/*  unsigned char src_1[ETH_ALEN] = {0xAA,0xAA,0xBB,0xBB,0xCC,0xCC}; */
/*  unsigned char src_2[ETH_ALEN] = {0x66,0x66,0x77,0x77,0x88,0x88}; */

static int fd_schar;

#ifdef SIM_OUTPUT
static  FILE *smfp;
#endif

int eth_open()
{
#ifdef SIM_OUTPUT
  smfp=fopen("sim_out.hex","w");
#endif
  fd_schar = open("/dev/schar", O_RDWR);
  if (fd_schar == -1) {
    perror("open");
    return 1;
  }
  eth_read_timeout(RD_TMO_short);
  eth_get_src_mac();
}


void eth_get_src_mac()
{
  FILE *fp;
  int  i,n;
  char eth[] = ETH_DEV_NUM;
  unsigned int a[6];
  char mesg[60];
  char *fmt;
  char dsh[] = "%02X-"; 
  char nodsh[] = "%02X\n"; 

  sprintf(mesg,"/sbin/ifconfig %s > macadd",eth);
  system(mesg); 
  fp=fopen("macadd","r");
  fscanf(fp,"eth%*1d      Link encap:Ethernet  HWaddr %02x:%02x:%02x:%02x:%02x:%02x  \n",&a[0],&a[1],&a[2],&a[3],&a[4],&a[5]);
  for(i=0;i<6;i++){
    hw_source_addr[i]=a[i]&0xFF;
  }
  fclose(fp);
  printf("                 Source: ");
  for(i=0;i<6;i++){
    fmt = (i<5)?dsh:nodsh;
    printf(fmt,hw_source_addr[i]&0xff);
  }
  nmacs=0;
}

int eth_register_mac(unsigned char *mac)
{
  int  i,mac_idx;
  char *fmt;
  char dsh[] = "%02X-"; 
  char nodsh[] = "%02X\n";
  mac_idx = nmacs++; 
  if((ether_header[mac_idx]=(struct ethhdr *)malloc(sizeof(struct ethhdr)))==0){
    printf("Could not register MAC address: Allocation error\n");
    return -1;
  }
  memcpy(ether_header[mac_idx]->h_dest, mac, ETH_ALEN);
  memcpy(ether_header[mac_idx]->h_source,hw_source_addr, ETH_ALEN);
/*    memcpy(ether_header[mac_idx]->h_source,fake, ETH_ALEN); */
  printf("Registered Dest. MAC %2d: ",mac_idx);
  for(i=0;i<6;i++){
    fmt = (i<5)?dsh:nodsh;
    printf(fmt,ether_header[mac_idx]->h_dest[i]&0xff);
  }
/*    mac_idx = nmacs++;  */
/*    if((ether_header[mac_idx]=(struct ethhdr *)malloc(sizeof(struct ethhdr)))==0){ */
/*      printf("Could not register MAC address: Allocation error\n"); */
/*      return -1; */
/*    } */
/*    memcpy(ether_header[mac_idx]->h_dest, mac, ETH_ALEN); */
/*    memcpy(ether_header[mac_idx]->h_source,src_1, ETH_ALEN); */
/*    mac_idx = nmacs++;  */
/*    if((ether_header[mac_idx]=(struct ethhdr *)malloc(sizeof(struct ethhdr)))==0){ */
/*      printf("Could not register MAC address: Allocation error\n"); */
/*      return -1; */
/*    } */
/*    memcpy(ether_header[mac_idx]->h_dest, mac, ETH_ALEN); */
/*    memcpy(ether_header[mac_idx]->h_source,src_2, ETH_ALEN); */
/*    return mac_idx-2; */
  return mac_idx;
}

int eth_reset(void)
{ 
  if(ioctl(fd_schar,SCHAR_RESET)==-1){
    printf(" error in SCHAR_RESET \n");
  }

  return 0;
}

int eth_read(int count,char *buf)
{
int err;
int size;
int loopcnt;
 
 loopcnt=0;
 size=0;
 GETMORE: 
        size=read(fd_schar,rbuf,nrbuf);
        if(size<0)return size;
        if(size<7){
           if(rbuf[0]==0x03&&loopcnt<100){usleep(100);loopcnt=loopcnt+1;goto GETMORE;}
        }
   return size;
}


int eth_write()
{
  int pkt_size,pkt_stp;
  int i;
  //  check for registered MAC address
  if(cur_mac<0 || cur_mac >= nmacs){
    printf("Your using an unregister MAC address\n");
    return -99;
  }
  //Creating the packet
  ether_header[cur_mac]->h_proto = htons(nwbuf);
  pkt_size = ETH_HLEN + nwbuf;
  memcpy(ebuf, ether_header[cur_mac], ETH_HLEN);
  memcpy(ebuf+ETH_HLEN, wbuf, nwbuf);
#ifdef SIM_OUTPUT
#ifdef SIM_TRUNK_MAX
  pkt_stp = SIM_TRUNK_MAX;
#else
  pkt_stp = pkt_size;
#endif
  for(i=0;i<pkt_size&&i<pkt_stp;i++)fprintf(smfp,"%02X",ebuf[i]&0xff);
#ifdef SIM_TRUNK_MAX
  if(i== SIM_TRUNK_MAX)  fprintf(smfp,"...");
#endif
  fprintf(smfp,"\n");
  fflush(smfp);
#endif
  return write(fd_schar, (const void *)ebuf, pkt_size);
}


void eth_close(void)
{
  int i;
#ifdef SIM_OUTPUT
  fclose(smfp);
#endif
  for(i=0;i<nmacs;i++){
    free(ether_header[i]);
  }
  close(fd_schar);
}

/*
int eth_enableblock(void)
{
  if(ioctl(fd_schar,SCHAR_BLOCKON)==-1){
    printf(" error in SCHAR_BLOCKON \n");
  }
  return 0;
}

int eth_disableblock(void)
{
  if(ioctl(fd_schar,SCHAR_BLOCKOFF)==-1){
    printf(" error in SCHAR_BLOCKOFF \n");
  }

  return 0;
}
*/
int eth_read_timeout(int rd_tmo)
{
  if(ioctl(fd_schar,SCHAR_READ_TIMEOUT,rd_tmo)==-1){
    printf(" error in SCHAR_READ_TIMEOUT \n");
  }
  return 0;
}
