#include <stdio.h>
struct ucw {
  int code;
  char *type;
  char *mnem;
  char *msg;
};
struct ak_st {
  char *mnem;
  char *status;
};

extern struct ucw ucwtab[];
extern struct ucw foptab[];
extern struct ucw pkttab[];
extern struct ak_st ak_status[];

#include "codes_ini.h"

main()
{
  int i;
  FILE *fp;
  fp=fopen("codes.h","w");
  fprintf(fp,"#ifndef HAVE_CODES\n");
  fprintf(fp,"#define HAVE_CODES\n");
  fprintf(fp,"struct ucw {\n  int code;\n  char *type;\n  char *mnem;\n");
  fprintf(fp,"  char *msg;\n};\nstruct ak_st {\n  char *mnem;\n");
  fprintf(fp,"  char *status;\n};\n\n");
  fprintf(fp,"extern struct ucw ucwtab[];\n");
  fprintf(fp,"extern struct ucw foptab[];\n");
  fprintf(fp,"extern struct ucw pkttab[];\n");
  fprintf(fp,"extern struct ak_st ak_status[];\n\n");
  fprintf(fp,"extern int nerrcodes;\n");
  fprintf(fp,"extern int nopcodes;\n");
  fprintf(fp,"extern int npktcodes;\n\n");
  fprintf(fp,"\n// Universal Message Code Words\n\n");
  for(i=0;i<NERRCODES;i++){
    printf("%4s: 0x%03X: %-20s: %s\n",ucwtab[i].type,ucwtab[i].code,ucwtab[i].mnem,ucwtab[i].msg);
    fprintf(fp,"#define %-15s 0x%03X\n",ucwtab[i].mnem,ucwtab[i].code);
  }
  fprintf(fp,"\n// Function Op Code Words\n\n");
  for(i=0;i<NOPCODES;i++){
    if(strcmp(foptab[i].mnem,"Gen_Intr")==0 || strcmp(foptab[i].mnem,"Gen_Hard_Rst")==0){
      printf("%6s:  0x%02X: %-17s: %s //for slave configuration only\n",foptab[i].type,foptab[i].code,foptab[i].mnem,foptab[i].msg);
      fprintf(fp,"#define %17s 0x%02X //for slave configuration only\n",foptab[i].mnem,foptab[i].code);
    }
    else { 
      printf("%6s:  0x%02X: %-17s: %s\n",foptab[i].type,foptab[i].code,foptab[i].mnem,foptab[i].msg);
      fprintf(fp,"#define %17s 0x%02X\n",foptab[i].mnem,foptab[i].code);
    }
  }
  fprintf(fp,"\n// Return Packet Data Type Code Words\n");
  fprintf(fp,"// are defined in an enum in pkt_info.h\n");
  fprintf(fp,"\n#endif\n");
  fclose(fp);
}
