#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "eth.h"
#include "jtag_defs.h"
#include "jtag_instr.h"
#include "codes.h"
#include "pkt_info.h"


extern char *wbuf;
extern int nwbuf;
extern char rbuf[];
extern int nrbuf;



JINSTR_t rbk_prg[512];

void jtag_init()
{
  int i,n;
  enum JRTN_ID rtn;
  JINSTR_t *jrtn;
  //  for(rtn=JC_Rd_DevID; rtn<=JC_Chk_Conn; rtn++){
  for(rtn=JC_Rd_DevID; rtn<=JC_User; rtn++){
    ld_rtn_base_addr(jtr[rtn].base);
    wbuf[0]=0x00;
    wbuf[1]=Write_Prg_Space;
    nwbuf=2;
    for(i=0;i<jtr[rtn].n;i++){
      jrtn = jtr[rtn].rtn+i;
      wbuf[nwbuf]=((jrtn->instr)>>8)&0xFF;
      wbuf[nwbuf+1]=(jrtn->instr)&0xFF;
      wbuf[nwbuf+2]=((jrtn->bc)>>8)&0xFF;
      wbuf[nwbuf+3]=(jrtn->bc)&0xFF;
      wbuf[nwbuf+4]=((jrtn->data)>>8)&0xFF;
      wbuf[nwbuf+5]=(jrtn->data)&0xFF;
      nwbuf+=6;
    }
    n=eth_write();
  }
}
unsigned int read_dev_id()
{
  int n;
  unsigned int dev_id;
  enum pkt_t ptyp;
  wbuf[0]=0x00;
  wbuf[1]=Rd_Dev_ID;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  ptyp = rbuf[PKT_TYP_OFF]&0xff;
  if(ptyp>=INFO_PKT){
    printf("%s",dcode_msg_pkt(rbuf));
    return 0;
  }
  dev_id = ((rbuf[DATA_OFF+2]&0xff)<<24)|((rbuf[DATA_OFF+3]&0xff)<<16)|((rbuf[DATA_OFF]&0xff)<<8)|(rbuf[DATA_OFF+1]&0xff);
  return dev_id;
}
unsigned int read_user_code()
{
  int n;
  unsigned int user_code;
  enum pkt_t ptyp;
  wbuf[0]=0x00;
  wbuf[1]=Rd_User_Code;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  ptyp = rbuf[PKT_TYP_OFF]&0xff;
  if(ptyp>=INFO_PKT){
    printf("%s",dcode_msg_pkt(rbuf));
    return 0;
  }
  user_code = ((rbuf[DATA_OFF+2]&0xff)<<24)|((rbuf[DATA_OFF+3]&0xff)<<16)|((rbuf[DATA_OFF]&0xff)<<8)|(rbuf[DATA_OFF+1]&0xff);
  return user_code;
}
char *read_customer_code()
{
  int i,n;
  enum pkt_t ptyp;
  wbuf[0]=0x00;
  wbuf[1]=Rd_Cust_Code;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  if(n>6){
    ptyp = rbuf[PKT_TYP_OFF]&0xff;
    if(ptyp>=INFO_PKT){
      printf("%s",dcode_msg_pkt(rbuf));
      return 0;
    }
/*      for(i=DATA_OFF;i<n;i++){ */
/*        printf("%02X",rbuf[i]&0xFF); */
/*      } */
/*      printf("\n"); */
    return &rbuf[DATA_OFF];
  }
  else {
    printf("no response\n");
    return 0;
  }
}
int erase_prom()
{
  int n,rslt;
  enum pkt_t ptyp;
  //Return value:
  //  1: Successful completion of erase 
  //  0: No response after sending erase command 
  // -1: Unsuccessful erasure 
  eth_read_timeout(RD_TMO_xlong);
  wbuf[0]=0x20;
  wbuf[1]=Erase_PROM;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  if(n>6){
    ptyp = rbuf[PKT_TYP_OFF]&0xff;
    if(ptyp>=INFO_PKT){
      printf("%s",dcode_msg_pkt(rbuf));
      rslt = 0;
    }
    if(AK_STATUS(rbuf) == CC_S){
      rslt = 1;
    }else{
      eth_read_timeout(RD_TMO_short);
      n=eth_read();
      if(n>6){
	ptyp = rbuf[PKT_TYP_OFF]&0xff;
	if(ptyp>=INFO_PKT){
          printf("%s",dcode_msg_pkt(rbuf));
	}
      }
      rslt = -1;
    }
  }else{
    printf("No Response after Erase_PROM command\n");
    rslt = 0;
  }
  eth_read_timeout(RD_TMO_short);
  return rslt;
}
int erase_prom_bcast()
{
  int n,rslt;

  //Return value:
  //  1: Successful completion of erase 
  //  0: No response after sending erase command 
  // -1: Unsuccessful erasure 
  wbuf[0]=0x00;
  wbuf[1]=Erase_PROM;
  nwbuf=2;
  n=eth_write();
  sleep(15);
  return 1;
}
int chk_jtag_conn()
{
  int n,rslt;
  enum pkt_t ptyp;
  //Return value:
  //  1: Successful connection made 
  //  0: No response after sending check connection command 
  // -1: Problem with JTAG connection
  eth_read_timeout(RD_TMO_long);
  wbuf[0]=0x20;
  wbuf[1]=Chk_JTAG_Conn;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  if(n>6){
    ptyp = rbuf[PKT_TYP_OFF]&0xff;
    if(ptyp>=INFO_PKT){
      printf("%s",dcode_msg_pkt(rbuf));
      rslt = 0;
    }
    if(AK_STATUS(rbuf) == CC_S){
      rslt = 1;
    }else{
      eth_read_timeout(RD_TMO_short);
      n=eth_read();
      if(n>6){
	ptyp = rbuf[PKT_TYP_OFF]&0xff;
	if(ptyp>=INFO_PKT){
          printf("%s",dcode_msg_pkt(rbuf));
	}
      }
      rslt = -1;
    }
  }else{
    printf("No Response after Chk_JTAG_Conn command\n");
    rslt = 0;
  }
  eth_read_timeout(RD_TMO_short);
  return rslt;
}
void program_prom_cmd()
{
  int n;
  wbuf[0]=0x20;
  wbuf[1]=Program_PROM;
  nwbuf=2;
  n=eth_write();
}
void program_prom_cmd_no_ack()
{
  int n;
  wbuf[0]=0x00;
  wbuf[1]=Program_PROM;
  nwbuf=2;
  n=eth_write();
}
void reload_fpga()
{
  int n;
  enum pkt_t ptyp;
  wbuf[0]=0x00;
  wbuf[1]=Reload_FPGA;
  nwbuf=2;
  n=eth_write();
  while((n=eth_read())>6){
    ptyp = rbuf[PKT_TYP_OFF]&0xff;
    if(ptyp>=INFO_PKT){
      printf("%s",dcode_msg_pkt(rbuf));
    }
  }
}
void verify_prom_cmd()
{
  int n;
  wbuf[0]=0x20;
  wbuf[1]=Verify_PROM;
  nwbuf=2;
  n=eth_write();
}
void ld_rtn_base_addr(unsigned short base)
{
  int n;
  wbuf[0]=0x00;
  wbuf[1]=Ld_Rtn_Base_Addr;
  wbuf[2]=(base>>8)&0xFF;
  wbuf[3]=base &0xFF;
  nwbuf=4;
  n=eth_write();
}
void exec_routine(enum JRTN_ID rtn)
{
  int n;
  wbuf[0]=0x20;
  wbuf[1]=Exec_Routine;
  wbuf[2]=0x00;
  wbuf[3]=(unsigned char) rtn;
  nwbuf=4;
  n=eth_write();
}
unsigned int get_jtag_status()
{
  int n;
  enum pkt_t ptyp;
  unsigned int status;
  wbuf[0]=0x00;
  wbuf[1]=Module_Status;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  ptyp = rbuf[PKT_TYP_OFF]&0xff;
  if(ptyp>=INFO_PKT){
    printf("%s",dcode_msg_pkt(rbuf));
    return 0;
  }
  status = ((rbuf[DATA_OFF]&0xff)<<8)|(rbuf[DATA_OFF+1]&0xff);
  return status;
}
void abort_jtag_cmnds()
{
  int n;
  wbuf[0]=0x00;
  wbuf[1]=Abort_JTAG_Cmnds;
  nwbuf=2;
  n=eth_write();
}

void write_jtag_fifo_words(unsigned short *buf, int nw)
{
  int i,n;
  wbuf[0]=0x00;
  wbuf[1]=Write_JTAG_FIFO;
  nwbuf=2;
  for(i=0; i<nw; i++){
    wbuf[nwbuf]=(buf[i]>>8)&0xFF;
    wbuf[nwbuf+1]=(buf[i])&0xFF;
    nwbuf+=2;
  }
  n=eth_write();
}
void write_jtag_fifo_bytes(unsigned char *buf, int nb)
{
  int i,n;
  wbuf[0]=0x00;
  wbuf[1]=Write_JTAG_FIFO;
  nwbuf=2;
  for(i=0; i<nb; i++){
    wbuf[nwbuf]=(buf[i])&0xFF;
    nwbuf++;
  }
  n=eth_write();
}
int read_prg_space(unsigned short base)
{
  int i,n,nwrds;
  int offset;
  enum pkt_t ptyp;
  ld_rtn_base_addr(base);
  wbuf[0]=0x00;
  wbuf[1]=Read_Prg_Space;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  ptyp = rbuf[PKT_TYP_OFF]&0xff;
  if(ptyp>=INFO_PKT){
    printf("%s",dcode_msg_pkt(rbuf));
    return 0;
  }
  nwrds = DAT_WRD_CNT(rbuf);
  printf("Nwords = %d\n",nwrds);
  for(i=0;i<nwrds/3;i++){
    offset = 6*i+DATA_OFF;
    rbk_prg[i].instr = ((rbuf[offset]&0xff)<<8)|(rbuf[offset+1]&0xff);
    rbk_prg[i].bc    = ((rbuf[offset+2]&0xff)<<8)|(rbuf[offset+3]&0xff);
    rbk_prg[i].data  = ((rbuf[offset+4]&0xff)<<8)|(rbuf[offset+5]&0xff);
  }
  return nwrds/3;
}

void print_routines()
{
  int i,j,n,ninstr;
  enum JRTN_ID rtn;
  char *rtnstr[] = {"Read Device ID", "Read User Code", "Read Customer Code",
                    "Readback PROM", "Erase PROM", "Program PROM", 
                    "Reload FPGA", "Verify PROM", "Check JTAG Connection"};
  FILE *fp;
  fp=fopen("prgmemrbk.dat","w");
  //  for(rtn=JC_Rd_DevID; rtn<=JC_Chk_Conn; rtn++){
  for(rtn=JC_Rd_DevID; rtn<=JC_User; rtn++){
    fprintf(fp,"\nRoutine: %s\n-----------------------------------------\n",rtnstr[rtn]);
    ninstr = read_prg_space(jtr[rtn].base);
    fprintf(fp,"ninstr = %d\n",ninstr);
    fprintf(fp,"Address  Instruction  Bit Count  Data\n");
    fprintf(fp,"--------------------------------------\n");
    for(i=0;i<ninstr;i++){
      fprintf(fp,"  %03X :      %02X        %04hX     %04hX\n",jtr[rtn].base+i,
             rbk_prg[i].instr&0x3F,rbk_prg[i].bc,rbk_prg[i].data);
    }
  }
  fclose(fp);
}
void rd_back_prom()
{
  int i,n,wc,naddr,wcntr,prtd,npkt;
  unsigned int faddr,chksum;
  unsigned short addr[2048];
  enum pkt_t ptyp;
  union {
    unsigned char *cp;
    unsigned short int *shtp;
  } flex_buf;
  FILE *fp;
  fp = fopen("Prom_readback.dat","w");
  naddr = 1024;
  faddr = 0;
  for(i=0;i<naddr;i++){
    addr[2*i] = (1024*i)&0xFFFF;
    addr[2*i+1] = ((1024*i)>>16)&0xFF;
  }
  wbuf[0]=0x00;
  wbuf[1]=Rd_Back_PROM;
  nwbuf=2;
  n=eth_write();
  write_jtag_fifo_words(addr,2*naddr);
  wcntr=0;
  prtd=0;
  npkt=0;
  while((n=eth_read())>6){
    npkt++;
    flex_buf.cp = &rbuf[DATA_OFF];
    wc = DAT_WRD_CNT(rbuf);
    //    printf("Packet no. %d; size %d; word count %d\n",npkt,n,wc);
    ptyp = rbuf[PKT_TYP_OFF]&0xff;
    if(ptyp>=INFO_PKT){
      printf("%s",dcode_msg_pkt(rbuf));
    } else {
      for(i=0;i<wc;i++){
	if(faddr%0x10000==0 && !prtd){
	  chksum = ~((6+((faddr>>24)&0xFF)+((faddr>>16)&0xFF))%256)+1;
	  fprintf(fp,":02000004%04X%02X\r\n",(faddr>>16)&0xFFFF,chksum&0xFF);
          prtd=1;
	}
        if(wcntr%8==0){
          chksum = 16+((faddr>>8)&0xFF)+(faddr&0xFF);
          fprintf(fp,":10%04X00",faddr&0xFFFF);
	}
        chksum = chksum+(flex_buf.cp[2*i]&0xFF)+(flex_buf.cp[2*i+1]&0xFF);
        fprintf(fp,"%04hX",flex_buf.shtp[i]);
        wcntr++;
        if(wcntr!=0 && wcntr%8==0){
          fprintf(fp,"%02X\r\n",(~(chksum%256)+1)&0xFF);
          faddr+=16;
          prtd=0;
	}
      }
    }
  }
  fprintf(fp,":00000001FF\r\n");
  fclose(fp);
}

void read_mcs(char *fn)
{
  char line[1024];
  FILE *fp;
  int i,paddr,lpcnt,parms;
  unsigned int tt,cc;
  unsigned int ddl,ddh;
  unsigned int ll,addr;

  fp = fopen(fn,"r");
  if(fp==NULL){
    printf("Error opening %s\n",fn);
    return;
  }
  paddr = 0;
  lpcnt = 0;
  tt=0;
  while(tt!=1){
    parms = fscanf(fp,":%2x%4x%2x",&ll,&addr,&tt);
    //    printf("%1x:%02X%04X%02X",parms,ll,addr,tt);
    if(tt==0){
      for(i=0;i<ll/2;i++){
        parms = fscanf(fp,"%2x%2x",&ddl,&ddh);
        prm_dat[paddr++] = ((ddh&0xFF)<<8) | (ddl&0xFF);
	//        printf("%5X: %04hX\n",paddr,prm_dat[paddr-1]);
      }
    }
    fgets(line,1024,fp);
    lpcnt++;
    //    printf("%s %d\n",line,lpcnt);
  }
  fclose(fp);
}

void send_ver_prom_data()
{
  int i,j,n,nw,pktnum,nsend,tot_bytes;
  int lp,cdwrd,send,pause,abort;
  int addr,pnum,bi;
  enum pkt_t ptyp;
  enum ack_st ack;
  VERIFY_t ver_dat[147];
  nw = 512;
  send = 1;
  pause = 0;
  abort = 0;
  pktnum = 0;
  lp=0;
  addr = 0;
  nsend = 0;
  pnum =-1;
  for(i=0;i<1024;i++){
    if(i!=0 && i%7==0){
      ver_dat[pnum].nw = bi;
    }
    if(i%7==0){
      ver_dat[++pnum].buf = (unsigned short int *)malloc(2*7*(nw+2));
      bi = 0;
    }
    ver_dat[pnum].buf[bi++] = addr&0xFFFF;
    ver_dat[pnum].buf[bi++] = (addr>>16)&0xFF;
    for(j=0;j<nw;j++){
      ver_dat[pnum].buf[bi++] = prm_dat[nw*i+j];
    }
    addr+=1024;
  }
  ver_dat[pnum].nw = bi;
  tot_bytes = 0;
  while(lp<pnum+1 && !abort){
    if(send){
      nsend++;
      write_jtag_fifo_words(ver_dat[lp].buf, ver_dat[lp].nw);
      tot_bytes+=2*ver_dat[lp++].nw;
      printf("%d: have sent %d bytes\n",nsend,tot_bytes);
      if(nsend%4 == 0){
        pause = 1;
        send  = 0;
        abort = 0;
      }
    }
    if(pause){
      while((n=eth_read())>6){
	pktnum++;
	printf("\n");
	ptyp = rbuf[PKT_TYP_OFF]&0xff;
	if(ptyp>=INFO_PKT){
	  printf("pktnum A%d: %s",pktnum,dcode_msg_pkt(rbuf));
	  cdwrd = UNV_CODE_WRD(rbuf);
	  if(cdwrd==JT_Buf_AF){
	    pause = 1;
	    send = 0;
	    abort = 0;
	  } else if(cdwrd==JT_Buf_AMT){
	    pause = 0;
	    send = 1;
	    abort = 0;
	  } else if((cdwrd==JT_Buf_Ovfl) || (cdwrd==JT_Ver_Fail) || (cdwrd==JT_Buf_RdErr)){
	    pause = 0;
	    send = 0;
	    abort = 1;
	  }
	} else {
	  printf("pktnum A%d:",pktnum);
	  ack = AK_STATUS(rbuf); 
	  switch(ack){
	  case NO_ACK:
	    printf("Non message or no acknowledge packet received\n");
	    break;
	  case CC_S:
	    printf("Verify completed successfully\n");
	    break;
	  case CC_W: case CC_E: case CE_I: case CIP_W: case CIP_E:
	    printf("\aAn error or warning occured verify!\n");
	    break;
	  default:
	    printf("Unknown packet returned\n");
	    break;
	  }
	}
      }
    }
  }
  if(abort){
    abort_jtag_cmnds();
  }
  while((n=eth_read())>6){
    pktnum++;
    ptyp = rbuf[PKT_TYP_OFF]&0xff;
    if(ptyp>=INFO_PKT){
      printf("pktnum B%d: %s",pktnum,dcode_msg_pkt(rbuf));
    } else {
      printf("pktnum B%d:",pktnum);
      ack = AK_STATUS(rbuf); 
      switch(ack){
      case NO_ACK:
	printf("Non message or no acknowledge packet received\n");
	break;
      case CC_S:
	printf("Verify completed successfully\n");
	break;
      case CC_W:
	printf("Verify completed with a warning\n");
	break;
      case CC_E:
	printf("Verify completed with an error\n");
	break;
      case CE_I:
	printf("Verify execution finished incomplete\n");
	break;
      case CIP_W: case CIP_E:
	printf("Command in progress with an error or warning\n");
	break;
      default:
	printf("Unknown packet returned\n");
	break;
      }
    }
  }
  for(i=0;i<pnum+1;i++){
    free(ver_dat[i].buf);
  }
}

void send_prg_prom_data()
{
  int i,j,n,nw,pktnum,nsend,tot_bytes;
  int cdwrd,send,pause,abort;
  enum pkt_t ptyp;
  enum ack_st ack;
  int npus_max = 32768;
  int npus_per_pkt_max = 249;
  int npus,tot_npus;
  send = 1;
  pause = 0;
  abort = 0;
  pktnum = 0;
  nsend = 0;
  tot_npus = 0;
  tot_bytes = 0;
  while(tot_npus<npus_max && !abort){
    if(send){
      nsend++;
      if((npus_max-tot_npus)< npus_per_pkt_max){
        npus = npus_max - tot_npus;
      }else{
        npus = npus_per_pkt_max;
      }
      nw=16*npus;
      write_jtag_fifo_words(&prm_dat[16*tot_npus], nw);
      tot_npus+=npus;
      tot_bytes+=2*nw;
      printf("%d: have sent %d pu's and %d bytes\n",nsend,tot_npus,tot_bytes);
      if(nsend%4 == 0){
        pause = 1;
        send  = 0;
        abort = 0;
      }
    }
    if(pause){
      while((n=eth_read())>6){
	pktnum++;
	printf("\n");
	ptyp = rbuf[PKT_TYP_OFF]&0xff;
	if(ptyp>=INFO_PKT){
	  printf("pktnum A%d: %s",pktnum,dcode_msg_pkt(rbuf));
	  cdwrd = UNV_CODE_WRD(rbuf);
	  if(cdwrd==JT_Buf_AF){
	    pause = 1;
	    send = 0;
	    abort = 0;
	  } else if(cdwrd==JT_Buf_AMT){
	    pause = 0;
	    send = 1;
	    abort = 0;
	  } else if((cdwrd==JT_Buf_Ovfl) || (cdwrd==JT_Ver_Fail) || (cdwrd==JT_Buf_RdErr)){
	    pause = 0;
	    send = 0;
	    abort = 1;
	  }
	} else {
	  printf("pktnum A%d:",pktnum);
	  ack = AK_STATUS(rbuf); 
	  switch(ack){
	  case NO_ACK:
	    printf("Non message or no acknowledge packet received\n");
	    break;
	  case CC_S:
	    printf("Programming completed successfully\n");
	    break;
	  case CC_W: case CC_E: case CE_I: case CIP_W: case CIP_E:
	    printf("\aAn error or warning occured during programming\n");
	    break;
	  default:
	    printf("Unknown packet returned\n");
	    break;
	  }
	}
      }
    }
  }
  if(abort){
    abort_jtag_cmnds();
  }
}
void send_prg_prom_data_bcast()
{
  int i,j,n,nw,nsend,tot_bytes;
  int cdwrd;
  int npus_max = 32768;
  int npus_per_pkt_max = 249;
  int npus,tot_npus;
  nsend = 0;
  tot_npus = 0;
  tot_bytes = 0;
  while(tot_npus<npus_max){
    nsend++;
    if((npus_max-tot_npus)< npus_per_pkt_max){
      npus = npus_max - tot_npus;
    }else{
      npus = npus_per_pkt_max;
    }
    nw=16*npus;
    write_jtag_fifo_words(&prm_dat[16*tot_npus], nw);
    tot_npus+=npus;
    tot_bytes+=2*nw;
    printf("%d: have sent %d pu's and %d bytes\n",nsend,tot_npus,tot_bytes);
    if(nsend%4 == 0){
      usleep(500000);
    }
  }
}
void send_uc_cc_data(char *fn)
{
  int i;
  unsigned int uc,proj,maj_ver,min_ver;
  char cc[33];
  for(i=0;i<33;i++){
    cc[i] = 0;
  }
  strncpy(cc,fn,32);
  sscanf(fn,"%5X.V%1X.%2X.mcs",&proj,&maj_ver,&min_ver);
  printf("proj: %05X\n",proj);
  printf("majv: %01X\n",maj_ver);
  printf("minv: %02X\n",min_ver);
  uc = (proj<<12)|(maj_ver<<8)|(min_ver);
  printf("uc  : %08X\n",uc);
  printf("cc  : %s\n\n",cc);

  write_jtag_fifo_words((unsigned short *)&uc, 2);
/*    printf("user code packet:\n"); */
/*    for(i=0;i<6;i++)printf("%02X",wbuf[i]&0xFF); */
/*    printf("\n"); */

  write_jtag_fifo_words((unsigned short *)&uc, 2);
/*    printf("user code verify packet:\n"); */
/*    for(i=0;i<6;i++)printf("%02X",wbuf[i]&0xFF); */
/*    printf("\n"); */

  write_jtag_fifo_bytes((unsigned char *)cc, 32);
/*    printf("customer code packet:\n"); */
/*    for(i=0;i<34;i++)printf("%02X",wbuf[i]&0xFF); */
/*    printf("\n"); */
}
    
