#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "jtag_defs.h"
#include "jtag_instr.h"

main()
{
  int i,j,n;
  enum JRTN_ID rtn;
  JINSTR_t *jrtn;
  unsigned int addr,mem[512],memp[512];
  FILE *fp;

  fp=fopen("prg_mem_init.dat","w");
  for(i=0;i<512;i++){
    mem[i] = 0;
    memp[i] = 0;
  }
  for(rtn=JC_Rd_DevID; rtn<=JC_User; rtn++){
    addr = jtr[rtn].base;
    for(i=0;i<jtr[rtn].n;i++){
      jrtn = jtr[rtn].rtn+i;
      mem[addr+i] = ((jrtn->instr&3)<<30)|((jrtn->bc&0x3FFF)<<16)|(jrtn->data&0xFFFF);
      memp[addr+i] = ((jrtn->instr>>2)&0xF);
    }
  }
  fprintf(fp,"   // Data input\n");
  for(i=0;i<64;i++){
    fprintf(fp,"   .INIT_%02X(256'h",i&0xFF);
    for(j=7;j>0;j--){
      fprintf(fp,"%08X_",mem[8*i+j]);
    }
    fprintf(fp,"%08X),\n",mem[8*i]);
  }
  fprintf(fp,"   // Parity data input\n");
  for(i=0;i<8;i++){
    fprintf(fp,"   .INITP_%02X(256'h",i&0xFF);
    for(j=63;j>0;j--){
      fprintf(fp,"%01X",memp[64*i+j]&0xF);
    }
    fprintf(fp,"%01X),\n",memp[64*i]&0xF);
  }
  fclose(fp);
}
