#include <stdio.h>
#include <string.h>
#include "eth.h"
#include "eth_ext_dcl.h"
#include "jtag_defs.h"
#include "codes.h"
#include "codes_ini.h"
#include "pkt_info.h"


void prg_vcc_prom_ver(char *, char *);

int bcast,uninit,slave,master,tmp_master;

FILE *fplog = NULL;

main(int argc,char *argv[])
{
  static unsigned char slv_mac[6] = {0x02,0x00,0x00,0x00,0x00,0x01};
  static unsigned char mstr_mac[6] = {0x02,0x00,0x00,0x00,0x00,0x29};

  static char path[] = ".";
  char ver[5];
  unsigned short int sn;
  int i,ver_found;
  /*
   *
   * Initialization
   */
  nerrcodes = NERRCODES;
  nopcodes  = NOPCODES;
  npktcodes = NPKTCODES;

  /*
   *
   * Check for command line arguments 
   */
  ver_found =0;
  if(argc>1){
    if((strstr(argv[1],"."))!=NULL){
      strcpy(ver,argv[1]);
      ver_found = 1;
    }
    else {
      sn = (unsigned short int)(atoi(argv[1])&0xFF);
    }
    if(argc>2){
      if(ver_found==1){
        sn = (unsigned short int)(atoi(argv[2])&0xFF);
      }
      else {
        strcpy(ver,argv[2]);
      }
    }
    else { 
      if(ver_found==1){
        printf("Enter serial number of VCC: ");
        scanf("%d",&sn);
      }
      else {
        printf("Enter version number (ex: \"4.2A\"): ");
        scanf("%s",ver);
      }
    }
  }
  else {
    printf("Enter serial number of VCC: ");
    scanf("%d",&sn);
    printf("Enter version number (ex: \"4.2A\"): ");
    scanf("%s",ver);
  }
  printf("\nUsing version: %s\n",ver);
  printf("      VCC S/N: %d\n\n",sn);
 
  mstr_mac[5]=(char)(sn&0xFF);
  for(i=0;i<JMB_DATA_LEN;i++)wbuf[i]=0;
  eth_open("vme0");
  slave  = eth_register_mac(slv_mac);
  master = eth_register_mac(mstr_mac);
  eth_reset();
  eth_read_timeout(RD_TMO_short);
  cur_mac = master;

  /*
   *
   * Call to program VCC PROM
   */
  prg_vcc_prom_ver(path,ver);
}
