#include <stdio.h>

#define MAXLINE 20000
#define MAXDATA 5000
#define CLOCK_PERIOD   16
#define CLOCK_OFFSET    8
#define SETUP_TO_CLK    3
#define START_OFFSET   6*CLOCK_PERIOD-CLOCK_OFFSET-SETUP_TO_CLK
#define INIT_OFFSET 3200*CLOCK_PERIOD
#define PKT_SPACING   25*CLOCK_PERIOD

char line[MAXLINE];
int nhead = 4;
int ntail = 3;
int ndata;
int changed;
unsigned short int pdata[MAXDATA];
unsigned short int khead[] = {0x0002,0x0000,0x0000,0x0000};
unsigned short int  head[] = {0xFB55,0x5555,0x5555,0x55D5};
unsigned short int ktail[] = {0x0000,0x0000,0x0003};
unsigned short int  tail[] = {0xCCCC,0xCCCC,0xFDF7};
unsigned short int kidle   = 0x0002;
unsigned short int  idle   = 0xBC50;
unsigned short int prev_wrd;

int fgetline(FILE *fp,char *line,int max);

main()
{
  int i,j,k,l,len,time,rel_time;
  FILE *hxfp,*vfp;
  rel_time = START_OFFSET;
  time = START_OFFSET;
  hxfp=fopen("sim_out.hex","r");
  vfp=fopen("stimulus.v","w");
  fprintf(vfp,"`timescale 1ns / 1ps\n\n");
  fprintf(vfp,"module stimulus(RXCHARISK,RXDATA);\n");
  fprintf(vfp,"\noutput [1:0] RXCHARISK;\noutput [15:0] RXDATA);\n");
  fprintf(vfp,"\nreg [1:0] RXCHARISK;\nreg [15:0] RXDATA;\n");
  fprintf(vfp,"\ninitial  //Process for Input stimulus\nbegin\n");
  fprintf(vfp,"   //Current Time: %7d ns\n",time);
  fprintf(vfp,"   #%d;\n",rel_time);
  fprintf(vfp,"   RXCHARISK = 2'b%01d%01d;\n",(kidle>>1)&1,kidle&1);
  fprintf(vfp,"   RXDATA = 16'h%04X;\n",idle);
  rel_time = INIT_OFFSET;
  prev_wrd = idle;  
  while((len = fgetline(hxfp,line,MAXLINE))!=0){
    for(i=0;i<len/4;i++){
      sscanf(line+4*i,"%4X",&pdata[i]);
    }
    ndata = i;
    for(i=0;i<nhead;i++){
      changed = (head[i]==prev_wrd)?0:1;
      if(changed==1){
        time += rel_time;
        fprintf(vfp,"   //Current Time: %7d ns\n",time);
        fprintf(vfp,"   #%d;\n",rel_time);
        fprintf(vfp,"   RXCHARISK = 2'b%01d%01d;\n",(khead[i]>>1)&1,khead[i]&1);
        fprintf(vfp,"   RXDATA = 16'h%04X;\n",head[i]);
        rel_time = CLOCK_PERIOD;
      }
      else {
        rel_time = rel_time + CLOCK_PERIOD;
      }
      prev_wrd = head[i];
    }
    for(i=0;i<ndata;i++){
      changed = (pdata[i]==prev_wrd)?0:1;
      if(changed==1){
        time += rel_time;
        fprintf(vfp,"   //Current Time: %7d ns\n",time);
        fprintf(vfp,"   #%d;\n",rel_time);
        fprintf(vfp,"   RXCHARISK = 2'b00;\n");
        fprintf(vfp,"   RXDATA = 16'h%04X;\n",pdata[i]);
        rel_time = CLOCK_PERIOD;
      }
      else {
        rel_time = rel_time + CLOCK_PERIOD;
      }
      prev_wrd = pdata[i];
    }
    if(ndata<30){
      changed = (0==prev_wrd)?0:1;
      if(changed==1){
        time += rel_time;
        fprintf(vfp,"   //Current Time: %7d ns\n",time);
        fprintf(vfp,"   #%d;\n",rel_time);
        fprintf(vfp,"   RXCHARISK = 2'b00;\n");
        fprintf(vfp,"   RXDATA = 16'h0000;\n");
        rel_time = (30-ndata)*CLOCK_PERIOD;
      }
      else {
        rel_time = rel_time + (30-ndata)*CLOCK_PERIOD;
      }
      prev_wrd = 0;
    }
    for(i=0;i<ntail;i++){
      changed = (tail[i]==prev_wrd)?0:1;
      if(changed==1){
        time += rel_time;
        fprintf(vfp,"   //Current Time: %7d ns\n",time);
        fprintf(vfp,"   #%d;\n",rel_time);
        fprintf(vfp,"   RXCHARISK = 2'b%01d%01d;\n",(ktail[i]>>1)&1,ktail[i]&1);
        fprintf(vfp,"   RXDATA = 16'h%04X;\n",tail[i]);
        rel_time = CLOCK_PERIOD;
      }
      else {
        rel_time = rel_time + CLOCK_PERIOD;
      }
      prev_wrd = tail[i];
    }
    time += rel_time;
    fprintf(vfp,"   //Current Time: %7d ns\n",time);
    fprintf(vfp,"   #%d;\n",rel_time);
    fprintf(vfp,"   RXCHARISK = 2'b%01d%01d;\n",(kidle>>1)&1,kidle&1);
    fprintf(vfp,"   RXDATA = 16'h%04X;\n",idle);
    rel_time = PKT_SPACING;
  }
  fprintf(vfp,"end\n");
  fprintf(vfp,"\nendmodule\n");
  fclose(hxfp);
  fclose(vfp);
}

int fgetline(FILE *fp,char *line,int max)
{
  if(fgets(line,max,fp) == NULL)
    return 0;
  else
    return strlen(line);
}
