#ifndef HAVE_SLV_DEV_DEFS
#define HAVE_SLV_DEV_DEFS
enum SLV_DEV {MEMA16=0, MEMA32=1, MEMB8=2, MEMB64=3, EXT_FIFO=4, RND_RBN=5};

enum TRNS_TYP {SNGL=0, BLOCK=1, RMW=2, UNALG=3};
enum DATA_SZ {D08=0, D16=1, D32=2, D64=3};
enum WRT_RD {READ=0, WRITE=1};
enum ADDR_SZ {A16=1, A24=2, A32=3, A40=4, A64=5};
enum DLY_TYP {No_Dly=0, D4nsX16=1, D16nsX16=2, D16usX16=3,
                        D4nsX32=4, D16nsX32=5, D16usX32=6};

typedef struct vcmd_t {  /* VME command type */
  union {
    unsigned int full; //full VME control word
    struct {
      unsigned int tt  : 2; //Transfer Type (2 bit field) 
      unsigned int dsz : 2; //Data Size     (2 bit field)
      unsigned int wrt : 1; //Write or Read (1 bit field)
      unsigned int asz : 3; //Address Size  (3 bit field)
      unsigned int dt  : 3; //Delay Type    (3 bit field)
      unsigned int at  : 5; // all "access type" bits (5 bit field)
    } tg; // tag
    struct {
      unsigned int     :11; // place holder
      unsigned int pg  : 1; //Program/Data access
      unsigned int sp  : 1; //Supervisory/Non-Privileged access
      unsigned int lk  : 1; // LOCK Command access
      unsigned int cr  : 1; // Configuration ROM/ Control/Status Reg.
      unsigned int ud  : 1; //User Defined Address Modifier
    } fl; // flag
  } cw; // control word
  int  addr_h;  //high order of 64 bit VME address
  int  addr_l;  //low  order of 64 bit VME address
  int  dc;    //Data Count for block transfers
  int *dp;    //Data pointer
  int  delay; //Delay value
  int  uam;   //User defined Address Modifier
} VCMD_t;

#endif
