#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "codes.h"
#include "pkt_info.h"
#include "slave_dev.h"
#include "slave_cnfg_defs.h"
#include "test_defs.h"
#include "cnfg_defs.h"
#include "eth.h"
#include "eth_ext_dcl.h"
#include "mac_utils_dcls.h"
#include "cntrl_subs_dcls.h"


#define MACSZ 14
#define PROTSZ 6
#define MAX_DATA_SZ 8994
#define DATA_INC 1
#define MAX_LINE  80
#define MAX_LINES 256

int bcast,uninit,slave,master,tmp_master;
int pre_prod;
int ser_num,mac_sn;
SN_t sn;

CNFG_t std_cnfg = { {DEV_MAC,
                     MCAST1_MAC,
                     MCAST2_MAC,
                     MCAST3_MAC,
                     DFLT_SRV_MAC},
                    ETH_CR_DFLT,
                    FIFO_CR_DFLT,
                    RST_CR_DFLT,
                    VME_CR_DFLT,
                    VME_BTO_DFLT,
                    VME_BGTO_DFLT};


FILE *fplog = NULL;

#define DATA_BUF_SIZE 1024
unsigned int data[DATA_BUF_SIZE];
unsigned int rtn_buf[DATA_BUF_SIZE];

int main(void);


int main()
{
  unsigned char dflt_mac[] = DFLT_FRM_MAC;
  unsigned char bcast_mac[] = BCAST_MAC;
  unsigned char mstr_mac[] = {0x02,0,0,0,0,0x29};
  unsigned char slv_mac[6];

  char *dp;
  int i,j,l,n,lcnt,max,pg,cnt,nvu;

  CNFG_ptr snd_cp;

  FILE *fp;

  VCMD_t a24d16;

  /*
   *
   * Initialization
   */

  snd_cp=(CNFG_ptr)malloc(sizeof(CNFG_t));
  snd_cp->reset = 0x001B;
  snd_cp->vme   = 0x20001D1F;
  snd_cp->ether = 0x0010;

  fp=fopen("mac_addr_slave.hex","r");
  fscanf(fp,"%02X-%02X-%02X-%02X-%02X-%02X",&slv_mac[0],&slv_mac[1],&slv_mac[2],&slv_mac[3],&slv_mac[4],&slv_mac[5]);
  fclose(fp);

  for(i=0;i<JMB_DATA_LEN;i++)wbuf[i]=0;
  eth_open("vme0");
  bcast  = eth_register_mac(bcast_mac);
  uninit = eth_register_mac(dflt_mac);
  slave  = eth_register_mac(slv_mac);
  master = eth_register_mac(mstr_mac);
  cur_mac = master;
  eth_reset();
  eth_read_timeout(RD_TMO_short);

  /*
  wbuf[0]=0x00;
  wbuf[1]=Wrt_Rst_CR;
  wbuf[2]=((snd_cp->reset)>>8)&0xFF;
  wbuf[3]=(snd_cp->reset)&0xFF;
  nwbuf=4;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;

  wbuf[0]=0x00;
  wbuf[1]=Wrt_VME_CR;
  wbuf[2]=((snd_cp->vme)>>24)&0xFF;
  wbuf[3]=((snd_cp->vme)>>16)&0xFF;
  wbuf[4]=((snd_cp->vme)>>8)&0xFF;
  wbuf[5]=(snd_cp->vme)&0xFF;
  nwbuf=6;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;

  wbuf[0]=0x00;
  wbuf[1]=Save_Cnfg_Num;
  wbuf[2]=0x00;
  wbuf[3]=0x01;
  nwbuf=4;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;

  wbuf[0]=0x00;
  wbuf[1]=Set_Cnfg_Dflt;
  wbuf[2]=0x00;
  wbuf[3]=0x01;
  nwbuf=4;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;

  wbuf[0]=0x00;
  wbuf[1]=Wrt_Eth_CR;
  wbuf[2]=((snd_cp->ether)>>8)&0xFF;
  wbuf[3]=(snd_cp->ether)&0xFF;
  nwbuf=4;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  */
  a24d16.cw.tg.tt=SNGL;
  a24d16.cw.tg.dsz=D16;
  a24d16.cw.tg.wrt=WRITE;
  a24d16.cw.tg.asz=A24;
  a24d16.cw.tg.dt=No_Dly;
  a24d16.cw.tg.at=0;
  a24d16.addr_l = 0x00680000;
  a24d16.addr_h = 0x00000000;
  a24d16.dc = 1;
  a24d16.dp = data;
  a24d16.delay = 0;
  a24d16.uam = 0;

  data[0] = 0x0000;

  nvu=add2pkt(1, &a24d16);
  wbuf[0]=0x00;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;

  a24d16.addr_l = 0x00680020;
  data[0] = 0x0001;
  nvu=add2pkt(1, &a24d16);
  wbuf[0]=0x00;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;

  a24d16.addr_l = 0x00680040;
  a24d16.cw.tg.wrt=0;
  nvu=add2pkt(1, &a24d16);
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;

}
