#include "slave_dev.h"
#include "pkt_info.h"
#include "cnfg_defs.h"
#include "codes.h"

#ifndef HAVE_TEST_DEFS
#define HAVE_TEST_DEFS


//flash_subs.c definitions
#define MAX_PAGES 128
#define MAX_ADDRS  64
#define WRT      0x80
#define RD       0x00
#define BEG_SECT  0
#define END_SECT 15
#define MAX_SECT 16
#define NUM_PGS   8
#define MAX_PAGES 128
#define BEG_ADDRS 0
#define END_ADDRS 63
#define MAX_ADDRS 64

enum CMP_MODE {NO_CMP, ZERO_CMP, FF_CMP,
               AA_CMP, _55_CMP, INC_CMP, DEC_CMP};

enum rsts_t {NO_RSTS, INT_RSTS, FP_RSTS, HRD_RSTS};

enum fftest_t {PATTERNS, RANDOMS};

//Chose which VME test routines get compiled
#define TEST_DTB
#define TEST_AM
#define TEST_ARB
#define TEST_INTR
#define TEST_BERR
#define TEST_DLY

#endif

//test_subs.c routines
extern void print_mac(unsigned char *);
extern void print_macnr(unsigned char *);
extern int maccmp(char *,char *);
extern int poll_macs(unsigned char [][6]);
extern int test_leds();
extern int test_flash();
extern int test_cnfg();
extern int test_resets();
extern int cycle_reloads(enum rsts_t);
extern void alrm_hndlr(int);
extern void gen_hrd_rst();
extern void gen_intr();
extern int test_fifo();
extern int exercise_fifo(enum fftest_t);
extern int test_vme();


//vme_test_subs.c routines
extern int vme_dtb();
extern int vme_am();
extern int vme_arb();
extern int vme_intr();
extern int vme_berr();
extern int vme_dly();
extern void init_slave();
extern void prt_rsp(struct rspn_t *);
extern void fprt_rsp(FILE *, struct rspn_t *);
extern int add2pkt(int, VCMD_t *);
extern struct rspn_t look4_vme_pkt(enum pkt_t, void *, int );


//flash_subs.c routines
extern void flash_init_rbk();
extern int flash_read(enum CMP_MODE );
extern int flash_write(enum CMP_MODE );
extern int dcode_flash_pkt(enum CMP_MODE);
extern void flash_print(FILE *);
