#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "cnfg_defs.h"
#include "eth.h"
#include "eth_ext_dcl.h"
#include "mac_utils_dcls.h"
#include "cntrl_subs_dcls.h"
#include "jtag_defs.h"
#include "codes.h"
#include "codes_ini.h"
#include "pkt_info.h"


#define MACSZ 14
#define PROTSZ 6
#define MAX_DATA_SZ 8994
#define DATA_INC 1
#define MAX_LINE  80
#define MAX_LINES 256

extern unsigned short int prm_dat[];

void prg_vcc_prom_ver(char *, char *);

int bcast,uninit,slave,master,tmp_master;
SN_t sn;

FILE *fplog = NULL;

int main(void);


int main()
{
  unsigned char dflt_mac[] = DFLT_FRM_MAC;
  unsigned char bcast_mac[] = BCAST_MAC;
  unsigned char mstr_mac[] = DEV_MAC;
  unsigned char dmac[] = {0x00,0x0D,0x88,0xB5,0x86,0xAC};
  unsigned char mac[6];

  static char *jtagcmds[]  = {"dvid","rd_uc","rd_cc","chk_con","base",
                              "ld_rtn","prt_rtn","status","abort",
                              "erase","program","verify","jreload","rdbk",
                              "rdmcs","wrtdat","custom","prgver"};
  static char *ffcmds[]  = {"ecc","no_ecc","vme","fifo","inj","no_inj",
			    "prst","mrst","st_mrk","rst_mrk",
			    "prg_off","rbk_off","rd_err_cnt","rst_err"};
  static char *gencmds[] = {"warn","no_warn","strt_pkt","no_strt_pkt",
			    "freload","hard_reset","frc_sysrst","leds","bov"};
  static char *cnfgcmds[]  = {"set_dflt","read_dflt","sav_cnum","rstr_cnum",
			    "rd_cnum_dir","rd_cnum_dcd","set_macs",
			    "rd_macs_dir","rd_macs_dcd","read_crs","wrt_crs",
                            "sc_bits","frc_sysrst","upd_lvls",
                            "wrt_ser_num","rd_ser_num"};
  static char *lucmds[] = {"help","sel_dev","mac","cnfg_reg",
                           "load_cnfg","write_cnfg",
                           "prt_buf","cp_buf","quit"};
  static char *blank = "             ";

  int numjtag = 18;
  int numff = 14;
  int numgen = 9;
  int numcnfg = 16;
  int numlu = 9;

  char *ptr0,*ptr1,*ptr2,*ptr3,*ptr4;
  char *tmp_cp;
  char cmnd[25],cnfg_fn[128],c,ans[12];
  char macfmt[] = "%2hx-%2hx-%2hx-%2hx-%2hx-%2hx";
  char fname[32];
  char *dp;
  int i,j,l,n,lcnt,max,pg,cnt,opt,nu,wrng_mac;
  int cnfg_num,dflt_num,ser_num;
  unsigned int mask;
  unsigned int cor,uncor;
  unsigned int leds,full_off,mt_off;
  unsigned int rbk_full_off, rbk_mt_off;

  int slv_mtch,unt_mtch,rsp_macs,unt,rsp;
  int npol;
  int cur_dev;
  int rslt;
  int sav_mac;
  unsigned int temp_uint;
  unsigned short tmp[6],base_addr;
  unsigned char slv_mac[6];
  unsigned char gen_mac[6];
  unsigned char pmacs[NMAX_MACS][6];
  int tag_macs[NMAX_MACS];


  CNFG_ptr snd_cp,rcv_cp,scr_cp;
  enum MAC_ID mcid;
  enum CR_ID  crid;
  enum SET_CLR  sc;
  FILE *fp;
  CNFG_t *rcv_cnfg;

  enum pkt_t ptyp;
  enum ack_st ack;
  int pktnum,pktnumA,pktnumB,pktnumW;
  int seq_num;
  /*
   *
   * Initialization
   */
  nerrcodes = NERRCODES;
  nopcodes  = NOPCODES;
  npktcodes = NPKTCODES;
  fp=fopen("mac_addr_slave.hex","r");
  fscanf(fp,"%02X-%02X-%02X-%02X-%02X-%02X",&slv_mac[0],&slv_mac[1],&slv_mac[2],&slv_mac[3],&slv_mac[4],&slv_mac[5]);
  fclose(fp);

  max=0;
  if(numjtag>max)max=numjtag;
  if(numff>max)max=numff;
  if(numgen>max)max=numgen;
  if(numcnfg>max)max=numcnfg;
  if(numlu>max)max=numlu;
  snd_cp = 0;
  rcv_cp = 0;
  scr_cp = 0;
  for(i=0;i<JMB_DATA_LEN;i++)wbuf[i]=0;
  eth_open("vme0");
  bcast  = eth_register_mac(bcast_mac);
  uninit = eth_register_mac(dflt_mac);
  slave  = eth_register_mac(slv_mac);
  eth_reset();
  eth_read_timeout(RD_TMO_short);
  /*
   *
   * Scanning for boards
   */
  cur_mac = bcast;
  npol = poll_macs(pmacs);
  slv_mtch=unt_mtch=rsp_macs=0;
  printf("received %d packets\n",npol);
  if(npol>0){
    printf("The following MAC devices were found:\n");
    for(n=0;n<npol;n++){
      printf("                      %d: ",n);
      print_mac(pmacs[n]);
      if(maccmp(pmacs[n],slv_mac)==0){
        slv_mtch++;
        tag_macs[n]=slave;
      }
      else if(maccmp(pmacs[n],dflt_mac)==0){
        unt_mtch++;
        unt=n;
        tag_macs[n]=uninit;
      }
      else {
        tag_macs[n]= -1;
        rsp=n;
        rsp_macs++;
      }
    }
    printf("Registering new devices.\n");
    for(n=0;n<npol;n++){
      if(tag_macs[n]==-1) tag_macs[n]= eth_register_mac(pmacs[n]);
    }
    if(rsp_macs>0){
      cur_mac = tag_macs[rsp];
      cur_dev = rsp;
      printf("Current MAC set to     : ");print_mac(pmacs[rsp]);
      strcpy(cmnd,"help");
    }
    else {
      printf("Current Mac is not initialized.  You must choose one.\n");
      strcpy(cmnd,"sel_dev");
    }
  }
  else {
    printf("No responses found!  Check your setup.\n");
    exit(1);
  }
  /*
   *
   * Command parsing
   * 
   */
  while(strcmp(cmnd,"quit")!=0){
    if(strcmp(cmnd,"help")==0){
      printf("     JTAG        FIFO          General       Config       Local Utils\n");
      printf("-----------------------------------------------------------------------\n");
      for(l=0;l<max;l++){
        ptr0 = (l<numjtag)?jtagcmds[l]:blank;
        ptr1 = (l<numff)?ffcmds[l]:blank;
        ptr2 = (l<numgen)?gencmds[l]:blank;
        ptr3 = (l<numcnfg)?cnfgcmds[l]:blank;
        ptr4 = (l<numlu)?lucmds[l]:blank;
        printf("%-14s%-14s%-14s%-14s%-14s\n",ptr0,ptr1,ptr2,ptr3,ptr4);
      }
    }
    else if(strcmp(cmnd,"sel_dev")==0){
      printf("Select one of the following devices to talk to:\n");
      for(n=0;n<npol;n++){
	printf("%d: ",n);
	print_mac(pmacs[n]);
      }
      printf("%d: Enter a device not listed.",n);
      printf("\nSelect Device > ");
      scanf("%d",&opt);
      while(opt>n || opt<0){
        printf("Invalid option: %d, try again > ",opt);
        scanf("%d",&opt);
      }
      if(opt==n){
        printf("Enter MAC address:\n");
        printf("in xx-xx-xx-xx-xx-xx format:\n");
        printf("   ");
        scanf(macfmt,tmp,tmp+1,tmp+2,tmp+3,tmp+4,tmp+5);
        for(i=0;i<6;i++)pmacs[n][i]=(unsigned char)tmp[i];
        tag_macs[n]= eth_register_mac(pmacs[n]);
      }
      cur_dev = opt;
      cur_mac = tag_macs[cur_dev];
      printf("Current MAC set to     : ");print_mac(pmacs[cur_dev]);
    }
    else if(strcmp(cmnd,"dvid")==0){
      temp_uint = read_dev_id();
      printf("Device ID is %08X\n",temp_uint);
    }
    else if(strcmp(cmnd,"rd_uc")==0){
      temp_uint = read_user_code();
      printf("User Code is %08X\n",temp_uint);
    }
    else if(strcmp(cmnd,"rd_cc")==0){
      tmp_cp = read_customer_code();
      if(tmp_cp!=0){
        printf("Customer Code is %s\n",tmp_cp);
      }
      else {
        printf("Did not receive customer code\n");
      }
    }
    else if(strcmp(cmnd,"chk_con")==0){
      rslt = chk_jtag_conn();
      if(rslt == 1){
        printf("JTAG connection is good.\n");
      }
      else{
        printf("\a\aJTAG connection is bad!\n");
      }
    }
    else if(strcmp(cmnd,"base")==0){
      printf("Enter base address (3 hex digits): ");
      scanf("%03x",&base_addr);
      ld_rtn_base_addr(base_addr);
    }
    else if(strcmp(cmnd,"ld_rtn")==0){
      jtag_init();
    }
    else if(strcmp(cmnd,"prt_rtn")==0){
      print_routines();
    }
    else if(strcmp(cmnd,"status")==0){
      temp_uint = get_jtag_status();
      printf("Status is %08X\n",temp_uint);
    }
    else if(strcmp(cmnd,"abort")==0){
      abort_jtag_cmnds();
    }
    else if(strcmp(cmnd,"erase")==0){
      rslt = erase_prom();
      if(rslt == 1){
        printf("PROM successfully erased.\n");
      }
      else{
        printf("\a\aPROM is not erased!\n");
      }
    }
    else if(strcmp(cmnd,"program")==0){
      pktnum = 0;
      printf("Enter mcs filename: ");
      scanf("%s",fname);
      read_mcs(fname);
      program_prom_cmd();
      send_prg_prom_data();
      send_uc_cc_data(fname);
      while((n=eth_read())>6){
	pktnum++;
	ptyp = rbuf[PKT_TYP_OFF]&0xff;
	if(ptyp>=INFO_PKT){
	  printf("pktnum B%d: %s",pktnum,dcode_msg_pkt(rbuf));
	} else {
	  printf("pktnum B%d:",pktnum);
	  ack = AK_STATUS(rbuf); 
	  switch(ack){
	  case NO_ACK:
	    printf("Non message or no acknowledge packet received\n");
	    break;
	  case CC_S:
	    printf("Command completed successfully\n");
	    break;
	  case CC_W:
	    printf("Command completed with a warning\n");
	    break;
	  case CC_E:
	    printf("Command  completed with an error\n");
	    break;
	  case CE_I:
	    printf("Command execution finished incomplete\n");
	    break;
	  case CIP_W: case CIP_E:
	    printf("Command in progress with an error or warning\n");
	    break;
	  default:
	    printf("Unknow packet returned\n");
	    break;
	  }
	}
      }
    }
    else if(strcmp(cmnd,"custom")==0){
      ld_rtn_base_addr(0x180);
      exec_routine(JC_Custom_Rtn);
      n=eth_read();
      if(n>6){
        ptyp = rbuf[PKT_TYP_OFF]&0xff;
        if(ptyp>=INFO_PKT){
          printf("%s",dcode_msg_pkt(rbuf));
        }
        else {
          for(i=0;i<n;i++)printf("%02X",rbuf[i]);
          printf("\n");
	}
      }
      else {
        printf("no packet returned\n");
      }
    }
    else if(strcmp(cmnd,"verify")==0){
      printf("Enter filename: ");
      scanf("%s",fname);
      read_mcs(fname);
      verify_prom_cmd();
      send_ver_prom_data();
    }
    else if(strcmp(cmnd,"jreload")==0){
      reload_fpga();
    }
    else if(strcmp(cmnd,"hard_reset")==0){
      sav_mac=cur_mac;
      cur_mac=slave;
      wbuf[0]=0x00;
      wbuf[1]=Gen_Hard_Rst;
      nwbuf = 2;
      eth_write();
      printf("    Hard Reset!\n");
      cur_mac=sav_mac;
    }
    else if(strcmp(cmnd,"rdbk")==0){
      rd_back_prom();
    }
    else if(strcmp(cmnd,"rdmcs")==0){
      printf("Enter filename: ");
      scanf("%s",fname);
      read_mcs(fname);
    }
    else if(strcmp(cmnd,"wrtdat")==0){
      fp=fopen("MCS_data.dat","w");
      for(i=0;i<0x80000;i++){
        if(i!=0 && i%8==0)fprintf(fp,"\n");
        fprintf(fp,"%04hX",prm_dat[i]);
      }
      fprintf(fp,"\n");
      fclose(fp);
    }
    else if(strcmp(cmnd,"prgver")==0){
      prg_vcc_prom_ver(".","4.24");
    }
    else if(strcmp(cmnd,"ecc")==0){
      enable_ECC();
    }
    else if(strcmp(cmnd,"no_ecc")==0){
      disable_ECC();
    }
    else if(strcmp(cmnd,"vme")==0){
      set_VME_mode();
    }
    else if(strcmp(cmnd,"fifo")==0){
      set_ff_test_mode();
    }
    else if(strcmp(cmnd,"inj")==0){
      enable_inj_errs();
    }
    else if(strcmp(cmnd,"no_inj")==0){
      disable_inj_errs();
    }
    else if(strcmp(cmnd,"prst")==0){
      prst_ff();
    }
    else if(strcmp(cmnd,"mrst")==0){
      mrst_ff();
    }
    else if(strcmp(cmnd,"set_mrk")==0){
      set_mark();
    }
    else if(strcmp(cmnd,"rst_mrk")==0){
      rst_mark();
    }
    else if(strcmp(cmnd,"prg_off")==0){
      printf("enter Full  offset in hex (18 bits): ");
      scanf("%8x",&full_off);
      printf("enter Empty offset in hex (18 bits): ");
      scanf("%8x",&mt_off);
      prg_off(full_off,mt_off);
    }
    else if(strcmp(cmnd,"rbk_off")==0){
      rdbk_off(&rbk_full_off,&rbk_mt_off);
      printf("full offset  = %d\n",rbk_full_off);
      printf("empty offset = %d\n",rbk_mt_off);
    }
    else if(strcmp(cmnd,"rd_err_cnt")==0){
      rd_err_cnts(&cor, &uncor);
      printf("      Uncorrected   Corrected\n");
      printf("         Errors      Errors\n");
      printf("    ----------------------------\n");
      printf("     %10d    %10d\n",uncor,cor);
    }
    else if(strcmp(cmnd,"rst_err")==0){
      rst_err_cnt();
    }
    else if(strcmp(cmnd,"warn")==0){
      enable_warn_on_shutdown();
    }
    else if(strcmp(cmnd,"no_warn")==0){
      disable_warn_on_shutdown();
    }
    else if(strcmp(cmnd,"strt_pkt")==0){
      snd_startup_pkt();
    }
    else if(strcmp(cmnd,"no_strt_pkt")==0){
      no_startup_pkt();
    }
    else if(strcmp(cmnd,"freload")==0){
      force_reload();
    }
    else if(strcmp(cmnd,"leds")==0){
      printf("enter 32 bit number in hex : ");
      scanf("%8x",&leds);
      ld_usr_reg(leds);
    }
    else if(strcmp(cmnd,"bov")==0){
      pktnum = 0;
      pktnumA = 0;
      pktnumB = 0;
      pktnumW = 0;
      eth_read_timeout(RD_TMO_med);
      wbuf[0]=0x20;
      wbuf[1]=0x11;//write RST/Misc. CR
      wbuf[2]=0x03;
      wbuf[3]=0x1B;
      nwbuf=4;
      n=eth_write();
/*        wbuf[0]=0x20; */
/*        wbuf[1]=0x12;//write VME CR */
/*        wbuf[2]=0x20; */
/*        wbuf[3]=0x00; */
/*        wbuf[4]=0x1D; */
/*        wbuf[5]=0x0F; */
/*        nwbuf=6; */
/*        n=eth_write(); */
/*        wbuf[0]=0x20; */
/*        wbuf[1]=0x05;//Save config to flash */
/*        wbuf[2]=0x00; */
/*        wbuf[3]=0x01; */
/*        nwbuf=4; */
/*        n=eth_write(); */
/*        wbuf[0]=0x20; */
/*        wbuf[1]=0x0e;//Read CR's */
/*        nwbuf=2; */
/*        n=eth_write(); */
      wbuf[0]=0x20;
      wbuf[1]=0x20;//VME command
      wbuf[2]=0x00;
      wbuf[3]=0x01;
      wbuf[4]=0x03;
      wbuf[5]=0x00;
      wbuf[6]=0x3B;
      wbuf[7]=0x9C;
      nwbuf=8;
      n=eth_write();
      //      nu=970;
      nu=10;
      wbuf[0]=0x20;
      wbuf[1]=0x20;//VME command
      wbuf[2]=(nu>>8)&0xff;
      wbuf[3]=nu&0xff;
      for(i=0;i<nu;i++){
        wbuf[8*i+4]=0x00;
        wbuf[8*i+5]=0x54;
        wbuf[8*i+6]=0x00;
        wbuf[8*i+7]=0x58;
        wbuf[8*i+8]=0x00;
        wbuf[8*i+9]=0x00;
        wbuf[8*i+10]=0x00;
        wbuf[8*i+11]=0x00;
      }
      nwbuf=8*nu+4;
      for(i=0;i<175;i++){
        n=eth_write();
      }
      while((n=eth_read())>6){
	pktnum++;
	ptyp = rbuf[PKT_TYP_OFF]&0xff;
        seq_num = SEQ_PKT_ID(rbuf);
	if(ptyp>=INFO_PKT){
	  printf("pktnum B%d:seq:%d: %s",++pktnumB,seq_num,dcode_msg_pkt(rbuf));
	} else {
	  printf("pktnum A%d:seq:%d:",++pktnumA,seq_num);
	  ack = AK_STATUS(rbuf); 
/*              for(i=0;i<n;i++){ */
/*                printf("%02X",rbuf[i]&0xFF); */
/*              } */
/*              printf("\n"); */
	  switch(ack){
	  case NO_ACK:
	    printf("Non message or no acknowledge packet received\n");
            for(i=0;i<n;i++){
              printf("%02X",rbuf[i]&0xFF);
            }
            printf("\n");
	    break;
	  case CC_S:
	    printf("Command completed successfully\n");
	    break;
	  case CC_W:
	    printf("Command completed with a warning\n");
	    break;
	  case CC_E:
	    printf("Command  completed with an error\n");
	    break;
	  case CE_I:
	    printf("Command execution finished incomplete\n");
	    break;
	  case CIP_W: case CIP_E:
	    printf("Command in progress with an error or warning\n");
	    break;
	  default:
	    printf("Unknow packet returned\n");
	    break;
	  }
	}
        wrng_mac=0;
        for(i=0;i<6 && !wrng_mac;i++){
          if(rbuf[i]!=dmac[i])wrng_mac=1;
        }
        if(wrng_mac==1){
          printf("Destination mac is wrong!!!\n");
          printf("pktnum W%d:seq:%d: MAC: ",++pktnumW,seq_num);
          for(i=0;i<5;i++)printf("%02X-",rbuf[i]);
          printf("%02X\n",rbuf[5]);
	}
      }
      eth_read_timeout(RD_TMO_short);
    }
    else if(strcmp(cmnd,"frc_sysrst")==0){
      set_clr_bits(SET,VME,VME_CR_FRC_SRST);
    }
    else if(strcmp(cmnd,"load_cnfg")==0){
      printf("Enter config filename: ");
      scanf("%s",cnfg_fn);
      scr_cp = load_cnfg(cnfg_fn);
      if(scr_cp== (CNFG_ptr)-1){
        printf("could not open file %s\n",cnfg_fn);
      }
      else {
        printf("Loaded Config:\n");
        print_cnfg(scr_cp);
        if(snd_cp == NULL){
          snd_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
        }
        cp_cnfg(snd_cp,scr_cp);
        free(scr_cp);
        scr_cp=0;
      }
    }
    else if(strcmp(cmnd,"write_cnfg")==0){
      if(rcv_cp == NULL){
        printf("No configuration in the receive buffer yet!\n");
      }
      else {
        printf("Enter config filename: ");
        scanf("%s",cnfg_fn);
        if(write_cnfg(rcv_cp,cnfg_fn)==-1){
          printf("could not open file %s\n",cnfg_fn);
        }
        else {
          printf("Receive buffer written to %s\n",cnfg_fn);
        }
      }
    }
    else if(strcmp(cmnd,"set_dflt")==0){
      printf("Enter default config num: ");
      scanf("%d",&dflt_num);
      set_cnfg_dflt(dflt_num);
    }
    else if(strcmp(cmnd,"read_dflt")==0){
      dflt_num = read_cnfg_dflt();
      printf("Default config num is : %d\n",dflt_num);
    }
    else if(strcmp(cmnd,"sav_cnum")==0){
      printf("Enter config num: ");
      scanf("%d",&cnfg_num);
      save_cnfg_num(cnfg_num);
    }
    else if(strcmp(cmnd,"rstr_cnum")==0){
      printf("Enter config num: ");
      scanf("%d",&cnfg_num);
      rstr_cnfg_num(cnfg_num);
    }
    else if(strcmp(cmnd,"rd_cnum_dir")==0){
      printf("Enter config num: ");
      scanf("%d",&cnfg_num);
      n=read_cnfg_num_dir(cnfg_num, &dp);
      if(n<0){
        printf("Error in controller.  Error type is %d\n",-n);
      }
      else {
        l=0;
        printf("   data    |    parity\n");
        printf("pg:ad  dt  |  pg:ad  dt\n");
        printf("-----------|------------\n");
        while(l<n){
          pg=dp[2*l];
          cnt=dp[2*l+1];
          l++;
          for(j=0;j<cnt;j+=6){
            for(i=j;i<j+3;i++){
              printf("%02X:%02X  %02X  |  ",pg&0xFF,dp[2*l+2*i]&0xFF,dp[2*l+2*i+1]&0xFF);
              printf("%02X:%02X  %02X\n",pg&0xFF,dp[2*l+2*i+6]&0xFF,dp[2*l+2*i+7]&0xFF);
            }
          }
          l+=cnt;
        }
      }
    }
    else if(strcmp(cmnd,"rd_cnum_dcd")==0){
      printf("Enter config num: ");
      scanf("%d",&cnfg_num);
      scr_cp = read_cnfg_num_dcd(cnfg_num);
      if(scr_cp<0){
        printf("Error in controller.  Error type is %d\n",-(int)scr_cp);
      }
      else {
        print_crs(scr_cp);
        if(rcv_cp == NULL){
          rcv_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
        }
        cp_crs(rcv_cp,scr_cp);
        free(scr_cp);
        scr_cp=0;
      }
    }
    else if(strcmp(cmnd,"set_macs")==0){
      if(snd_cp == NULL){
        printf("No configuration in the send buffer yet!\n");
        printf("Either load configuration from file or\n");
        printf("enter MAC and/or config. reg. manually\n");
        printf("using the mac or cnfg_reg commands.\n");
      }
      else {
        printf("DEVICE   -- %d\nMCAST1   -- %d\nMCAST2   -- %d\nMCAST3   -- %d\nDFLT_SRV -- %d\nALL_MACS -- %d\n",DEVICE,MCAST1,MCAST2,MCAST3,DFLT_SRV,ALL_MACS);
        printf("Choose MAC ID: ");
        scanf("%d",&mcid);
        if(mcid==DEVICE | mcid==ALL_MACS){
          for(i=0;i<6;i++){
            mac[i]=snd_cp->mac.device[i];
          }
          for(n=0;n<npol && (cur_mac != tag_macs[n]);n++);
	  if(n!=npol){ //remove the current MAC from the list
            npol--;
            for(j=n;j<npol;j++){
              tag_macs[j]=tag_macs[j+1];
              for(i=0;i<6;i++)pmacs[j][i]=pmacs[j+1][i];
	    }
	  }
          set_macs(mcid,snd_cp);
          cur_mac = eth_register_mac(mac);
          for(n=0;n<npol && (cur_mac != tag_macs[n]);n++);
	  if(n=npol){ //if no match then add to list
	    npol++;
	    tag_macs[n]=cur_mac;
	    for(i=0;i<6;i++)pmacs[n][i]=mac[i];
	  }
          cur_dev = n;
          printf("Current MAC set to     : ");print_mac(pmacs[cur_dev]);
        }
        else {
          set_macs(mcid,snd_cp);
        }
      }
    }
    else if(strcmp(cmnd,"mac")==0){
      printf("Enter MAC address:\n");
      printf("in xx-xx-xx-xx-xx-xx format:\n");
      printf("   ");
      scanf(macfmt,tmp,tmp+1,tmp+2,tmp+3,tmp+4,tmp+5);
      for(i=0;i<6;i++)gen_mac[i]=(unsigned char)tmp[i];
      if(snd_cp == NULL){
        snd_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
      }
      printf("DEVICE   -- %d\nMCAST1   -- %d\nMCAST2   -- %d\nMCAST3   -- %d\nDFLT_SRV -- %d\n",DEVICE,MCAST1,MCAST2,MCAST3,DFLT_SRV);
      printf("Choose MAC type: ");
      scanf("%d",&mcid);
      switch (mcid){
      case DEVICE:
	for(i=0;i<6;i++){
	  snd_cp->mac.device[i]=gen_mac[i];
	}
	break;
      case MCAST1:
	for(i=0;i<6;i++){
	  snd_cp->mac.mcast1[i]=gen_mac[i];
	}
	break;
      case MCAST2:
	for(i=0;i<6;i++){
	  snd_cp->mac.mcast2[i]=gen_mac[i];
	}
	break;
      case MCAST3:
	for(i=0;i<6;i++){
	  snd_cp->mac.mcast3[i]=gen_mac[i];
	}
	break;
      case DFLT_SRV:
	for(i=0;i<6;i++){
	  snd_cp->mac.dflt_srv[i]=gen_mac[i];
	}
	break;
      default:
	printf("No such type\n");
	break;
      }
      printf("\nSend buffer MACs:\n");
      print_macs(snd_cp);
    }
    else if(strcmp(cmnd,"rd_macs_dir")==0){
      n=read_macs_dir(&dp);
      if(n<0){
        printf("Error in controller.  Error type is %d\n",-n);
      }
      else {
        l=0;
        printf("   data    |    parity\n");
        printf("pg:ad  dt  |  pg:ad  dt\n");
        printf("-----------|------------\n");
        while(l<n){
          pg=dp[2*l];
          cnt=dp[2*l+1];
          l++;
          for(j=0;j<cnt;j+=6){
            for(i=j;i<j+3;i++){
              printf("%02X:%02X  %02X  |  ",pg&0xFF,dp[2*l+2*i]&0xFF,dp[2*l+2*i+1]&0xFF);
              printf("%02X:%02X  %02X\n",pg&0xFF,dp[2*l+2*i+6]&0xFF,dp[2*l+2*i+7]&0xFF);
            }
          }
          l+=cnt;
        }
      }
    }
    else if(strcmp(cmnd,"rd_macs_dcd")==0){
      scr_cp = read_macs_dcd();
      if(scr_cp<0){
        printf("Error in controller.  Error type is %d\n",-(int)scr_cp);
      }
      else {
        print_macs(scr_cp);
        if(rcv_cp == NULL){
          rcv_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
        }
        cp_macs(rcv_cp,scr_cp);
        free(scr_cp);
        scr_cp = 0;
      }
    }
    else if(strcmp(cmnd,"cnfg_reg")==0){
      printf("Enter config reg contents in hex: ");
      scanf("%8X",&temp_uint);
      if(snd_cp == NULL){
        snd_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
      }
      printf("ETHER    -- %d\nEXTFIFO  -- %d\nRESET    -- %d\nVME      -- %d\nBTO      -- %d\nBGTO     -- %d\nALL_CRS  -- %d\n",ETHER,EXTFIFO,RESET,VME,BTO,BGTO,ALL_CRS);
      printf("Choose CR ID : ");
      scanf("%d",&crid);
      switch (crid){
      case ETHER:
        snd_cp->ether = (unsigned short int) temp_uint;
        break;
      case EXTFIFO:
        snd_cp->ext_fifo = (unsigned short int) temp_uint;
        break;
      case RESET:
        snd_cp->reset = (unsigned short int) temp_uint;
        break;
      case VME:
        snd_cp->vme = temp_uint;
        break;
      case BTO:
        snd_cp->vme_bto = (unsigned short int) temp_uint;
        break;
      case BGTO:
        snd_cp->vme_bgto = (unsigned short int) temp_uint;
        break;
      default:
	printf("No such type\n");
	break;
      }
      print_crs(snd_cp);
    }
    else if(strcmp(cmnd,"read_crs")==0){
      scr_cp = read_crs();
      print_crs(scr_cp);
      if(rcv_cp == NULL){
        rcv_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
      }
      cp_crs(rcv_cp,scr_cp);
      free(scr_cp);
      scr_cp = 0;
    }
    else if(strcmp(cmnd,"wrt_crs")==0){
      if(snd_cp == NULL){
        printf("No configuration in the send buffer yet!\n");
        printf("Either load configuration from file or\n");
        printf("enter MAC and/or config. reg. manually\n");
        printf("using the mac or cnfg_reg commands.\n");
      }
      else {
        printf("ETHER    -- %d\nEXTFIFO  -- %d\nRESET    -- %d\nVME      -- %d\nBTO      -- %d\nBGTO     -- %d\nALL_CRS  -- %d\n",ETHER,EXTFIFO,RESET,VME,BTO,BGTO,ALL_CRS);
        printf("Choose CR ID : ");
        scanf("%d",&crid);
        wrt_crs(crid,snd_cp);
      }
    }
    else if(strcmp(cmnd,"sc_bits")==0){
      printf("ETHER    -- %d\nEXTFIFO  -- %d\nRESET    -- %d\nVME      -- %d\nBTO      -- %d\nBGTO     -- %d\n",ETHER,EXTFIFO,RESET,VME,BTO,BGTO);
      printf("Choose CR ID : ");
      scanf("%d",&crid);
      printf("Set or Clear bit (s/c) : ");
      scanf("%*c%c",&c);
      sc=(c=='s')?SET:CLR;
      printf("Enter Mask in Hex : ");
      scanf("%8x",&mask);
      set_clr_bits(sc, crid, mask);
    }
    else if(strcmp(cmnd,"upd_lvls")==0){
      sc = SET;
      crid = VME;
      mask = VME_CR_UPD_IRQ;
      set_clr_bits(sc, crid, mask);
    }
    else if(strcmp(cmnd,"prt_buf")==0){
      printf("Receive or Send buffer (r/s): ");
      scanf("%*c%c",&c);
      if(c=='r'){
        if(rcv_cp == NULL){
          printf("Receive buffer is empty\n");
        }
        else {
          print_cnfg(rcv_cp);
        }
      }
      else if(c=='s'){
        if(snd_cp == NULL){
          printf("Send buffer is empty\n");
        }
        else {
          print_cnfg(snd_cp);
        }
      }
      else {
        printf("Must enter 'r' or 's'\n");
      }
    }
    else if(strcmp(cmnd,"cp_buf")==0){
      printf("Receive to Send buffer or\n");
      printf("Send to Receive buffer?\n");
      printf("(r2s/s2r): ");
      scanf("%s",ans);
      if(strcmp(ans,"r2s")==0){
        if(rcv_cp == NULL){
          printf("Receive buffer is empty\n");
        }
        else {
          if(snd_cp == NULL){
            snd_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
          }
          cp_cnfg(snd_cp,rcv_cp);
        }
      }
      else if(strcmp(ans,"s2r")==0){
        if(snd_cp == NULL){
          printf("Send buffer is empty\n");
        }
        else {
          if(rcv_cp == NULL){
            rcv_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
          }
          cp_cnfg(rcv_cp,snd_cp);
        }
      }
      else {
        printf("Must enter 'r2s' or 's2r'\n");
      }
    }
    else if(strcmp(cmnd,"wrt_ser_num")==0){
      ser_num = -1;
      while(ser_num <= 0 || ser_num >= 16777216){
        printf("Enter serial number: ");
        scanf("%d",&ser_num);
        if(ser_num>0 && ser_num<16777216){
          wrt_ser_num(ser_num);
        }
        else {
          printf("Number out of range!\n"); 
          printf("The serial number is a 24 bit number.\n"); 
          printf("It must be positive and < 16777216.\n");
        }
      }
    }
    else if(strcmp(cmnd,"rd_ser_num")==0){
      sn = rd_ser_num();
      if(sn.status==-1){
	printf("The board did not respond. MAC: ");
	print_mac(pmacs[cur_dev]);
      }
      else if(sn.status==-2){
	printf("Received error type %2X from controler\n",sn.err_typ);
      }
      else {
	ser_num = sn.sn;
        printf("This is board: %d\n",ser_num);
      }
    }
    else {
      printf("Unknown command, try again\n");
    }
    printf("Cmnd> ");
    scanf("%s",cmnd);
  }
  eth_close();
}
