#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <signal.h>
#include "codes.h"
#include "eth.h"
#include "pkt_info.h"
#include "slave_dev.h"
#include "cnfg_defs.h"
#include "slave_cnfg_defs.h"
#include "test_defs.h"
#include "mac_utils_dcls.h"
#include "cntrl_subs_dcls.h"

extern char *wbuf;
extern char rbuf[];
extern int nwbuf;
extern int nrbuf;
extern int cur_mac;

extern struct rspn_t response;

extern int ser_num;
extern int bcast,uninit,slave,master,tmp_master;
extern FILE *fplog;
extern CNFG_t std_cnfg;
CNFG_t slv_cnfg;

#define SET_TIMER_SEC 1
#define SET_TIMER_USEC 500000
//#define SET_ST_TO 300000
#define SET_ST_TO 500000
//#define SET_TIMER 5
//#define SET_ST_TO 2000000
#define SET_WAIT_TO 20
#define NWRTFF_RND 703
#define NRDFF_RND 703
#define NWRTFF_PAT 50
#define NRDFF_PAT 50
#define WMAX 4497
#define WMAX 745
#define WLOOP 350
#define NMK_WRDS 4
#define MAX_MSG_SIZE 1024

int num_rq_rlds, num_alrms_rcv, num_missed_strt_up;
int strt_up_rcv, shtdwn_wrn_rcv;
int keep_running;
enum rsts_t cur_rst_typ;

static short int pat[] = {0X5555,0x0000,0X1111,0xAAAA,0xFFFF,0X2222,0X5555,0X8888};
static short int expat[] = {0X5555,0x0000,0X1111,0xAAAA,0xFFFF,0X2222,0X5555,0X8888};
//static short int pat[] = {0x0000,0xFFFF};
//static short int expat[] = {0x0000,0xFFFF};
//static short int pat[] = {0x5555,0xAAAA};
//static short int expat[] = {0x5555,0xAAAA};
//static short int expat[] = {0x525E,0xADA1};
#define NWPAT  (sizeof pat / sizeof(short int))


int test_leds()
{
  int i,j,k,n;
  int l,err;
  int nevt=0;
  int fdw,fdr;
  char ans[10];
  struct rspn_t pstats;
  unsigned int tpat[] = {0x00000000,0xFFFFFFFF,0xAAAAAAAA,0x55555555,
                         0x00000001,0x00000002,0x00000004,0x00000008,
                         0x00000010,0x00000020,0x00000040,0x00000080,
                         0x00000100,0x00000200,0x00000400,0x00000800,
                         0x00001000,0x00002000,0x00004000,0x00008000,
                         0x00010000,0x00020000,0x00040000,0x00080000,
                         0x00100000,0x00200000,0x00400000,0x00800000,
                         0x01000000,0x02000000,0x04000000,0x08000000,
                         0x10000000,0x20000000,0x40000000,0x80000000};
  err = 0;
  for(i=0;i<9000;i++)wbuf[i]=i&0xff;
  printf("\nSet Switch 1 to zero: Ready? (y): ");
  scanf("%s",ans);

  for(j=0;j<4;j++){
    ld_usr_reg(tpat[j]);
    printf("  Pat %2d: %08X : LEDs OK? (y/n): ",j,tpat[j]);
    scanf("%s",ans);
    if(ans[0] == 'n'){
      fprintf(fplog,"  Pat %2d: %08X :....................................................Failed:\n",j,tpat[j]);
      err++;
    }
    else {
      fprintf(fplog,"  Pat %2d: %08X :....................................................Passed:\n",j,tpat[j]);
    }
  }
  printf("  Cycle single bit on:\n");
  for(j=4;j<36;j++){
    ld_usr_reg(tpat[j]);
    usleep(100000);
  }
  printf("  Did each bit light in sequence? (y/n): ");
  scanf("%s",ans);
  if(ans[0] == 'n'){
    fprintf(fplog,"  Pat 4-35  bit on :....................................................Failed:\n");
    err++;
  }
  else {
    fprintf(fplog,"  Pat 4-35  bit on :....................................................Passed:\n");
  }
  printf("  Cycle single bit off:\n");
  for(j=4;j<36;j++){
    ld_usr_reg(~tpat[j]);
    usleep(100000);
  }
  printf("  Did each bit light in sequence? (y/n): ");
  scanf("%s",ans);
  if(ans[0] == 'n'){
    fprintf(fplog,"  Pat 36-67 bit off:....................................................Failed:\n");
    err++;
  }
  else {
    fprintf(fplog,"  Pat 36-67 bit off:....................................................Passed:\n");
  }
  pstats = flush_pkts();
  return err;
}

int test_flash()
{
  int errcnt,errtot,syserr,fl_open;
  enum CMP_MODE cmp;
  char *fl_tst[]  = {"No Test", "Zero's", "FF's", "AA's",
                   "55's", "Incrementing numbers","Decremneting numbers"};
  char *fl_fll[]  = {".............", "..............", "................",
		     "................","................","",""};
  char *cmp_nm[] = {"rbk","00","ff","aa","55","inc","dec"};
  char  flash_fn[128];
  FILE *flash_fp;
  struct rspn_t pstats;
  pstats = flush_pkts();
  errtot = 0;
  for(cmp=ZERO_CMP;cmp<=DEC_CMP;cmp++){
    printf("  Testing Flash with %s:\n",fl_tst[cmp]);
    flash_write(cmp);
    flash_init_rbk();
    errcnt=flash_read(cmp);
    /*
     * open flash data file
     */
    fl_open =0;
    sprintf(flash_fn,"flash/flash_%s.dat",cmp_nm[cmp]);
    if((flash_fp = fopen(flash_fn,"w"))==0){
      printf("    Could not open flash data file. %s\n",flash_fn);
      if(errno==2){
        printf("    No \"flash\" directory found\n");
        printf("    Attempting to create it\n");
        syserr = system("mkdir flash");
        if((flash_fp = fopen(flash_fn,"w"))==0){
          printf("    Still could not open flash data file.\nSystem error %d\nError number %d\n",syserr,errno);
          perror("    test_flash: ");
        }
        else {
          printf("    Success: flash data file is open\n");
          fl_open=1;
        }
      }
      else {
        printf("    Could not open flash data file.\nError number %d\n",errno);
        perror("    test_flash: ");
      }
    }
    else {
      printf("    Success: flash data file is open\n");
      fl_open=1;
    }
    if(errcnt>0){
      fprintf(fplog,"  Found %d errors:\n",errcnt);
      fprintf(fplog,"  Flash test with %s%s..................................Failed:\n",fl_tst[cmp],fl_fll[cmp]);
      errtot+=errcnt;
      if(fl_open){
        flash_print(flash_fp);
        fclose(flash_fp);
      }
    }
    if(errcnt<0){
      fprintf(fplog,"  No valid FLASH data Packet Found :\n",errcnt);
      fprintf(fplog,"  Flash test with %s%s..................................Failed:\n",fl_tst[cmp],fl_fll[cmp]);
      errtot+=-errcnt;
    }
    else {
      fprintf(fplog,"  Flash test with %s%s..................................Passed:\n",fl_tst[cmp],fl_fll[cmp]);
      if(fl_open) fclose(flash_fp); 
    }
  }
  printf("  Returning the Flash memory to \"Blank\" condition:\n");
  flash_write(FF_CMP);
  pstats = flush_pkts();
  return errtot;  
}

int test_cnfg()
{
  int errs,errcnt,cur_dflt,rbk_ser_num;
  extern CNFG_t std_cnfg;
  enum MAC_ID mid;
  enum CR_ID  crid;
  enum SET_CLR sc;
  CNFG_t   scr_cnfg,wrn_cnfg;
  SN_t sn;
  CNFG_ptr rcv_cnfg1,rcv_cnfg2,rcv_cnfg3;
  struct rspn_t pstats;

  pstats = flush_pkts();
  errcnt=0;
  cp_cnfg(&wrn_cnfg,&std_cnfg);
  printf("  Testing Config:\n");

  //Write standard configuration to all CR's
  printf("    Writing CRs:\n");
  wrt_crs(ALL_CRS,&std_cnfg);

  //Write standard MAC addresses
  printf("    Writing MACs:\n");
  set_macs(ALL_MACS,&std_cnfg);

  //MAC address of master may have changed so set cur_mac to master
  cur_mac=master;

  //save the configuration in flash memory as config #0
  printf("    Saving as config #0:\n");
  save_cnfg_num(0);

  //Turn on "warn on shutdown",
  //        "send startup packet" bits,
  //     and enable Hard Resets.
  printf("    Setting warning/startup and Hard Reset bits:\n");
  set_clr_bits(SET, RESET,(RST_CR_HR | RST_CR_WARN | RST_CR_STRTUP));
  wrn_cnfg.reset |= (RST_CR_HR | RST_CR_WARN | RST_CR_STRTUP);
  //save as config #1
  printf("    Saving as config #1:\n");
  save_cnfg_num(1);
  
  /*
   * Verify that configuration was written correctly in flash memory
   */
  rcv_cnfg1 = read_macs_dcd();
  cp_macs(&scr_cnfg,rcv_cnfg1);
  rcv_cnfg2 = read_cnfg_num_dcd(0);
  cp_crs(&scr_cnfg,rcv_cnfg2);
  errs = cmp_cnfg(&std_cnfg,&scr_cnfg);
  if(errs){
    printf("    %d Error(s) in configuration #0:\n",errs);
    fprintf(fplog,"    Configuration #0 Failed with %d errors:\n",errs);
    fprintf(fplog,"    MAC/CR        Expected            Readback\n");
    fprintf(fplog,"    -----------------------------------------------\n");
    log_cnfg_diffs(&std_cnfg,&scr_cnfg);
    printf("    Configuration #0....................................................Failed:\n");
    fprintf(fplog,"    Configuration #0....................................................Failed:\n");
    errcnt = errs;
  }
  else {
    printf("    Configuration #0 was written succesfully:\n");
    printf("    Configuration #0....................................................Passed:\n");
    fprintf(fplog,"    Configuration #0....................................................Passed:\n");
  }
  rcv_cnfg3 = read_cnfg_num_dcd(1);
  cp_crs(&scr_cnfg,rcv_cnfg3);
  errs = cmp_crs(&wrn_cnfg,&scr_cnfg);
  if(errs){
    printf("    %d Error(s) in configuration #1:\n",errs);
    fprintf(fplog,"    Configuration #1 Failed with %d errors:\n",errs);
    fprintf(fplog,"    MAC/CR        Expected            Readback\n");
    fprintf(fplog,"    -----------------------------------------------\n");
    log_cr_diffs(&wrn_cnfg,&scr_cnfg);
    printf("    Configuration #1....................................................Failed:\n");
    fprintf(fplog,"    Configuration #1....................................................Failed:\n");
    errcnt += errs;
  }
  else {
    printf("    Configuration #1 was written succesfully:\n");
    printf("    Configuration #1....................................................Passed:\n");
    fprintf(fplog,"    Configuration #1....................................................Passed:\n");
  }
  free(rcv_cnfg1);
  free(rcv_cnfg2);
  free(rcv_cnfg3);

  /*
   * Verify that configuration registers can be restored correctly
   */
  rcv_cnfg1 = read_crs(); //should be cnfg #1
  cp_macs(&scr_cnfg,rcv_cnfg1);
  rstr_cnfg_num(0);
  rcv_cnfg2 = read_crs();
  errs = cmp_crs(&wrn_cnfg,&scr_cnfg);
  if(errs){
    printf("    %d Error(s) in reading CRs:\n",errs);
    fprintf(fplog,"    Read CRs Failed with %d errors:\n",errs);
    fprintf(fplog,"    MAC/CR        Expected            Readback\n");
    fprintf(fplog,"    -----------------------------------------------\n");
    log_cr_diffs(&wrn_cnfg,&scr_cnfg);
    printf("    Configuration Register Read.........................................Failed:\n");
    fprintf(fplog,"    Configuration Register Read.........................................Failed:\n");
    errcnt += errs;
  }
  else {
    printf("    CRs were read succesfully:\n");
    printf("    Configuration Register Read.........................................Passed:\n");
    fprintf(fplog,"    Configuration Register Read.........................................Passed:\n");
  }
  errs = cmp_crs(&std_cnfg,rcv_cnfg2);
  if(errs){
    printf("    %d Error(s) in restoring CRs:\n",errs);
    fprintf(fplog,"    Restoring CRs Failed with %d errors:\n",errs);
    fprintf(fplog,"    MAC/CR        Expected            Readback\n");
    fprintf(fplog,"    -----------------------------------------------\n");
    log_cr_diffs(&std_cnfg,rcv_cnfg2);
    printf("    Configuration Register Restore......................................Failed:\n");
    fprintf(fplog,"    Configuration Register Restore......................................Failed:\n");
    errcnt += errs;
  }
  else {
    printf("    CRs were restored succesfully:\n");
    printf("    Configuration Register Restore......................................Passed:\n");
    fprintf(fplog,"    Configuration Register Restore......................................Passed:\n");
  }
  free(rcv_cnfg1);
  free(rcv_cnfg2);

  //Set the default configuration to config #0
  printf("    Setting default configuration to config #0:\n");
  set_cnfg_dflt(0);
  cur_dflt = read_cnfg_dflt();
  if(cur_dflt!=0){
    printf("    Error: The default configuration is wrong (read %d expected 0):\n",cur_dflt&0xFF);
    fprintf(fplog,"    Setting Configuration Default Failed:\n");
    fprintf(fplog,"      Expected: 00    Readback: %02d\n\n",cur_dflt&0xFF);
    printf("    Setting Configuration Default.......................................Failed:\n");
    fprintf(fplog,"    Setting Configuration Default.......................................Failed:\n");
    errcnt++;
  }
  else {
    printf("    Setting Configuration Default.......................................Passed:\n");
    fprintf(fplog,"    Setting Configuration Default.......................................Passed:\n");
  }

  //Write the serial number
  printf("    Writing the serial number:\n");
  wrt_ser_num(ser_num);
  sn = rd_ser_num();
  if(sn.status==-1){
    printf("Did not get a response.\n");
    errcnt++;
    rbk_ser_num=0;
  }
  else if(sn.status==-2){
    printf("Received error type %2X from controler\n",sn.err_typ);
    errcnt++;
    rbk_ser_num=0;
  }
  else {
    rbk_ser_num = sn.sn;
  }
  if(rbk_ser_num!=ser_num){
    printf("    Error: The serial number did not get set (read %d expected %d):\n",rbk_ser_num,ser_num);
    fprintf(fplog,"    Writing the Serial Number Failed:\n");
    fprintf(fplog,"      Expected: %d    Readback: %d\n\n",ser_num,rbk_ser_num);
    printf("    Writing the Serial Number...........................................Failed:\n");
    fprintf(fplog,"    Writing the Serial Number...........................................Failed:\n");
    errcnt++;
  }
  else {
    printf("    The serial number is now %d:\n",rbk_ser_num);
    printf("    Writing the Serial Number...........................................Passed:\n");
    fprintf(fplog,"    Writing the Serial Number...........................................Passed:\n");
  }
  return errcnt;  
}

int test_resets()
{
  int int_errcnt,fp_errcnt,hrd_errcnt;
  int i,j,n,l;
  extern int pre_prod;
  struct rspn_t pstats;

  pstats = flush_pkts();
  //Set the default configuration to config #1
  //(warn on shutdown and start up packets) 
  printf("    Setting default configuration to config #1:\n");
  set_cnfg_dflt(1);
  rstr_cnfg_num(1);

  //system initialization
  signal(SIGALRM,alrm_hndlr);
  eth_read_timeout(RD_TMO_short);
  /*
   * Test Internal (command generated) Reset
   */
  printf("\n  Testing Internal Reset:\n");
  fprintf(fplog,"\n  Testing Internal Reset:\n");
  int_errcnt = cycle_reloads(INT_RSTS);
  if(int_errcnt){
    printf("    Internal reload command failed with %d errors\n",int_errcnt);
    fprintf(fplog,"    Internal reload command failed with %d errors\n",int_errcnt);
    printf("    Internal reload command.............................................Failed:\n");
    fprintf(fplog,"    Internal reload command.............................................Failed:\n");
  }
  else {
    printf("    Internal reload command.............................................Passed:\n");
    fprintf(fplog,"    Internal reload command.............................................Passed:\n");
  }
  /*
   * Test Front Panel Reset button
   */
  printf("\n  Testing Front Panel Reset:\n");
  fprintf(fplog,"\n  Testing Front Panel Reset:\n");
  printf("    Push Front Panel Reset Button at will\n");
  printf("    Wait 3-5 seconds between pushes\n\n");
  fp_errcnt = cycle_reloads(FP_RSTS);
  if(fp_errcnt){
    printf("    Front Panel Reset Failed with %d errors\n",fp_errcnt);
    fprintf(fplog,"    Front Panel Reset Failed with %d errors\n",fp_errcnt);
    printf("    Front Panel Reset...................................................Failed:\n");
    fprintf(fplog,"    Front Panel Reset...................................................Failed:\n");
  }
  else {
    printf("    Front Panel Reset...................................................Passed:\n");
    fprintf(fplog,"    Front Panel Reset...................................................Passed:\n");
  }
  /*
   * Test CMS backplane Hard Resets
   */
  if(!pre_prod){
    printf("\n  Testing CMS Backplane Hard Reset:\n");
    fprintf(fplog,"\n  Testing CMS Backplane Hard Reset:\n");
    hrd_errcnt = cycle_reloads(HRD_RSTS);
    if(hrd_errcnt){
      printf("    Hard Resets Testing Failed with %d errors\n",hrd_errcnt);
      fprintf(fplog,"    Hard Resets Testing Failed with %d errors\n",hrd_errcnt);
      printf("    Hard Resets Testing.................................................Failed:\n");
      fprintf(fplog,"    Hard Resets Testing.................................................Failed:\n");
    }
    else {
      printf("    Hard Resets Testing.................................................Passed:\n");
      fprintf(fplog,"    Hard Resets Testing.................................................Passed:\n");
    }
  }
  printf("    Restoring default configuration to config #0:\n");
  set_cnfg_dflt(0);
  rstr_cnfg_num(0);
  eth_read_timeout(RD_TMO_short);
  return int_errcnt + fp_errcnt + hrd_errcnt;  
}

int cycle_reloads(enum rsts_t reset_type)
{
  int errcnt;
  int i,j,n,l;
  int num_warns_rcvd,num_start_ups,num_other;
  int nfppush;
  int seterr;
  unsigned short int source,msgtype,msgcode;
  enum pkt_t type;
  struct itimerval set_tmr,old_tmr,cur_time;

  old_tmr.it_interval.tv_sec=0;
  old_tmr.it_interval.tv_usec=0;
  old_tmr.it_value.tv_sec=0;
  old_tmr.it_value.tv_usec=0;

  keep_running=1;
  cur_rst_typ=reset_type;
  num_warns_rcvd = 0;
  num_start_ups = 0;
  num_other = 0;
  num_rq_rlds = 0;
  num_alrms_rcv = 0;
  num_missed_strt_up = 0;
  strt_up_rcv = 0;
  shtdwn_wrn_rcv = 0;
  printf("    Alarms Reqs  Warn St_ups Missed Others\n");
  printf("    --------------------------------------\n");
  fprintf(fplog,"    Alarms Reqs  Warn St_ups Missed Others\n");
  fprintf(fplog,"    --------------------------------------\n");
  if(reset_type == FP_RSTS){
    set_tmr.it_interval.tv_sec=SET_WAIT_TO;
    set_tmr.it_interval.tv_usec=0;
    set_tmr.it_value.tv_sec=SET_WAIT_TO;
    set_tmr.it_value.tv_usec=0;
  }
  else {
    set_tmr.it_interval.tv_sec=SET_TIMER_SEC;
    set_tmr.it_interval.tv_usec=SET_TIMER_USEC;
    set_tmr.it_value.tv_sec=SET_TIMER_SEC;
    set_tmr.it_value.tv_usec=SET_TIMER_USEC;
  }
  setitimer(ITIMER_REAL,&set_tmr,&old_tmr);
  while(keep_running){
    for(i=0;i<30;i++)rbuf[i]=0;
    n=eth_read();
    getitimer(ITIMER_REAL,&cur_time);
    if(n>6){
      type = rbuf[PKT_TYP_OFF]&0xff;
      source  = SOURCE_ID(rbuf);
      msgtype = MSG_TYP_ID(rbuf);
      msgcode = UNV_CODE_WRD(rbuf);
      //      printf("pkt_typ  = %02X\n",type&0xFF);
      //      printf("source   = %01X\n",source&0xF);
      //      printf("msg_type = %01X\n",msgtype&0xF);
      //      printf("msg_code = %03X\n",msgcode&0xFFF);
      switch(msgcode){
      case SS_Rld_Pndg:
        num_warns_rcvd++;
        if(reset_type == FP_RSTS){
          if(shtdwn_wrn_rcv==1){
            num_missed_strt_up++;
          }
        }
        else {
          set_tmr.it_interval.tv_sec=SET_TIMER_SEC-1;
          set_tmr.it_interval.tv_usec=SET_TIMER_USEC+1000000-SET_ST_TO;
          set_tmr.it_value.tv_sec=0;
          set_tmr.it_value.tv_usec=SET_ST_TO;
          seterr = setitimer(ITIMER_REAL,&set_tmr,&old_tmr);
        }
        strt_up_rcv = 0;
        shtdwn_wrn_rcv = 1;
        break;
      case SS_Sys_Up:
        num_start_ups++;
        if((reset_type == INT_RSTS) || (reset_type == HRD_RSTS)){
          set_tmr.it_interval.tv_sec=SET_TIMER_SEC;
          set_tmr.it_interval.tv_usec=SET_TIMER_USEC;
          set_tmr.it_value.tv_sec=SET_TIMER_SEC;
          set_tmr.it_value.tv_usec=SET_TIMER_USEC;
          seterr = setitimer(ITIMER_REAL,&set_tmr,&old_tmr);
        }
        strt_up_rcv = 1;
        shtdwn_wrn_rcv = 0;
        break;
      default:
        num_other++;
        strt_up_rcv = 0;
        shtdwn_wrn_rcv = 0;
        for(i=0;i<n;i++){
          printf("%02X",rbuf[i]&0xFF);
        }
        printf("\n");
        break;
      }
    }
    printf("      %2d    %2d    %2d    %2d     %2d     %2d : %6.3f\n",num_alrms_rcv,num_rq_rlds,num_warns_rcvd,num_start_ups,num_missed_strt_up,num_other,cur_time.it_value.tv_sec+((double)cur_time.it_value.tv_usec/1000000));
    fprintf(fplog,"      %2d    %2d    %2d    %2d     %2d     %2d\n",num_alrms_rcv,num_rq_rlds,num_warns_rcvd,num_start_ups,num_missed_strt_up,num_other);
  }
  // disable timer
  set_tmr.it_interval.tv_sec=0;
  set_tmr.it_interval.tv_usec=0;
  set_tmr.it_value.tv_sec=0;
  set_tmr.it_value.tv_usec=0;
  seterr = setitimer(ITIMER_REAL,&set_tmr,&old_tmr);
  printf("           Alarms received: %d\n",num_alrms_rcv);
  printf("       Shutdowns requested: %d\n",num_rq_rlds);
  printf("         Warnings received: %d\n",num_warns_rcvd);
  printf("        Start-ups received: %d\n",num_start_ups);
  printf("        Start-ups   missed: %d\n",num_missed_strt_up);
  printf("    Other packets received: %d\n",num_other);
  fprintf(fplog,"           Alarms received: %d\n",num_alrms_rcv);
  fprintf(fplog,"       Shutdowns requested: %d\n",num_rq_rlds);
  fprintf(fplog,"         Warnings received: %d\n",num_warns_rcvd);
  fprintf(fplog,"        Start-ups received: %d\n",num_start_ups);
  fprintf(fplog,"        Start-ups   missed: %d\n",num_missed_strt_up);
  fprintf(fplog,"    Other packets received: %d\n",num_other);
  if(reset_type == FP_RSTS){
    printf("\n    Enter the number of times the Front Panel Reset was pushed: ");
    scanf("%d",&nfppush);
    errcnt = num_missed_strt_up+abs(nfppush-num_warns_rcvd)+abs(nfppush-num_start_ups);
  }
  else {
    errcnt = num_missed_strt_up+abs(num_rq_rlds-num_warns_rcvd)+abs(num_rq_rlds-num_start_ups);
  }
  return errcnt;
}


void alrm_hndlr(int sig_num)
{
  struct itimerval cur_tm;
  switch(sig_num){
    case SIGALRM:
      num_alrms_rcv++;
      switch(cur_rst_typ){
        case FP_RSTS:
          keep_running = 0;
          break;
        case INT_RSTS:
        case HRD_RSTS:
          if(num_alrms_rcv>5){
            keep_running = 0;
          }
          else if((strt_up_rcv == 0) && (shtdwn_wrn_rcv == 1)){
            num_missed_strt_up++;
            shtdwn_wrn_rcv = 0;
          }
          else {
            if(cur_rst_typ == INT_RSTS){
              force_reload();
              fprintf(fplog,"    Reload!\n");
            }
            else {
              gen_hrd_rst();
              fprintf(fplog,"    Hard Reset!\n");
            }
            num_rq_rlds++;
          }
          break;
        default:
          break;
      }
      break;
    default:
      printf("    Unknown signal!\n");
      break;
  }
}

void gen_hrd_rst(){
  cur_mac=slave;
  wbuf[0]=0x00;
  wbuf[1]=Gen_Hard_Rst;
  nwbuf = 2;
  eth_write();
  printf("    Hard Reset!\n");
  cur_mac=master;
}

void gen_intr(){
  cur_mac=slave;
  wbuf[0]=0x00;
  wbuf[1]=Gen_Intr;
  nwbuf = 2;
  eth_write();
  printf("    Generating Interrupt\n");
  cur_mac=master;
}


int test_fifo()
{
  int i,j,k,l,n,lp,strt;
  int rderr,errcnt,pat_errcnt,rnd_errcnt,mark_errcnt;
  int rbk_mrk_errs;
  int rtr_mrk_errs;
  int ffrderrs;
  unsigned int full_off, mt_off;
  unsigned int rbk_fl_off, rbk_mt_off;
  unsigned short int rbk_mk[NMK_WRDS];
  unsigned short int rtr_mk[NMK_WRDS];
  unsigned short int cmp_mk[NMK_WRDS];
  enum src_id srcid;
  struct rspn_t pstats;

  pstats = flush_pkts();
  printf("\n  Testing FIFO offsets:\n");
  fprintf(fplog,"\n  Testing FIFO offsets:\n");

  errcnt=0;

  // initialize FIFO
  // Put controller in FIFO test mode

  set_ff_test_mode();
  mrst_ff();
  full_off = 0x28421;
  mt_off   = 0X15A5A;
  prg_off(full_off,mt_off);
  rderr = rdbk_off(&rbk_fl_off,&rbk_mt_off);
  if(rderr<0){
    printf("    Error while reading Offsets: %s\n",dcode_msg_pkt(rbuf));
    fprintf(fplog,"    Error while reading Offsets: %s\n",dcode_msg_pkt(rbuf));
    errcnt++;
  }
  if((rbk_fl_off != full_off) || (rbk_mt_off != mt_off)){
    printf("    Error found in FIFO offsets\n");
    printf("            Full    Empty\n");
    printf("    ------------------------\n");
    printf("    Exp: |  %05X   %05X\n",full_off,mt_off);
    printf("    Rbk: |  %05X   %05X\n",rbk_fl_off,rbk_mt_off);
    fprintf(fplog,"    Error found in FIFO offsets\n");
    fprintf(fplog,"            Full    Empty\n");
    fprintf(fplog,"    ------------------------\n");
    fprintf(fplog,"    Exp: |  %05X   %05X\n",full_off,mt_off);
    fprintf(fplog,"    Rbk: |  %05X   %05X\n",rbk_fl_off,rbk_mt_off);
    printf("    FIFO offsets........................................................Failed:\n");
    fprintf(fplog,"    FIFO offsets........................................................Failed:\n");
  }
  else {
    printf("    FIFO offsets Read Successfully\n");
    printf("    FIFO offsets........................................................Passed:\n");
    fprintf(fplog,"    FIFO offsets........................................................Passed:\n");
  }
  full_off = 0;
  mt_off   = 0;
  prg_off(full_off,mt_off);
  rst_mark();
  disable_inj_errs();
  //  enable_inj_errs(); // for reading out parity bits using special firmware
  disable_ECC(); 

  printf("\n  Testing FIFO with bit patterns (no ECC; no INJ):\n");
  fprintf(fplog,"\n  Testing FIFO with bit patterns (no ECC; no INJ):\n");
  fflush(fplog);
  pat_errcnt = exercise_fifo(PATTERNS);
  if(pat_errcnt>0){
    printf("    Pattern Test (no ECC) %6d errors.................................Failed:\n",pat_errcnt);
    fprintf(fplog,"    Pattern Test (no ECC) %6d errors.................................Failed:\n",pat_errcnt);
    errcnt+=pat_errcnt;
  }
  else if(pat_errcnt<0){
    printf("    Pattern Test (no ECC) FIFO Error....................................Failed:\n");
    fprintf(fplog,"    Pattern Test (no ECC) FIFO Error....................................Failed:\n");
    errcnt+=-pat_errcnt;
  }
  else {
    printf("    Pattern Test (no ECC)...............................................Passed:\n");
    fprintf(fplog,"    Pattern Test (no ECC)...............................................Passed:\n");
  }

  printf("\n  Testing FIFO with random words (no ECC; no INJ):\n");
  fprintf(fplog,"\n  Testing FIFO with random words (no ECC; no INJ):\n");
  rnd_errcnt = exercise_fifo(RANDOMS);
  if(rnd_errcnt>0){
    printf("    Random Test (no ECC) %6d errors..................................Failed:\n",rnd_errcnt);
    fprintf(fplog,"    Random Test (no ECC) %6d errors..................................Failed:\n",rnd_errcnt);
    errcnt+=rnd_errcnt;
  }
  else if(rnd_errcnt<0){
    printf("    Random Test (no ECC) FIFO Error.....................................Failed:\n");
    fprintf(fplog,"    Random Test (no ECC) FIFO Error.....................................Failed:\n");
    errcnt+=-rnd_errcnt;
  }
  else {
    printf("    Random Test (no ECC)................................................Passed:\n");
    fprintf(fplog,"    Random Test (no ECC)................................................Passed:\n");
  }


  enable_inj_errs();
  enable_ECC();

  printf("\n  Testing FIFO with bit patterns (ECC and INJ):\n");
  fprintf(fplog,"\n  Testing FIFO with bit patterns (ECC and INJ):\n");
  pat_errcnt = exercise_fifo(PATTERNS);
  if(pat_errcnt>0){
    printf("    Pattern Test (with ECC) %6d errors...............................Failed:\n",pat_errcnt);
    fprintf(fplog,"    Pattern Test (with ECC) %6d errors...............................Failed:\n",pat_errcnt);
    errcnt+=pat_errcnt;
  }
  else if(pat_errcnt<0){
    printf("    Pattern Test (with ECC) FIFO Error..................................Failed:\n");
    fprintf(fplog,"    Pattern Test (with ECC) FIFO Error..................................Failed:\n");
    errcnt+=-pat_errcnt;
  }
  else {
    printf("    Pattern Test (with ECC).............................................Passed:\n");
    fprintf(fplog,"    Pattern Test (with ECC).............................................Passed:\n");
  }

  printf("\n  Testing FIFO with random words (ECC and INJ):\n");
  fprintf(fplog,"\n  Testing FIFO with random words (ECC and INJ):\n");
  rnd_errcnt = exercise_fifo(RANDOMS);
  if(rnd_errcnt>0){
    printf("    Random Test (with ECC) %6d errors................................Failed:\n",rnd_errcnt);
    fprintf(fplog,"    Random Test (with ECC) %6d errors................................Failed:\n",rnd_errcnt);
    errcnt+=rnd_errcnt;
  }
  else if(rnd_errcnt<0){
    printf("    Random Test (with ECC) FIFO Error...................................Failed:\n");
    fprintf(fplog,"    Random Test (with ECC) FIFO Error...................................Failed:\n");
    errcnt+=-rnd_errcnt;
  }
  else {
    printf("    Random Test (with ECC)..............................................Passed:\n");
    fprintf(fplog,"    Random Test (with ECC)..............................................Passed:\n");
  }

  disable_inj_errs();

  printf("\n  Testing FIFO MARK and ReTransmit features:\n");
  fprintf(fplog,"\n  Testing FIFO MARK and ReTransmit features:\n");

  strt=0;
  for(i=0;i<WLOOP;i++){
    for(j=strt;j<strt+WMAX;j++){
      wbuf[2*(j-strt)+2]=(j>>8)&0xFF;
      wbuf[2*(j-strt)+3]=j&0xFF;
    }
    wrt_ff(WMAX);
    strt=j;
  }

  rbk_mrk_errs =0;
  rtr_mrk_errs =0;
  ffrderrs =0;
  for(i=0;i<5;i++){
    for(k=0;k<NMK_WRDS;k++)cmp_mk[k]=i*NMK_WRDS+k;
    set_mark();
    n=rd_ff(NMK_WRDS,0,rbk_mk);
    if(n<=0){
      printf("    Error while reading FIFO:(RD): %s\n",dcode_msg_pkt(rbuf));
      ffrderrs++;
      n = -n;
    }
    for(l=0;l<n;l++){
      if((rbk_mk[l] != cmp_mk[l])){
        rbk_mrk_errs++;
        printf("    cmp:%04hX -- rbk:%04hX\n",cmp_mk[l],rbk_mk[l]);
        fprintf(fplog,"    cmp:%04hX -- rbk:%04hX\n",cmp_mk[l],rbk_mk[l]);
      }
    }
    for(j=0;j<5;j++){
      n=rd_ff(NMK_WRDS,1,rtr_mk);
      if(n<=0){
	printf("    Error while reading FIFO:(RT): %s\n",dcode_msg_pkt(rbuf));
        ffrderrs++;
        n = -n;
      }
      for(l=0;l<n;l++){
        if((rtr_mk[l] != rbk_mk[l])){
          rtr_mrk_errs++;
          printf("    rbk:%04hX -- rtr:%04hX\n",rbk_mk[l],rtr_mk[l]);
          fprintf(fplog,"    rbk:%04hX -- rtr:%04hX\n",rbk_mk[l],rtr_mk[l]);
        }
      }
    }
    rst_mark();
  }
  if(rbk_mrk_errs != 0 || rtr_mrk_errs !=0 || ffrderrs != 0){
    printf("    Mark Error: %4d readback errors and %4d retransmit errors, and %d FIFO Read errors found:\n",rbk_mrk_errs,rtr_mrk_errs,ffrderrs);
    fprintf(fplog,"    Mark Error: %4d readback errors and %4d retransmit errors, and %d FIFO Read errors found:\n",rbk_mrk_errs,rtr_mrk_errs,ffrderrs);
    mark_errcnt = rbk_mrk_errs+rtr_mrk_errs+ffrderrs;
    printf("    Mark Test: %6d errors............................................Failed:\n",mark_errcnt);
    fprintf(fplog,"    Mark Test: %6d errors............................................Failed:\n",mark_errcnt);
    errcnt+=mark_errcnt;
  }
  else {
    printf("    Mark Test...........................................................Passed:\n");
    fprintf(fplog,"    Mark Test...........................................................Passed:\n");
  }

  //  disable_inj_errs();

  mrst_ff();       //Clear the FIFO before setting VME mode!!
  set_VME_mode();  //or the VME controller will choke on garbage.
  return errcnt;  
}


int exercise_fifo(enum fftest_t fftest)
{
  int errcnt,rderr;
  int i,j,k,l,n,lp,nwwrds,nrwrds;
  unsigned int x,cor,uncor;
  short int rbx,errword,exp_dat,rnd_buf[4500];
  int numwrds;
  float ucf;
  enum pkt_t pkt_type;
  struct rspn_t pstats;

  eth_read_timeout(RD_TMO_short);
  rst_err_cnt();
  for(i=0;i<9000;i++)wbuf[i]=0;
  for(i=0;i<9000;i++)rbuf[i]=0;
  // reset FIFO
  prst_ff();
  errcnt=0;
  for(lp=0;lp<1000 && errcnt<1000;lp++){
    // Write FIFO
    if(fftest==PATTERNS){
      nwwrds=NWPAT*NWRTFF_PAT;
      nrwrds=NWPAT*NRDFF_PAT;
      for(i=0;i<NWRTFF_PAT;i++){
	for(j=0;j<NWPAT;j++){
	  wbuf[2*NWPAT*i+2*j+2]=(pat[j]>>8)&0xFF;
	  wbuf[2*NWPAT*i+2*j+3]=pat[j]&0xFF;
	}
      }
    }
    else {
      nwwrds=NWRTFF_RND;
      nrwrds=NRDFF_RND;
      for(i=0;i<NWRTFF_RND;i++){
	x = (int)(65535*((float)rand()/RAND_MAX));
	wbuf[2*i+2]=(x>>8)&0xFF;
	wbuf[2*i+3]=x&0xFF;
	rnd_buf[i]=x;
      }
    }
    wrt_ff(nwwrds);
    for(i=0;i<9000;i++)wbuf[i]=0;
    wbuf[0]=0x20;
    wbuf[1]=Rd_Ext_FF;
    wbuf[2]=((nrwrds)>>24)&0XFF;
    wbuf[3]=((nrwrds)>>16)&0XFF;
    wbuf[4]=((nrwrds)>>8)&0XFF;
    wbuf[5]=(nrwrds)&0XFF;
    nwbuf=6;
    n=eth_write();
    for(i=0;i<9000;i++)rbuf[i]=0;
    do{
      n=eth_read();
      pkt_type = rbuf[PKT_TYP_OFF] & 0xFF;
      if(pkt_type==EXFIFO_PKT){
	numwrds = ((rbuf[WRD_CNT_OFF]&0xff)<<8)|(rbuf[WRD_CNT_OFF+1]&0xff);
	if(numwrds != nrwrds){
	  printf("    Did NOT receive the requested number or words!\n");
	  printf("    Requested %d words:  Received %d words.\n",nrwrds,numwrds);
	}
	for(i=0;i<numwrds;i++){
	  rbx=((rbuf[2*i+DATA_OFF]&0xFF)<<8)|(rbuf[2*i+DATA_OFF+1]&0xFF);
	  errword = (fftest==PATTERNS) ? expat[i%NWPAT]^rbx : rnd_buf[i]^rbx;
	  exp_dat = (fftest==PATTERNS) ? expat[i%NWPAT] : rnd_buf[i];
	  if(errword != 0){
	    errcnt++;
	    if((errcnt%100)==0){
	      //	  if((errcnt%1)==0){
	      printf("    error # %8d: %04hX %04hX %04hX %04hd  %d\n",errcnt,exp_dat,rbx,errword,i,lp*nrwrds+i);
	      fprintf(fplog,"    error # %8d: %04hX %04hX %04hX %04hd  %d\n",errcnt,exp_dat,rbx,errword,i,lp*nrwrds+i);
	    }
	  }
	}
      }
      else if(pkt_type==INFO_PKT){
        if(UNV_CODE_WRD(rbuf)!=0x20D){
	  printf("    %s",dcode_msg_pkt(rbuf));
	}
      }
      else if(pkt_type==WARN_PKT){
	printf("    Warning while reading FIFO: %s\n",dcode_msg_pkt(rbuf));
	fprintf(fplog,"    Warning while reading FIFO: %s\n",dcode_msg_pkt(rbuf));
      }
      else if(pkt_type==ERR_PKT){
	printf("    Error while reading FIFO: %s\n",dcode_msg_pkt(rbuf));
	fprintf(fplog,"    Error while reading FIFO: %s\n",dcode_msg_pkt(rbuf));
        pstats = flush_pkts();
	return -1;
      }
      else {
	printf("    Received unexpected packet type!\n");
	for(i=0;i<n;i++)printf("%02X",rbuf[i]&0xFF);
	printf("\n");
        pstats = flush_pkts();
	return -1;
      }
    } while(eth_get_pkts_left()>0);
  }
  rderr = rd_err_cnts(&cor, &uncor);
  if(rderr<0){
    printf("    Error while reading error counts: %s\n",dcode_msg_pkt(rbuf));
    fprintf(fplog,"    Error while reading error counts: %s\n",dcode_msg_pkt(rbuf));
  }
  printf("      Uncorrected   Corrected\n");
  printf("         Errors      Errors\n");
  printf("    ----------------------------\n");
  printf("     %10d    %10d\n",uncor,cor);
  fprintf(fplog,"      Uncorrected   Corrected\n");
  fprintf(fplog,"         Errors      Errors\n");
  fprintf(fplog,"    ----------------------------\n");
  fprintf(fplog,"     %10d    %10d\n",uncor,cor);

  if(cor>0){
    printf("    Warning: There are corrected errors.\n");
    fprintf(fplog,"    Warning: There are corrected errors.\n");
  }

  ucf =(float) uncor/(lp*nrwrds);
  if(ucf>0.00097 && ucf<0.00098)errcnt-=uncor;
  printf("    Total errors = %d :: Total cycles = %d\n",errcnt,lp);
  fprintf(fplog,"    Total errors = %d :: Total cycles = %d\n",errcnt,lp);
  return errcnt;
}


int test_vme()
{
int errcnt;

  struct rspn_t pstats;

  pstats = flush_pkts();
  // set configuration to std_cnfg
  //Write standard configuration to all CR's
  printf("    Writing CRs:\n");
  wrt_crs(ALL_CRS,&std_cnfg);

  printf("  Testing VME:\n");
  set_VME_mode();
  prst_ff();
  init_slave();

  set_clr_bits(SET, VME, VME_CR_HIGH); // Enable high order bits.

  errcnt=0;
#ifdef TEST_DTB
  errcnt += vme_dtb();
#endif
#ifdef TEST_AM
  errcnt += vme_am();
#endif
#ifdef TEST_ARB
  errcnt += vme_arb();
#endif
#ifdef TEST_INTR
  errcnt += vme_intr();
#endif
#ifdef TEST_BERR
  errcnt += vme_berr();
#endif
#ifdef TEST_DLY
  errcnt += vme_dly();
#endif
  return errcnt;  
}

