#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <signal.h>
#include "codes.h"
#include "eth.h"
#include "pkt_info.h"
#include "slave_dev.h"
#include "cnfg_defs.h"
#include "slave_cnfg_defs.h"
#include "test_defs.h"
#include "cntrl_subs_dcls.h"

extern char *wbuf;
extern int nwbuf;
extern char rbuf[];
extern int nrbuf;
extern int cur_mac;

extern int ser_num;
extern int bcast,uninit,slave,master,tmp_master;
extern FILE *fplog;

#define DATA_BUF_SIZE 1024
#define D64_LOW_OFF (DATA_BUF_SIZE / 2)

unsigned int data[DATA_BUF_SIZE];
unsigned int rtn_buf[DATA_BUF_SIZE];




static unsigned int pat64b[] = {0x00000000,0xFFFFFFFF,
				0x55555555,0xAAAAAAAA,
				0x99999999,0x66666666,
				0xCCCCCCCC,0x33333333};
static unsigned int slot = 11;
static int b_addr[] = {0x0000,0x0800,0x1000,0x2000,0x3000,0x3008};

static int dev_mask[]  = {0xFFFFFFFF,  //NONE
			  0xFFFFF800,  //A16
			  0xFFFFC000,  //A24
			  0xFFFFC000,  //A32
			  0xFFFFC000,  //A40
			  0xFFFFC000}; //A64

static int slot_mask_l[] = {0x00000000,  //NONE
			    0x000007FF,  //A16
			    0x0007FFFF,  //A24
			    0x07FFFFFF,  //A32
			    0xFFFFFFFF,  //A40
			    0xFFFFFFFF}; //A64

static int slot_mask_h[] = {0x00000000,  //NONE
			    0x00000000,  //A16
			    0x00000000,  //A24
			    0x00000000,  //A32
			    0x00000007,  //A40
			    0x07FFFFFF}; //A64

static int slot_shft[] = { 0,  //NONE
			   11,  //A16
			   19,  //A24
			   27,  //A32
			   35,  //A40
			   59}; //A64

struct rspn_t response;
enum SLV_DEV dev;
enum TRNS_TYP tt;
enum DATA_SZ  dsz,rdsz; 
enum WRT_RD wrt;
enum ADDR_SZ asz;
enum DLY_TYP dt;
VCMD_t a24mblt,amvc,a24d16,dly16us;
int aoff;

extern CNFG_t std_cnfg;
extern CNFG_t slv_cnfg;

static unsigned char amt[] = {0x00, 0x01, 0x03, 0x08,
			      0x09, 0x0A, 0X0B, 0X0C,
			      0x0D, 0x0E, 0X0F, 0X29,
			      0x2D, 0x34, 0X37, 0X38,
			      0x39, 0x3A, 0X3B, 0X3C,
			      0x3D, 0x3E, 0X3F};

static unsigned int cwrd[] = { 0x00BD, 0x00B8, 0x00B9, 0x007D,
			       0x0078, 0x0878, 0x0079, 0x107D,
			       0x1078, 0x1878, 0x1079, 0x0034,
			       0x1034, 0x0098, 0x0099, 0x005D,
			       0x0058, 0x0858, 0x0059, 0x105D,
			       0x1058, 0x1858, 0x1059};

#define NAM_TESTS sizeof cwrd / sizeof(unsigned int)

static enum SLV_DEV devl[] = { MEMB64, MEMA32, MEMA32, MEMB64,
			       MEMA32, MEMA32, MEMA32, MEMB64,
			       MEMA32, MEMA32, MEMA32, MEMA16,
			       MEMA16, MEMA32, MEMA32, MEMB64,
			       MEMA32, MEMA32, MEMA32, MEMB64,
			       MEMA32, MEMA32, MEMA32};

static enum pkt_t exp_dat[] = { VMED64_PKT, VMED32_PKT, VMED32_PKT, VMED64_PKT,
				VMED32_PKT, VMED32_PKT, VMED32_PKT, VMED64_PKT,
				VMED32_PKT, VMED32_PKT, VMED32_PKT, VMED16_PKT,
				VMED16_PKT, VMED32_PKT, VMED32_PKT, VMED64_PKT,
				VMED32_PKT, VMED32_PKT, VMED32_PKT, VMED64_PKT,
				VMED32_PKT, VMED32_PKT, VMED32_PKT};

static unsigned int ppmaska = 0x00FFFFFF;
static unsigned int ppmaskd = 0x0000FFFF;
static unsigned int ppammaska[] = {0x00000000, 0x00000000, 0x00000000, 0x00000000,
                                   0x00000000, 0x00000000, 0x00000000, 0x00000000,
                                   0x00000000, 0x00000000, 0x00000000, 0xFFFFFFFF,
                                   0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0x00FFFFFF,
                                   0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0x00FFFFFF,
                                   0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF};
static unsigned int ppammaskd[] = {0x00000000, 0x00000000, 0x00000000, 0x00000000,
                                   0x00000000, 0x00000000, 0x00000000, 0x00000000,
                                   0x00000000, 0x00000000, 0x00000000, 0xFFFFFFFF,
                                   0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0x0000FFFF,
                                   0x0000FFFF, 0x0000FFFF, 0x0000FFFF, 0x0000FFFF,
                                   0x0000FFFF, 0x0000FFFF, 0x0000FFFF};


int vme_dtb()
{
int i,j,k,l,n,nvu;
int errcnt,wrdcnt;
int dcnt,derr,derrs,exerr,exerrs;
unsigned int exphigh,explow;
extern int pre_prod;
unsigned int maska,maskd;

  if(pre_prod){
    maska=ppmaska;
    maskd=ppmaskd;
  }
  else {
    maska=0xFFFFFFFF;
    maskd=0xFFFFFFFF;
  }

  /*
   *  Testing Data Transfer Bus Lines A(31:1), D(31:0),
   *  LWORD, AS, DS0, DS1, WRITE, and DTACK. 
   */

  errcnt=0;
  wrdcnt=0;
  for(i=0;i<8;i++){
    data[2*wrdcnt]  =pat64b[i];
    data[2*wrdcnt+1]=pat64b[i];
    data[2*wrdcnt+4]=pat64b[i];
    data[2*wrdcnt+5]=pat64b[i];
    wrdcnt = ((i%2)==0)?wrdcnt+1:wrdcnt+3;
  }
  for(i=0;i<64;i++){
    if(i<32){
      data[2*wrdcnt]  =0;
      data[2*wrdcnt+1]=1<<i;
    }
    else {
      data[2*wrdcnt]  =1<<i;
      data[2*wrdcnt+1]=0;
    }
    wrdcnt++;
  }
  for(i=0;i<64;i++){
    if(i<32){
      data[2*wrdcnt]  =~0;
      data[2*wrdcnt+1]=~(1<<i);
    }
    else {
      data[2*wrdcnt]  =~(1<<i);
      data[2*wrdcnt+1]=~0;
    }
    wrdcnt++;
  }
  dev=MEMB64;
  aoff=0;
  a24mblt.cw.tg.tt=BLOCK;
  a24mblt.cw.tg.dsz=D64;
  a24mblt.cw.tg.wrt=WRITE;
  a24mblt.cw.tg.asz=A24;
  a24mblt.cw.tg.dt=No_Dly;
  a24mblt.cw.tg.at=0;
  a24mblt.addr_l = slot<<slot_shft[a24mblt.cw.tg.asz];
  a24mblt.addr_h = 0x00000000;
  a24mblt.addr_l = a24mblt.addr_l&dev_mask[a24mblt.cw.tg.asz] |
                   (b_addr[dev]+aoff)&~dev_mask[a24mblt.cw.tg.asz];
  a24mblt.dc = wrdcnt;
  a24mblt.dp = data;
  a24mblt.delay = 0;
  a24mblt.uam = 0;

  printf("\n    Address/Data line Test:\n");
  fprintf(fplog,"\n    Address/Data line Test:\n");


  nvu=add2pkt(1, &a24mblt);
  if(nvu<0){
    printf("    Error while packing VME data: Error #%d\n",-nvu);
    errcnt++;
  }
  else {
    printf("    VME command added to packet\n");
    printf("    Number of VME Units = %d unit(s)\n",nvu);
    printf("    Packet data size    = %d bytes\n",nwbuf);
    n=eth_write();
    response=look4_vme_pkt(NONE_EXP_PKT,rtn_buf, sizeof rtn_buf);
    if((response.nerr>0)||(response.nwrn>0)||(response.nberr>0)||(response.nbto>0)){
      fprintf(fplog,"    Errors reported during VME WRITE\n");
      errcnt++;
    }
    a24mblt.cw.tg.wrt=0; //change to MBLT read;
    nvu=add2pkt(1, &a24mblt);
    if(nvu<0){
      printf("    Error while packing VME data: Error #%d\n",-nvu);
    }
    else {
      printf("    VME command added to packet\n");
      printf("    Number of VME Units = %d unit(s)\n",nvu);
      printf("    Packet data size    = %d bytes\n",nwbuf);
      n=eth_write();
      response=look4_vme_pkt(VMED64_PKT,rtn_buf, sizeof rtn_buf);
      if(response.npkt==0){
	printf("    No response from Controller during VME READ\n");
	fprintf(fplog,"    No response from Controller during VME READ\n");
        errcnt++;
      }
      else {
        if(response.ndat>0 && response.buf_typ==D64){
          if(response.buf_cnt>wrdcnt){
            printf("    Warning: More words read back than expected.\n");
            printf("    Warning: Will only compare the expected number.\n");
            dcnt=wrdcnt;
          }
          else if(response.buf_cnt<wrdcnt){
            printf("    Warning: Did not receive the expected number of words.\n");
            printf("    Warning: Will compare what was read back.\n");
            dcnt=response.buf_cnt;
          }
          else {
            dcnt=wrdcnt;
          }
          derr=0;
          wrdcnt=0;
	  for(i=0;i<8 && wrdcnt<dcnt;i++){
	    if((rtn_buf[wrdcnt]&maska) !=(pat64b[i]&maska) || (rtn_buf[D64_LOW_OFF+wrdcnt]&maskd) !=(pat64b[i]&maskd)){
	      derr++;
              if(derr<10){
		printf("    %04d: ex:%08X%08X  rbk:%08X%08X  err:%08X%08X\n",
		       wrdcnt,pat64b[i]&maska,pat64b[i]&maskd,
		       rtn_buf[wrdcnt]&maska,rtn_buf[D64_LOW_OFF+wrdcnt]&maskd,
		       (rtn_buf[wrdcnt]&maska)^(pat64b[i]&maska),
                       (rtn_buf[D64_LOW_OFF+wrdcnt]&maska)^(pat64b[i]&maskd));
		fprintf(fplog,"    %04d: ex:%08X%08X  rbk:%08X%08X  err:%08X%08X\n",
		       wrdcnt,pat64b[i]&maska,pat64b[i]&maskd,
		       rtn_buf[wrdcnt]&maska,rtn_buf[D64_LOW_OFF+wrdcnt]&maskd,
		       (rtn_buf[wrdcnt]&maska)^(pat64b[i]&maska),
                       (rtn_buf[D64_LOW_OFF+wrdcnt]&maska)^(pat64b[i]&maskd));
	      }
	    }
	    if((rtn_buf[wrdcnt+2]&maska) != (pat64b[i]&maska) || (rtn_buf[D64_LOW_OFF+wrdcnt+2]&maskd) != (pat64b[i]&maskd)){
	      derr++;
              if(derr<10){
		printf("    %04d: ex:%08X%08X  rbk:%08X%08X  err:%08X%08X\n",
		       wrdcnt+2,pat64b[i]&maska,pat64b[i]&maskd,
		       rtn_buf[wrdcnt+2]&maska,rtn_buf[D64_LOW_OFF+wrdcnt+2]&maskd,
		       (rtn_buf[wrdcnt+2]&maska)^(pat64b[i]&maska),
                       (rtn_buf[D64_LOW_OFF+wrdcnt+2]&maska)^(pat64b[i]&maskd));
		fprintf(fplog,"    %04d: ex:%08X%08X  rbk:%08X%08X  err:%08X%08X\n",
		       wrdcnt+2,pat64b[i]&maska,pat64b[i]&maskd,
		       rtn_buf[wrdcnt+2]&maska,rtn_buf[D64_LOW_OFF+wrdcnt+2]&maskd,
		       (rtn_buf[wrdcnt+2]&maska)^(pat64b[i]&maska),
                       (rtn_buf[D64_LOW_OFF+wrdcnt+2]&maska)^(pat64b[i]&maskd));
	      }
	    }
	    wrdcnt = ((i%2)==0)?wrdcnt+1:wrdcnt+3;
	  }
	  for(i=0;i<64 && wrdcnt<dcnt;i++){
	    if(i<32){
	      exphigh=0;
              explow=(1<<i);
	    }
	    else {
	      exphigh=(1<<i);
              explow=0;
	    }
	    if((rtn_buf[wrdcnt]&maska) != (exphigh&maska) || (rtn_buf[D64_LOW_OFF+wrdcnt]&maskd) != (explow&maskd)){
	      derr++;
              if(derr<10){
		printf("    %04d: ex:%08X%08X  rbk:%08X%08X  err:%08X%08X\n",
		       wrdcnt,exphigh&maska,explow&maskd,
		       rtn_buf[wrdcnt]&maska,rtn_buf[D64_LOW_OFF+wrdcnt]&maskd,
		       (rtn_buf[wrdcnt]&maska)^(exphigh&maska),
                       (rtn_buf[D64_LOW_OFF+wrdcnt]&maskd)^(explow&maskd));
		fprintf(fplog,"    %04d: ex:%08X%08X  rbk:%08X%08X  err:%08X%08X\n",
		       wrdcnt,exphigh&maska,explow&maskd,
		       rtn_buf[wrdcnt]&maska,rtn_buf[D64_LOW_OFF+wrdcnt]&maskd,
		       (rtn_buf[wrdcnt]&maska)^(exphigh&maska),
                       (rtn_buf[D64_LOW_OFF+wrdcnt]&maskd)^(explow&maskd));
	      }
	    }
	    wrdcnt++;
	  }
	  for(i=0;i<64 && wrdcnt<dcnt;i++){
	    if(i<32){
	      exphigh=~0;
              explow=~(1<<i);
	    }
	    else {
	      exphigh=~(1<<i);
              explow=~0;
	    }
	    if((rtn_buf[wrdcnt]&maska) != (exphigh&maska) || (rtn_buf[D64_LOW_OFF+wrdcnt]&maskd) != (explow&maskd)){
	      derr++;
              if(derr<10){
		printf("    %04d: ex:%08X%08X  rbk:%08X%08X  err:%08X%08X\n",
		       wrdcnt,exphigh&maska,explow&maskd,
		       rtn_buf[wrdcnt]&maska,rtn_buf[D64_LOW_OFF+wrdcnt]&maskd,
		       (rtn_buf[wrdcnt]&maska)^(exphigh&maska),
                       (rtn_buf[D64_LOW_OFF+wrdcnt]&maskd)^(explow&maskd));
		fprintf(fplog,"    %04d: ex:%08X%08X  rbk:%08X%08X  err:%08X%08X\n",
		       wrdcnt,exphigh&maska,explow&maskd,
		       rtn_buf[wrdcnt]&maska,rtn_buf[D64_LOW_OFF+wrdcnt]&maskd,
		       (rtn_buf[wrdcnt]&maska)^(exphigh&maska),
                       (rtn_buf[D64_LOW_OFF+wrdcnt]&maskd)^(explow&maskd));
	      }
	    }
	    wrdcnt++;
	  }
          printf("    Read back %4d (64 bit) words: Compared %4d (64 bit) words\n",response.buf_cnt,dcnt);
          fprintf(fplog,"    Read back %4d (64 bit) words: Compared %4d (64 bit) words\n",response.buf_cnt,dcnt);
	  if(derr>0){
	    printf("    Address/Data line test Failed with %4d data errors:\n",derr);
	    fprintf(fplog,"    Address/Data line test Failed with %4d data errors:\n",derr);
	    errcnt+=derr;
	  }
	}
        else {
	  printf("    Problems encountered during READ:\n");
	  fprintf(fplog,"    Problems encountered during READ:\n");
          prt_rsp(&response);
          fprt_rsp(fplog, &response);
          errcnt++;
	}
      }
    }
  }
  if(errcnt>0) {
    printf("    Address/Data line test: %6d total errors.........................Failed:\n",errcnt);
    fprintf(fplog,"    Address/Data line test: %6d total errors.........................Failed:\n",errcnt);
  }
  else {
    printf("    Address/Data line test..............................................Passed:\n");
    fprintf(fplog,"    Address/Data line test..............................................Passed:\n");
  }
  return errcnt;
}


int vme_am()
{
int amidx;
int i,j,k,l,n,nvu;
int errcnt;
int dcnt,derr,derrs,exerr,exerrs;
int amstart;

unsigned char *cpr;
unsigned short int *hpr;
unsigned int *ipr,*lprh,*lprl;
extern int pre_prod;
unsigned int maska,maskd;


  cpr = (unsigned char *)rtn_buf;
  hpr = (unsigned short int *)rtn_buf;
  ipr = (unsigned int *)rtn_buf;
  lprh = (unsigned int *)rtn_buf;
  lprl = (unsigned int *)rtn_buf;
  lprl+=(sizeof rtn_buf)/8;


  /*
   *  Testing Address Modifier Lines 
   */


  data[0]  =0xAAAAAAAA;
  data[1]  =0xBBBBBBBB;
  data[2]  =0xCCCCCCCC;
  data[3]  =0xDDDDDDDD;
  data[4]  =0x66666666;
  data[5]  =0x77777777;
  data[6]  =0x88888888;
  data[7]  =0x99999999;

  errcnt=0;
  derrs=0;
  exerrs=0;
  amstart=0;
  if(pre_prod)amstart=11;
  for(amidx=amstart;amidx<NAM_TESTS;amidx++){
    if(pre_prod){
      maska=ppammaska[amidx];
      maskd=ppammaskd[amidx];
    }
    else {
      maska=0xFFFFFFFF;
      maskd=0xFFFFFFFF;
    }

    derr=0;
    exerr=0;
    aoff=0;
    amvc.cw.full= cwrd[amidx];
    if(amvc.cw.tg.asz<A40){
      amvc.addr_l = slot<<slot_shft[amvc.cw.tg.asz];
      amvc.addr_h = 0x00000000;
    }
    else {
      amvc.addr_l = 0x00000000;
      amvc.addr_h = slot<<(slot_shft[amvc.cw.tg.asz]-32);
    }
    amvc.addr_l = amvc.addr_l&dev_mask[amvc.cw.tg.asz] |
      (b_addr[devl[amidx]]+aoff)&~dev_mask[amvc.cw.tg.asz];
    amvc.dc = 4;
    amvc.dp = data;
    amvc.delay = 0;
    amvc.uam = 0;

    printf("\n    Address Modifier Test: AM_test[%02d]=%02X:\n",amidx,amt[amidx]);
    fprintf(fplog,"\n    Address Modifier Test: AM_test[%02d]=%02X:\n",amidx,amt[amidx]);
    nvu=add2pkt(1, &amvc);
    if(nvu<0){
      printf("    Error while packing VME data: Error #%d\n",-nvu);
      exerr++;
    }
    else {
      printf("    VME command added to packet\n");
      printf("    Number of VME Units = %d unit(s)\n",nvu);
      printf("    Packet data size    = %d bytes\n",nwbuf);
      n=eth_write();
      response=look4_vme_pkt(NONE_EXP_PKT,rtn_buf, sizeof rtn_buf);
      if((response.nerr>0)||(response.nwrn>0)||(response.nberr>0)||(response.nbto>0)){
	fprintf(fplog,"    Errors reported during VME WRITE\n");
        exerr++;
      }
      amvc.cw.tg.wrt=0; //change to read;
      nvu=add2pkt(1, &amvc);
      if(nvu<0){
	printf("    Error while packing VME data: Error #%d\n",-nvu);
        exerr++;
      }
      else {
	printf("    VME command added to packet\n");
	printf("    Number of VME Units = %d unit(s)\n",nvu);
	printf("    Packet data size    = %d bytes\n",nwbuf);
        derr=0;
	n=eth_write();
	response=look4_vme_pkt(exp_dat[amidx],rtn_buf, sizeof rtn_buf);
	if(response.npkt==0){
	  printf("    No response from Controller during VME READ\n");
	  fprintf(fplog,"    No response from Controller during VME READ\n");
          exerr++;
	}
	else {
          rdsz=response.buf_typ;
	  if(response.ndat>0 && rdsz==amvc.cw.tg.dsz){
	    if(amvc.cw.tg.tt==BLOCK){
	      if(response.buf_cnt>amvc.dc){
		printf("    Warning: AM_test[%02d]=%02X: More words read back than expected.\n",amidx,amt[amidx]);
		fprintf(fplog,"    Warning: AM_test[%02d]=%02X: More words read back than expected.\n",amidx,amt[amidx]);
		dcnt=amvc.dc;
                exerr++;
	      }
	      else if(response.buf_cnt<amvc.dc){
		printf("    Warning: AM_test[%02d]=%02X: Did not receive the expected number of words.\n",amidx,amt[amidx]);
		fprintf(fplog,"    Warning: AM_test[%02d]=%02X: Did not receive the expected number of words.\n",amidx,amt[amidx]);
		dcnt=response.buf_cnt;
                exerr++;
	      }
	      else {
		dcnt=amvc.dc;
	      }
            }
            else {
	      if(response.buf_cnt!=1){
		printf("    Warning: AM_test[%02d]=%02X: Expecting a single word but got %d.\n",amidx,amt[amidx],response.buf_cnt);
		fprintf(fplog,"    Warning: AM_test[%02d]=%02X: Expecting a single word but got %d.\n",amidx,amt[amidx],response.buf_cnt);
                exerr++;
	      }
	      dcnt=1;
            }
	    for(i=0;i<dcnt;i++){
	      switch(rdsz){
	      case D08:
		if(cpr[i] != (data[i]&0xFF)){
		  derr++;
		  if(derr<10){
		    printf("    %04d: ex:%02X  rbk:%02X  err:%02X\n",i,data[i]&0xFF,
			   cpr[i]&0xFF,cpr[i]^(data[i]&0xFF));
		    fprintf(fplog,"    %04d: ex:%02X  rbk:%02X  err:%02X\n",i,data[i]&0xFF,
			    cpr[i]&0xFF,(cpr[i]^(data[i]&0xFF))&0xFF);
		  }
		}
		break;
	      case D16:
		if(hpr[i] != (data[i]&0xFFFF)){
		  derr++;
		  if(derr<10){
		    printf("    %04d: ex:%04hX  rbk:%04hX  err:%04hX\n",i,data[i]&0xFFFF,
			   hpr[i],hpr[i]^(data[i]&0xFFFF));
		    fprintf(fplog,"    %04d: ex:%04hX  rbk:%04hX  err:%04hX\n",i,data[i]&0xFFFF,
			    hpr[i],hpr[i]^(data[i]&0xFFFF));
		  }
		}
		break;
	      case D32:
		if((ipr[i]&maskd) != (data[i]&maskd)){
		  derr++;
		  if(derr<10){
		    printf("    %04d: ex:%08X  rbk:%08X  err:%08X\n",i,data[i]&maskd,
			   ipr[i]&maskd,(ipr[i]&maskd)^(data[i]&maskd));
		    fprintf(fplog,"    %04d: ex:%08X  rbk:%08X  err:%08X\n",i,data[i]&maskd,
			    ipr[i]&maskd,(ipr[i]&maskd)^(data[i]&maskd));
		  }
		}
		break;
	      case D64:
		if(((lprh[i]&maska) != (data[2*i]&maska)) || ((lprl[i]&maskd) != (data[2*i+1]&maskd))){
		  derr++;
		  if(derr<10){
		    printf("    %04d: ex:%08X%08X  rbk:%08X%08X  err:%08X%08X\n",
			   i,data[2*i]&maska,data[2*i+1]&maskd,
			   lprh[i]&maska,lprl[i]&maskd,
			   (lprh[i]&maska)^(data[2*i]&maska),
                           (lprl[i]&maskd)^(data[2*i+1]&maskd));
		    fprintf(fplog,"    %04d: ex:%08X%08X  rbk:%08X%08X  err:%08X%08X\n",
			   i,data[2*i]&maska,data[2*i+1]&maskd,
			   lprh[i]&maska,lprl[i]&maskd,
			   (lprh[i]&maska)^(data[2*i]&maska),
                           (lprl[i]&maskd)^(data[2*i+1]&maskd));
		  }
		}
		break;
	      default:
		printf("    Illeagal Data size encountered\n");
                exerr++;
		break;
	      }
	    }
	  }
	  else {
	    printf("    Problems encountered during READ:\n");
	    fprintf(fplog,"    Problems encountered during READ:\n");
            prt_rsp(&response);
            fprt_rsp(fplog, &response);
            exerr++;
	  }
	}
      }
    }
    if(derr>0 || exerr>0){
      printf("    %6d data errors, %3d execution errors\n",derr,exerr);
      printf("    Address Modifier Test: AM_test[%02d]=%02X.............................. Failed:\n",amidx,amt[amidx]);
      fprintf(fplog,"    %6d data errors, %3d execution errors\n",derr,exerr);
      fprintf(fplog,"    Address Modifier Test: AM_test[%02d]=%02X.............................. Failed:\n",amidx,amt[amidx]);
      derrs+=derr;
      exerrs+=exerr;
    }
    else {
      printf("    Address Modifier Test: AM_test[%02d]=%02X...............................Passed:\n",amidx,amt[amidx]);
      fprintf(fplog,"    Address Modifier Test: AM_test[%02d]=%02X...............................Passed:\n",amidx,amt[amidx]);
    }
  }
  if(derrs>0 || exerrs>0){
    printf("\n    Address Modifier Failed with %4d data errors and %d execution errors:\n",derrs,exerrs);
    fprintf(fplog,"\n    Address Modifier Failed with %4d data errors and %d execution errors:\n",derrs,exerrs);
    errcnt+=derrs+exerrs;
  }
  else {
    printf("\n    All Address Modifier Tests..........................................Passed:\n");
    fprintf(fplog,"\n    All Address Modifier Tests..........................................Passed:\n");
  }
  return errcnt;
}


int vme_arb()
{
int breq_lvl;
int i,j,k,l,n,nvu;
int errcnt;
int derr,derrs,exerr,exerrs;

CNFG_t   scr_cnfg;
CNFG_ptr rcv_cnfg1;

unsigned char *cpr;
unsigned short int *hpr;
unsigned int *ipr,*lprh,*lprl;
extern int pre_prod;
unsigned int maska,maskd;

  cpr = (unsigned char *)rtn_buf;
  hpr = (unsigned short int *)rtn_buf;
  ipr = (unsigned int *)rtn_buf;
  lprh = (unsigned int *)rtn_buf;
  lprl = (unsigned int *)rtn_buf;
  lprl+=(sizeof rtn_buf)/8;


  /*
   *  Testing Arbitration Bus Lines 
   */

  if(pre_prod){
    maska=ppammaska[16];
    maskd=ppammaskd[16];
  }
  else {
    maska=0xFFFFFFFF;
    maskd=0xFFFFFFFF;
  }
  errcnt=0;
  aoff=0;
  amvc.cw.full= cwrd[16]; //A24:D32:SNGL
  if(amvc.cw.tg.asz<A40){
    amvc.addr_l = slot<<slot_shft[amvc.cw.tg.asz];
    amvc.addr_h = 0x00000000;
  }
  else {
    amvc.addr_l = 0x00000000;
    amvc.addr_h = slot<<(slot_shft[amvc.cw.tg.asz]-32);
  }
  amvc.addr_l = amvc.addr_l&dev_mask[amvc.cw.tg.asz] |
    (b_addr[devl[16]]+aoff)&~dev_mask[amvc.cw.tg.asz];
  amvc.dc = 1;
  amvc.dp = data;
  amvc.delay = 0;
  amvc.uam = 0;
  derrs=0;
  exerrs=0;

  rcv_cnfg1 = read_crs();
  cp_crs(&scr_cnfg,rcv_cnfg1);
  free(rcv_cnfg1);

  scr_cnfg.vme = SET_MSTR_REQ_TYP(REQ_RWD,scr_cnfg.vme); //Release When Done
  scr_cnfg.vme = SET_ARB_TYP(ARB_PRI,scr_cnfg.vme);      //Prioritized Arbiter

  for(breq_lvl=0;breq_lvl<4;breq_lvl++){
    exerr=0;
    data[0]=0;
    for(i=0;i<8;i++){
      data[0] =data[0]|((0xB+breq_lvl)<<(4*i));
    }
    scr_cnfg.vme = SET_MSTR_REQ_LVL(breq_lvl,scr_cnfg.vme);
    wrt_crs(VME,&scr_cnfg);
    printf("\n    Arbitration Bus Test: BR[%1d]:\n",breq_lvl);
    fprintf(fplog,"\n    Arbitration Bus Test: BR[%1d]:\n",breq_lvl);
    amvc.cw.tg.wrt=1; //change to write;
    nvu=add2pkt(1, &amvc);
    if(nvu<0){
      printf("    Error while packing VME data: Error #%d\n",-nvu);
      exerr++;
    }
    else {
      printf("    VME command added to packet\n");
      printf("    Number of VME Units = %d unit(s)\n",nvu);
      printf("    Packet data size    = %d bytes\n",nwbuf);
      n=eth_write();
      response=look4_vme_pkt(NONE_EXP_PKT,rtn_buf, sizeof rtn_buf);
      if((response.nerr>0)||(response.nwrn>0)||(response.nberr>0)||(response.nbto>0)){
	fprintf(fplog,"    Errors reported during VME WRITE\n");
        exerr++;
      }
      amvc.cw.tg.wrt=0; //change to read;
      nvu=add2pkt(1, &amvc);
      if(nvu<0){
	printf("    Error while packing VME data: Error #%d\n",-nvu);
        exerr++;
      }
      else {
	printf("    VME command added to packet\n");
	printf("    Number of VME Units = %d unit(s)\n",nvu);
	printf("    Packet data size    = %d bytes\n",nwbuf);
        derr=0;
	n=eth_write();
	response=look4_vme_pkt(VMED32_PKT,rtn_buf, sizeof rtn_buf);
	if(response.npkt==0){
	  printf("    No response from Controller during VME READ\n");
	  fprintf(fplog,"    No response from Controller during VME READ\n");
          exerr++;
	}
	else {
          rdsz=response.buf_typ;
	  if(response.ndat>0 && rdsz==amvc.cw.tg.dsz){
	    if(response.buf_cnt!=1){
	      printf("    Warning: ARB test BR[%1d]: Expecting a single word but got %d.\n",breq_lvl,response.buf_cnt);
	      fprintf(fplog,"    Warning: ARB test BR[%1d]: Expecting a single word but got %d.\n",breq_lvl,response.buf_cnt);
	      exerr++;
	    }
	    switch(rdsz){
	    case D08:
	      if(cpr[0] != (data[0]&0xFF)){
		derr++;
		if(derr<10){
		  printf("    %04d: ex:%02X  rbk:%02X  err:%02X\n",i,data[0]&0xFF,
			 cpr[0]&0xFF,cpr[0]^(data[0]&0xFF));
		  fprintf(fplog,"    %04d: ex:%02X  rbk:%02X  err:%02X\n",i,data[0]&0xFF,
			  cpr[0]&0xFF,(cpr[0]^(data[0]&0xFF))&0xFF);
		}
	      }
	      break;
	    case D16:
	      if(hpr[0] != (data[0]&0xFFFF)){
		derr++;
		if(derr<10){
		  printf("    %04d: ex:%04hX  rbk:%04hX  err:%04hX\n",i,data[0]&0xFFFF,
			 hpr[0],hpr[0]^(data[0]&0xFFFF));
		  fprintf(fplog,"    %04d: ex:%04hX  rbk:%04hX  err:%04hX\n",i,data[0]&0xFFFF,
			  hpr[0],hpr[0]^(data[0]&0xFFFF));
		}
	      }
	      break;
	    case D32:
	      if((ipr[0]&maskd) != (data[0]&maskd)){
		derr++;
		if(derr<10){
		  printf("        : ex:%08X  rbk:%08X  err:%08X\n",data[0]&maskd,
			 ipr[0]&maskd,(ipr[0]&maskd)^(data[0]&maskd));
		  fprintf(fplog,"        : ex:%08X  rbk:%08X  err:%08X\n",data[0]&maskd,
			  ipr[0]&maskd,(ipr[0]&maskd)^(data[0]&maskd));
		}
	      }
	      break;
	    case D64:
	      if(((lprh[0]&maska) != (data[0]&maska)) || ((lprl[0]&maskd) != (data[1]&maskd))){
		derr++;
		if(derr<10){
		  printf("        : ex:%08X%08X  rbk:%08X%08X  err:%08X%08X\n",
			 data[0]&maska,data[1]&maskd,
			 lprh[0]&maska,lprl[0]&maskd,
			 (lprh[0]&maska)^(data[0]&maska),
			 (lprl[0]&maskd)^(data[1]&maskd));
		  fprintf(fplog,"        : ex:%08X%08X  rbk:%08X%08X  err:%08X%08X\n",
			  data[0]&maska,data[1]&maskd,
			  lprh[0]&maska,lprl[0]&maskd,
			  (lprh[0]&maska)^(data[0]&maska),
			  (lprl[0]&maskd)^(data[1]&maskd));
		}
	      }
	      break;
	    default:
	      printf("    Illeagal Data size encountered\n");
	      exerr++;
	      break;
	    }
	  }
	  else {
	    printf("    Problems encountered during READ:\n");
	    fprintf(fplog,"    Problems encountered during READ:\n");
            prt_rsp(&response);
            fprt_rsp(fplog, &response);
            exerr++;
	  }
	}
      }
    }
    if(derr>0 || exerr>0){
      printf("    %6d data errors, %3d execution errors\n",derr,exerr);
      printf("    Arbitration Bus Test: BR[%1d].........................................Failed:\n",breq_lvl);
      fprintf(fplog,"    %6d data errors, %3d execution errors\n",derr,exerr);
      fprintf(fplog,"    Arbitration Bus Test: BR[%1d].........................................Failed:\n",breq_lvl);
      derrs+=derr;
      exerrs+=exerr;
    }
    else {
      printf("    Arbitration Bus Test: BR[%1d].........................................Passed:\n",breq_lvl);
      fprintf(fplog,"    Arbitration Bus Test: BR[%1d].........................................Passed:\n",breq_lvl);
    }
  }
  if(derrs>0 || exerrs>0){
    printf("\n    Arbitration Bus Tests Failed with %4d data errors and %d execution errors:\n",derrs,exerrs);
    fprintf(fplog,"\n    Arbitration Bus Tests Failed with %4d data errors and %d execution errors:\n",derrs,exerrs);
    errcnt+=derrs+exerrs;
  }
  else {
    printf("\n    All Arbitration Bus Tests...........................................Passed:\n");
    fprintf(fplog,"\n    All Arbitration Bus Tests...........................................Passed:\n");
  }
  return errcnt;
}


int vme_intr()
{
int ireq_lvl;
int i,j,k,l,n,nvu;
int errcnt;
int derr,derrs,exerr,exerrs;

CNFG_t   scr_cnfg;
CNFG_ptr rcv_cnfg1;

unsigned char *cpr;
unsigned short int *hpr;
unsigned int *ipr;
extern int pre_prod;
unsigned int maskd;

  cpr = (unsigned char *)rtn_buf;
  hpr = (unsigned short int *)rtn_buf;
  ipr = (unsigned int *)rtn_buf;

  /*
   *  Testing Interrupt Request Lines 
   */

  if(pre_prod){
    maskd=ppammaskd[16];
  }
  else {
    maskd=0xFFFFFFFF;
  }

  // Make sure spontaneous packets are enabled
  set_clr_bits(SET, ETHER, ETH_CR_SPONT); // Enable spontaneous packets.

  errcnt=0;
  derrs=0;
  exerrs=0;

  rcv_cnfg1 = read_crs();
  cp_crs(&scr_cnfg,rcv_cnfg1);
  free(rcv_cnfg1);

  scr_cnfg.vme = SET_ARB_TYP(ARB_SGL,scr_cnfg.vme);      //Single Level Arbiter
  scr_cnfg.vme = SET_MSTR_REQ_TYP(REQ_RWD,scr_cnfg.vme); //Master, Release When Done
  scr_cnfg.vme = SET_MSTR_REQ_LVL(3,scr_cnfg.vme);       //Master, Level 3
  scr_cnfg.vme |= VME_CR_IH;                             //Set bit to enalble Interrupt Handler
  scr_cnfg.vme = SET_IH_LEVELS(0x7F,scr_cnfg.vme);       //All IRQ levels active
  scr_cnfg.vme |= VME_CR_UPD_IRQ;                        //Set bit to update the active IRQ lines
  scr_cnfg.vme = SET_IH_REQ_TYP(REQ_RWD,scr_cnfg.vme);   //Intr. Hndlr., Release When Done
  scr_cnfg.vme = SET_IH_REQ_LVL(3,scr_cnfg.vme);         //Intr. Hndlr., Level 3
  scr_cnfg.vme = SET_IH_DAT_SZ(D32,scr_cnfg.vme);        //A D32 IH
  wrt_crs(VME,&scr_cnfg);

  // Setup the SLAVE for generating interrupts.
  cur_mac=slave;

  slv_cnfg.vme |= SLAVE_VME_CR_INTR;                   //Set bit to enalble Interrupter on the Slave
  slv_cnfg.vme = SLAVE_SET_I_DAT_SZ(D32,slv_cnfg.vme); //A D32 Interrupter
  wrt_crs(VME,&slv_cnfg);
  cur_mac=master;
  exerrs=0;
  for(ireq_lvl=1;ireq_lvl<8;ireq_lvl++){
    exerr=0;

    cur_mac=slave;
    slv_cnfg.vme = SLAVE_SET_IRQ_LVL(ireq_lvl,slv_cnfg.vme);
    wrt_crs(VME,&slv_cnfg);
    cur_mac=master;
    printf("\n    Interrupt Bus Test: IRQ[%1d]:\n",ireq_lvl);
    fprintf(fplog,"\n    Interrupt Bus Test: IRQ[%1d]:\n",ireq_lvl);
    gen_intr();

    response=look4_vme_pkt(IHD32_STAT_ID_PKT,rtn_buf, sizeof rtn_buf);
    if(response.npkt<=0){
      printf("    Did not receive interrupt packet!\n");
      fprintf(fplog,"    Did not receive interrupt packet!\n");
      exerr++;
    }
    else {
      derr=0;
      if(response.nintr>0){
	rdsz=response.buf_typ;
	if(response.buf_cnt!=1){
	  printf("    Warning: Interrupt test IRQ[%1d]: Expecting a single word but got %d.\n",ireq_lvl,response.buf_cnt);
	  fprintf(fplog,"    Warning: Interrupt test IRQ[%1d]: Expecting a single word but got %d.\n",ireq_lvl,response.buf_cnt);
	  exerr++;
	}
        else {
	  switch(rdsz){
	  case D08:
	    printf("    Interrupt Status word is: %02X\n",cpr[0]&0xFF);
	    fprintf(fplog,"    Interrupt Status word is: %02X\n",cpr[0]&0xFF);
	    if((cpr[0]>>4)&0xF != ireq_lvl){
	      derr++;
	      printf("    ex:%01X  rbk:%01X\n",ireq_lvl,(cpr[0]>>4)&0xF);
	      fprintf(fplog,"    ex:%01X  rbk:%01X\n",ireq_lvl,(cpr[0]>>4)&0xF);
	    }
	    break;
	  case D16:
	    printf("    Interrupt Status word is: %04hX\n",hpr[0]);
	    fprintf(fplog,"    Interrupt Status word is: %04hX\n",hpr[0]);
	    if((hpr[0]>>4)&0xF != ireq_lvl){
	      derr++;
	      printf("    ex:%01X  rbk:%01X\n",ireq_lvl,(hpr[0]>>4)&0xF);
	      fprintf(fplog,"    ex:%01X  rbk:%01X\n",ireq_lvl,(hpr[0]>>4)&0xF);
	    }
	    break;
	  case D32:
	    printf("    Interrupt Status word is: %08X\n",ipr[0]&maskd);
	    fprintf(fplog,"    Interrupt Status word is: %08X\n",ipr[0]&maskd);
	    if(((ipr[0]>>4)&0xF) != ireq_lvl){
	      derr++;
	      printf("    ex:%01X  rbk:%01X\n",ireq_lvl,(ipr[0]>>4)&0xF);
	      fprintf(fplog,"    ex:%01X  rbk:%01X\n",ireq_lvl,(ipr[0]>>4)&0xF);
	    }
	    break;
	  default:
	    printf("    Illeagal Data size for interrupts encountered\n");
	    exerr++;
	    break;
	  }
	}
      }
      else {
	printf("    Received an unexpected packet type:\n");
	fprintf(fplog,"    Received an unexpected packet type:\n");
        prt_rsp(&response);
        fprt_rsp(fplog, &response);
	exerr++;
      }
    }
    if(derr>0 || exerr>0){
      printf("    %6d data errors, %3d execution errors\n",derr,exerr);
      printf("    Interrupt Bus Test: IRQ[%1d]..........................................Failed:\n",ireq_lvl);
      fprintf(fplog,"    %6d data errors, %3d execution errors\n",derr,exerr);
      fprintf(fplog,"    Interrupt Bus Test: IRQ[%1d]..........................................Failed:\n",ireq_lvl);
      derrs+=derr;
      exerrs+=exerr;
    }
    else {
      printf("    Interrupt Bus Test: IRQ[%1d]..........................................Passed:\n",ireq_lvl);
      fprintf(fplog,"    Interrupt Bus Test: IRQ[%1d]..........................................Passed:\n",ireq_lvl);
    }
  }
  if(derrs>0 || exerrs>0){
    printf("\n    Interrupt Bus Tests Failed with %d data errors, %d execution errors:\n",derrs,exerrs);
    fprintf(fplog,"\n    Interrupt Bus Tests Failed with %d data errors, %d execution errors:\n",derrs,exerrs);
    errcnt+=derrs+exerrs;
  }
  else {
    printf("\n    All Interrupt Bus Tests.............................................Passed:\n");
    fprintf(fplog,"\n    All Interrupt Bus Tests.............................................Passed:\n");
  }


  // Disable interrupts on SLAVE and Master.
  cur_mac=slave;
  slv_cnfg.vme &= ~SLAVE_VME_CR_INTR;   //Clear bit to disalble Interrupter on the Slave
  wrt_crs(VME,&slv_cnfg);

  cur_mac=master;
  scr_cnfg.vme &= ~VME_CR_IH;   //Clear bit to disalble Interrupt Handler
  wrt_crs(VME,&scr_cnfg);

  return errcnt;
}


int vme_berr()
{
int i,j,k,l,n,nvu;
int errcnt;
int derr,derrs,exerr,exerrs;

unsigned short int *hpr;

  hpr = (unsigned short int *)rtn_buf;

  /*
   *  Testing BERR (bus error from slave)
   *  and (bus timeout from master)
   */


  // Make sure spontaneous packets are enabled
  set_clr_bits(SET, ETHER, ETH_CR_SPONT); // Enable spontaneous packets.

  errcnt=0;
  dev=MEMB8; 
  aoff=0;
  amvc.cw.full= cwrd[16]; 
  amvc.cw.tg.dsz=D16; //change to A24:D16:SNGL (illeagal access to MEMB8)
  amvc.addr_l = slot<<slot_shft[amvc.cw.tg.asz];
  amvc.addr_h = 0x00000000;
  amvc.addr_l = amvc.addr_l&dev_mask[amvc.cw.tg.asz] |
    (b_addr[dev]+aoff)&~dev_mask[amvc.cw.tg.asz];
  amvc.dc = 1;
  amvc.dp = data;
  amvc.delay = 0;
  amvc.uam = 0;
  data[0] = 0;
  derrs=0;
  exerrs=0;
  derr=0;
  exerr=0;
  amvc.cw.tg.wrt=READ; //change to read;

  printf("\n    BERR (Bus Error) Test:\n");
  fprintf(fplog,"\n    BERR (Bus Error) Test:\n"); 
  printf("\n    Checking for BERR from slave:\n");
  fprintf(fplog,"\n    Checking for BERR from slave:\n");

  nvu=add2pkt(1, &amvc);
  if(nvu<0){
    printf("    Error while packing VME data: Error #%d\n",-nvu);
    exerr++;
  }
  else {
    printf("    VME command added to packet\n");
    printf("    Number of VME Units = %d unit(s)\n",nvu);
    printf("    Packet data size    = %d bytes\n",nwbuf);
    n=eth_write();
    response=look4_vme_pkt(ERR_PKT,rtn_buf, sizeof rtn_buf);
    rdsz=response.buf_typ;
    switch (response.npkt){
    case 0:
      printf("    No response from controller after a VME READ\n");
      fprintf(fplog,"    No response from controller after a VME READ\n");
      exerr++;
      break;
    case 1:
    case 2:
      switch (response.nberr){
      case 0:
        printf("    No BERR from slave!\n");
        fprintf(fplog,"    No BERR from slave!\n");
        exerr++;
	break;
      case 1:
	printf("    Expected bus error from slave was received\n");
	fprintf(fplog,"    Expected bus error from slave was received\n");
	break;
      case 2:
	printf("    Two Bus error packets were received\n");
	fprintf(fplog,"    Two Bus error packets were received\n");
        exerr++;
	break;
      default:
	printf("    More than two Bus errors!\n");
	fprintf(fplog,"    More than two Bus errors!\n");
        exerr++;
	break;
      }
      switch (response.ndat){
      case 0:
        printf("    No Data packets received!\n");
        fprintf(fplog,"    No Data packets received!\n");
        exerr++;
	break;
      case 1:
	if(rdsz==D16){
	  if(hpr[0] != 0xBAAD){
	    derr++;
	    printf("    Data packet received but not the expected data\n");
	    fprintf(fplog,"    Data packet received but not the expected data\n");
	    printf("    ex:%04hX  rbk:%04hX  err:%04hX\n",0xBAAD,hpr[0],hpr[0]^0xBAAD);
	    fprintf(fplog,"    ex:%04hX  rbk:%04hX  err:%04hX\n",0xBAAD,hpr[0],hpr[0]^0xBAAD);
	  }
          else {
            printf("    Expected Place-Holder data was received.\n");
            fprintf(fplog,"    Expected Place-Holder data was received.\n");
	  }
	}
        else {
          printf("    Data packet received but wrong size data\n");
          fprintf(fplog,"    Data packet received but wrong size data\n");
          derr++;
	}
	break;
      case 2:
	printf("    Two Place-Holder data packets were received.\n");
	fprintf(fplog,"    Two Place-Holder data packets were received.\n");
        exerr++;
	break;
      default:
	printf("    More than two Data packets!\n");
	fprintf(fplog,"    More than two Data packets!\n");
        exerr++;
	break;
      }
      if(response.nberr==0 && response.ndat==0){
	printf("    Received an unexpected packet type:\n");
	fprintf(fplog,"    Received an unexpected packet type:\n");
	prt_rsp(&response);
	fprt_rsp(fplog, &response);
	exerr++;
      }
      break;
    default:
      printf("    More than two packets were received!\n");
      fprintf(fplog,"    More than two packets were received!\n");
      exerr++;
      break;
    }
  }
  printf("    Received %2d BERR packets, and %2d Data packets.\n",response.nberr, response.ndat);
  fprintf(fplog,"    Received %2d BERR packets, and %2d Data packets.\n",response.nberr, response.ndat);
  printf("    Encontered %2d data errors and %2d execution errors.\n",derr,exerr);
  fprintf(fplog,"    Encontered %2d data errors and %2d execution errors.\n",derr,exerr);
  exerrs+=exerr;
  derrs+=derr;
  if(exerr+derr >0){
    printf("    Did not receive expected response (BERR test).......................Failed:\n");
    fprintf(fplog,"    Did not receive expected response (BERR test).......................Failed:\n");
  }
  else {
    printf("    BERR from slave test................................................Passed:\n");
    fprintf(fplog,"    BERR from slave test................................................Passed:\n");
  }


  dev=MEMA16; 
  amvc.addr_l = (slot+1)<<slot_shft[amvc.cw.tg.asz]; //Set non-occupied slot
  amvc.addr_h = 0x00000000;
  amvc.addr_l = amvc.addr_l&dev_mask[amvc.cw.tg.asz] |
    (b_addr[dev]+aoff)&~dev_mask[amvc.cw.tg.asz];

  printf("\n    Checking for BERR due to bus timeout:\n");
  fprintf(fplog,"\n    Checking for BERR due to bus timeout:\n");

  derr=0;
  exerr=0;
  nvu=add2pkt(1, &amvc);
  if(nvu<0){
    printf("    Error while packing VME data: Error #%d\n",-nvu);
    exerr++;
  }
  else {
    printf("    VME command added to packet\n");
    printf("    Number of VME Units = %d unit(s)\n",nvu);
    printf("    Packet data size    = %d bytes\n",nwbuf);
    n=eth_write();
    response=look4_vme_pkt(ERR_PKT,rtn_buf, sizeof rtn_buf);
    rdsz=response.buf_typ;
    switch (response.npkt){
    case 0:
      printf("    No response from controller after a VME READ\n");
      fprintf(fplog,"    No response from controller after a VME READ\n");
      exerr++;
      break;
    case 1:
    case 2:
      switch (response.nbto){
      case 0:
        printf("    No BTO from controller!\n");
        fprintf(fplog,"    No BTO from controller!\n");
        exerr++;
	break;
      case 1:
	printf("    Expected bus timeout error was received\n");
	fprintf(fplog,"    Expected bus timeout error was received\n");
	break;
      case 2:
	printf("    Two Bus Timeout error packets were received\n");
	fprintf(fplog,"    Two Bus Timeout error packets were received\n");
        exerr++;
	break;
      default:
	printf("    More than two Bus Timeout errors!\n");
	fprintf(fplog,"    More than two Bus Timeout errors!\n");
        exerr++;
	break;
      }
      switch (response.ndat){
      case 0:
        printf("    No Data packets received!\n");
        fprintf(fplog,"    No Data packets received!\n");
        exerr++;
	break;
      case 1:
	if(rdsz==D16){
	  if(hpr[0] != 0xBAAD){
	    derr++;
	    printf("    Data packet received but not the expected data\n");
	    fprintf(fplog,"    Data packet received but not the expected data\n");
	    printf("    ex:%04hX  rbk:%04hX  err:%04hX\n",0xBAAD,hpr[0],hpr[0]^0xBAAD);
	    fprintf(fplog,"    ex:%04hX  rbk:%04hX  err:%04hX\n",0xBAAD,hpr[0],hpr[0]^0xBAAD);
	  }
          else {
            printf("    Expected Place-Holder data was received.\n");
            fprintf(fplog,"    Expected Place-Holder data was received.\n");
	  }
	}
        else {
          printf("    Data packet received but wrong size data\n");
          fprintf(fplog,"    Data packet received but wrong size data\n");
          derr++;
	}
	break;
      case 2:
	printf("    Two Place-Holder data packets were received.\n");
	fprintf(fplog,"    Two Place-Holder data packets were received.\n");
        exerr++;
	break;
      default:
	printf("    More than two Data packets!\n");
	fprintf(fplog,"    More than two Data packets!\n");
        exerr++;
	break;
      }
      if(response.nberr==0 && response.ndat==0){
	printf("    Received an unexpected packet type:\n");
	fprintf(fplog,"    Received an unexpected packet type:\n");
	prt_rsp(&response);
	fprt_rsp(fplog, &response);
	exerr++;
      }
      break;
    default:
      printf("    More than two packets were received!\n");
      fprintf(fplog,"    More than two packets were received!\n");
      exerr++;
      break;
    }
  }
  printf("    Received %2d BTO packets, and %2d Data packets.\n",response.nbto, response.ndat);
  fprintf(fplog,"    Received %2d BTO packets, and %2d Data packets.\n",response.nbto, response.ndat);
  printf("    Encontered %2d data errors and %2d execution errors.\n",derr,exerr);
  fprintf(fplog,"    Encontered %2d data errors and %2d execution errors.\n",derr,exerr);
  exerrs+=exerr;
  derrs+=derr;
  if(exerr+derr >0){
    printf("    Did not receive expected response (BTO test)........................Failed:\n");
    fprintf(fplog,"    Did not receive expected response (BTO test)........................Failed:\n");
  }
  else {
    printf("    BTO test............................................................Passed:\n");
    fprintf(fplog,"    BTO test............................................................Passed:\n");
  }

  errcnt=exerrs+derrs;
  if(errcnt>0){
    printf("\n    BERR Tests Failed with %d errors:....................................Failed:\n",errcnt);
    fprintf(fplog,"\n    BERR Tests Failed with %d errors:....................................Failed:\n",errcnt);
  }
  else {
    printf("\n    BERR Tests..........................................................Passed:\n");
    fprintf(fplog,"\n    BERR Tests..........................................................Passed:\n");
  }

  return errcnt;
}


int vme_dly()
{
int i,j,k,l,n,nvu;
int errcnt;
int derr,derrs,exerr,exerrs;

unsigned short int *hpr;

  hpr = (unsigned short int *)rtn_buf;


  /*
   *  Testing Delays (checking for erroneous bus request
   *  that cause the VME master to hang)
   *  Must disable spontaneous packets to avoid an onslaught of error messages
   *  from revision 3.59.
   */


  set_clr_bits(CLR, ETHER, ~ETH_CR_SPONT); // Disable spontaneous packets.

  errcnt=0;
  dev=MEMA16;
  aoff=0;
  a24d16.cw.tg.tt=SNGL;
  a24d16.cw.tg.dsz=D16;
  a24d16.cw.tg.wrt=WRITE;
  a24d16.cw.tg.asz=A24;
  a24d16.cw.tg.dt=No_Dly;
  a24d16.cw.tg.at=0;
  a24d16.addr_l = slot<<slot_shft[a24d16.cw.tg.asz];
  a24d16.addr_h = 0x00000000;
  a24d16.addr_l = a24d16.addr_l&dev_mask[a24d16.cw.tg.asz] |
                   (b_addr[dev]+aoff)&~dev_mask[a24d16.cw.tg.asz];
  a24d16.dc = 1;
  a24d16.dp = data;
  a24d16.delay = 0;
  a24d16.uam = 0;

  data[0] = 0xC0DE;

  dly16us.cw.tg.tt=SNGL;
  dly16us.cw.tg.dsz=D08;
  dly16us.cw.tg.wrt=READ;
  dly16us.cw.tg.asz=A16;
  //  dly16us.cw.tg.dt=D16nsX16;
  dly16us.cw.tg.dt=D16usX16;
  dly16us.cw.tg.at=0;
  dly16us.addr_l = 0;
  dly16us.addr_h = 0;
  dly16us.dc = 0;
  dly16us.dp = data;
  dly16us.delay = 0x2710;
  //  dly16us.delay = 0x8000;
  dly16us.uam = 0;

  derrs=0;
  exerrs=0;
  derr=0;
  exerr=0;
  printf("\n    DELAY Test:\n");
  fprintf(fplog,"\n    DELAY Test:\n"); 
  printf("\n    Checking for proper VME transfers after executing a delay:\n");
  fprintf(fplog,"\n    Checking for proper VME transfers after executing a delay:\n");

  a24d16.cw.tg.wrt=1; //change to write;
  nvu=add2pkt(1, &a24d16);
  nvu=add2pkt(0, &dly16us);
  a24d16.cw.tg.wrt=0; //change to read;
  nvu=add2pkt(0, &a24d16);
  nvu=add2pkt(0, &a24d16);
  nvu=add2pkt(0, &a24d16);
  if(nvu<0){
    printf("    Error while packing VME data: Error #%d\n",-nvu);
    exerr++;
  }
  else {
    printf("    VME command added to packet\n");
    printf("    Number of VME Units = %d unit(s)\n",nvu);
    printf("    Packet data size    = %d bytes\n",nwbuf);
    n=eth_write();
    response=look4_vme_pkt(VMED16_PKT,rtn_buf, sizeof rtn_buf);
    if(response.npkt==0){
      printf("    No response after DELAY and attempting a VME READ\n");
      fprintf(fplog,"    No response after DELAY and attempting a VME READ\n");
      exerr++;
    }
    else {
      rdsz=response.buf_typ;
      if(response.ndat>0 && rdsz==a24d16.cw.tg.dsz){
        for(i=0;i<3;i++){
	  if(hpr[i] != (data[0]&0xFFFF)){
	    derr++;
	    printf("    ex:%04hX  rbk:%04hX  err:%04hX\n",data[0]&0xFFFF,
		   hpr[i],hpr[i]^(data[0]&0xFFFF));
	    fprintf(fplog,"    ex:%04hX  rbk:%04hX  err:%04hX\n",data[0]&0xFFFF,
		    hpr[i],hpr[i]^(data[0]&0xFFFF));
	  }
	}
      }
      else {
	printf("    Problems encountered during READ:\n");
	fprintf(fplog,"    Problems encountered during READ:\n");
        prt_rsp(&response);
        fprt_rsp(fplog, &response);
	exerr++;
      }
    }
  }
  if(derr>0 || exerr>0){
    printf("    %6d data errors, %3d execution errors\n",derr,exerr);
    printf("    Delay Test: ........................................................Failed:\n");
    fprintf(fplog,"    %6d data errors, %3d execution errors\n",derr,exerr);
    fprintf(fplog,"    Delay Test: ........................................................Failed:\n");
    derrs+=derr;
    exerrs+=exerr;
    derr=0;
    exerr=0;
    printf("\n    Attempting to recover with reload command:\n");
    fprintf(fplog,"\n    Attempting to recover with reload command:\n");
    force_reload();
    sleep(3);      
    a24d16.cw.tg.wrt=0; //change to read;
    nvu=add2pkt(1, &a24d16);
    if(nvu<0){
      printf("    Error while packing VME data: Error #%d\n",-nvu);
      exerr++;
    }
    else {
      printf("    VME command added to packet\n");
      printf("    Number of VME Units = %d unit(s)\n",nvu);
      printf("    Packet data size    = %d bytes\n",nwbuf);
      n=eth_write();
      response=look4_vme_pkt(VMED16_PKT,rtn_buf, sizeof rtn_buf);
      if(response.npkt==0){
	printf("    No response after DELAY and attempting a VME READ\n");
	fprintf(fplog,"    No response after DELAY and attempting a VME READ\n");
	exerr++;
      }
      else {
	rdsz=response.buf_typ;
	if(response.ndat>0 && rdsz==a24d16.cw.tg.dsz){
	  if(hpr[0] != (data[0]&0xFFFF)){
	    derr++;
	    printf("    ex:%04hX  rbk:%04hX  err:%04hX\n",data[0]&0xFFFF,
		   hpr[0],hpr[0]^(data[0]&0xFFFF));
	    fprintf(fplog,"    ex:%04hX  rbk:%04hX  err:%04hX\n",data[0]&0xFFFF,
		    hpr[0],hpr[0]^(data[0]&0xFFFF));
	  }
	}
	else {
	  printf("    Problems encountered during READ:\n");
	  fprintf(fplog,"    Problems encountered during READ:\n");
          prt_rsp(&response);
          fprt_rsp(fplog, &response);
	  exerr++;
	}
      }
    }
    if(derr>0 || exerr>0){
      printf("    %6d data errors, %3d execution errors\n",derr,exerr);
      printf("    Delay Test Recovery Attempt: .......................................Failed:\n");
      fprintf(fplog,"    %6d data errors, %3d execution errors\n",derr,exerr);
      fprintf(fplog,"    Delay Test Recovery Attempt: .......................................Failed:\n");
      derrs+=derr;
      exerrs+=exerr;
    }
    else {
      printf("    Delay Test Recovery Attempt: .....................................Succeded:\n");
      fprintf(fplog,"    Delay Test Recovery Attempt: .....................................Succeded:\n");
    }
  }
  else {
    printf("    Delay Test: ........................................................Passed:\n");
    fprintf(fplog,"    Delay Test: ........................................................Passed:\n");
  }
  errcnt= derrs+exerrs;
  set_clr_bits(SET, ETHER, ETH_CR_SPONT); // Re-enable spontaneous packets.
  return errcnt;
}



void init_slave()
{
int n;
enum pkt_t ptyp;
enum src_id srcid;
enum typ_id typid;

CNFG_ptr rcv_cnfg1;
  cur_mac=slave;{
    eth_read_timeout(RD_TMO_long);
    // Set "send startup packet" bit,
    set_clr_bits(SET, RESET,RST_CR_STRTUP);
    //Get slave configuration
    rcv_cnfg1 = read_crs();
    cp_crs(&slv_cnfg,rcv_cnfg1);
    free(rcv_cnfg1);
    save_cnfg_num(1);
    set_cnfg_dflt(1);
    printf("    Clearing memory by reloading the Slave\n");
    force_reload();
    n=eth_read();
    if(n>6){
      ptyp = rbuf[PKT_TYP_OFF]&0xFF;
      srcid = SOURCE_ID(rbuf);
      typid = MSG_TYP_ID(rbuf);
      if(ptyp == INFO_PKT && srcid == STRTUP_SHTDWN){
        printf("    Rcvd. Startup pkt. Slave is ready\n");
      }
      else {
        printf("    Rcvd. Unexpected packet type\n");
        printf("    Packet type = %02X\n",ptyp);
        printf("    Source ID   = %01X\n",srcid);
        printf("    Type ID     = %01X\n",typid);
      }
    }
    else {
      printf("    No response from slave! Continuing anyway...\n");
      usleep(500000); //pause 500 ms 
    }
    // Clear "send startup packet" bit,
    set_clr_bits(CLR, RESET,~RST_CR_STRTUP);
    set_cnfg_dflt(0);
  }
  cur_mac=master;
  eth_read_timeout(RD_TMO_short);
}

void prt_rsp(struct rspn_t *rsp)
{
  printf("    Number Pkts: %d\n",rsp->npkt);
  printf("    Spont. Pkts: %d\n",rsp->nspt);
  printf("    Error  Pkts: %d\n",rsp->nerr);
  printf("    BERR(slave): %d\n",rsp->nberr);
  printf("    BusTimeouts: %d\n",rsp->nbto);
  printf("    Warn.  Pkts: %d\n",rsp->nwrn);
  printf("    Info.  Pkts: %d\n",rsp->ninf);
  printf("    Intr.  Pkts: %d\n",rsp->nintr);
  printf("    Data   Pkts: %d\n",rsp->ndat);
  printf("    Ackn   Pkts: %d\n",rsp->nack_only);
  printf("    Bad    Pkts: %d\n",rsp->nbad);
  printf("    Data wrdcnt: %d\n",rsp->buf_cnt);
  printf("    Data   type: %d\n",rsp->buf_typ);
  printf("    Total words: %d\n",rsp->totwrds);
}
void fprt_rsp(FILE *fp, struct rspn_t *rsp)
{
  fprintf(fp,"    Number Pkts: %d\n",rsp->npkt);
  fprintf(fp,"    Spont. Pkts: %d\n",rsp->nspt);
  fprintf(fp,"    Error  Pkts: %d\n",rsp->nerr);
  fprintf(fp,"    BERR(slave): %d\n",rsp->nberr);
  fprintf(fp,"    BusTimeouts: %d\n",rsp->nbto);
  fprintf(fp,"    Warn.  Pkts: %d\n",rsp->nwrn);
  fprintf(fp,"    Info.  Pkts: %d\n",rsp->ninf);
  fprintf(fp,"    Intr.  Pkts: %d\n",rsp->nintr);
  fprintf(fp,"    Data   Pkts: %d\n",rsp->ndat);
  fprintf(fp,"    Ackn   Pkts: %d\n",rsp->nack_only);
  fprintf(fp,"    Bad    Pkts: %d\n",rsp->nbad);
  fprintf(fp,"    Data wrdcnt: %d\n",rsp->buf_cnt);
  fprintf(fp,"    Data   type: %d\n",rsp->buf_typ);
  fprintf(fp,"    Total words: %d\n",rsp->totwrds);
}

int add2pkt(int new, VCMD_t *vc)
{
  static int nvme_cmds;
  int i;
  int err_num,cur_nwbuf;
  int nlimit,doff,off;
  err_num=0;
  if(new){
    nvme_cmds=0;
    nwbuf=4;
    //    wbuf[0]=0x20;
    wbuf[0]=0x00;
    wbuf[1]=VME_Cmds;
  }
  cur_nwbuf = nwbuf;
  wbuf[nwbuf++]=vc->cw.full>>8;
  wbuf[nwbuf++]=vc->cw.full&0xFF;
  if(vc->cw.tg.dt >0){
    if(vc->cw.tg.dt<4){
      wbuf[nwbuf++] = (vc->delay>>8)&0xFF;
      wbuf[nwbuf++] = vc->delay&0xFF;
    }
    else {
      wbuf[nwbuf++] = (vc->delay>>24)&0xFF;
      wbuf[nwbuf++] = (vc->delay>>16)&0xFF;
      wbuf[nwbuf++] = (vc->delay>>8)&0xFF;
      wbuf[nwbuf++] = vc->delay&0xFF;
    }
  }
  else {
    if(vc->cw.fl.ud){
      wbuf[nwbuf++] = 0x00;
      wbuf[nwbuf++] = vc->uam&0xFF;
    }
    switch(vc->cw.tg.asz){
    case A16:
      wbuf[nwbuf++] = (vc->addr_l>>8)&0xFF;
      wbuf[nwbuf++] = vc->addr_l&0xFF;
      break;
    case A24:
      wbuf[nwbuf++] = 0x00;
      wbuf[nwbuf++] = (vc->addr_l>>16)&0xFF;
      wbuf[nwbuf++] = (vc->addr_l>>8)&0xFF;
      wbuf[nwbuf++] = vc->addr_l&0xFF;
      break;
    case A32:
      wbuf[nwbuf++] = (vc->addr_l>>24)&0xFF;
      wbuf[nwbuf++] = (vc->addr_l>>16)&0xFF;
      wbuf[nwbuf++] = (vc->addr_l>>8)&0xFF;
      wbuf[nwbuf++] = vc->addr_l&0xFF;
      break;
    case A40:
      wbuf[nwbuf++] = 0x00;
      wbuf[nwbuf++] = vc->addr_h&0xFF;
      wbuf[nwbuf++] = (vc->addr_l>>24)&0xFF;
      wbuf[nwbuf++] = (vc->addr_l>>16)&0xFF;
      wbuf[nwbuf++] = (vc->addr_l>>8)&0xFF;
      wbuf[nwbuf++] = vc->addr_l&0xFF;
      break;
    case A64:
      wbuf[nwbuf++] = (vc->addr_h>>24)&0xFF;
      wbuf[nwbuf++] = (vc->addr_h>>16)&0xFF;
      wbuf[nwbuf++] = (vc->addr_h>>8)&0xFF;
      wbuf[nwbuf++] = vc->addr_h&0xFF;
      wbuf[nwbuf++] = (vc->addr_l>>24)&0xFF;
      wbuf[nwbuf++] = (vc->addr_l>>16)&0xFF;
      wbuf[nwbuf++] = (vc->addr_l>>8)&0xFF;
      wbuf[nwbuf++] = vc->addr_l&0xFF;
      break;
    default:
      printf("    Error in address size.\n");
      printf("    Command is not being executed\n");
      err_num = 1;
      break;
    }
    if(vc->cw.tg.tt == BLOCK){
      wbuf[nwbuf++] = (vc->dc>>8)&0xFF;
      wbuf[nwbuf++] = vc->dc&0xFF;
      nlimit = (vc->cw.tg.dsz==D64)?2*vc->dc:vc->dc;
      doff = off;
    }
    else {
      nlimit = 1;
      doff = 0;
    }
    if(vc->cw.tg.wrt){
      if(vc->dc==0){
	printf("    No DATA specified.\n");
	printf("    Command is not being executed\n");
	err_num = 3;
      }
      else {
	for(i=0;i<nlimit;(vc->cw.tg.dsz==D64)?i+=2:i++){
	  switch(vc->cw.tg.dsz){
	  case D08:
	    wbuf[nwbuf++] = 0x00;
	    wbuf[nwbuf++] = vc->dp[i]&0xFF;
	    break;
	  case D16:
	    wbuf[nwbuf++] = (vc->dp[i]>>8)&0xFF;
	    wbuf[nwbuf++] = vc->dp[i]&0xFF;
	    break;
	  case D32:
	    wbuf[nwbuf++] = (vc->dp[i]>>24)&0xFF;
	    wbuf[nwbuf++] = (vc->dp[i]>>16)&0xFF;
	    wbuf[nwbuf++] = (vc->dp[i]>>8)&0xFF;
	    wbuf[nwbuf++] = vc->dp[i]&0xFF;
	    break;
	  case D64:
	    wbuf[nwbuf++] = (vc->dp[i]>>24)&0xFF;
	    wbuf[nwbuf++] = (vc->dp[i]>>16)&0xFF;
	    wbuf[nwbuf++] = (vc->dp[i]>>8)&0xFF;
	    wbuf[nwbuf++] = vc->dp[i]&0xFF;
	    wbuf[nwbuf++] = (vc->dp[i+1]>>24)&0xFF;
	    wbuf[nwbuf++] = (vc->dp[i+1]>>16)&0xFF;
	    wbuf[nwbuf++] = (vc->dp[i+1]>>8)&0xFF;
	    wbuf[nwbuf++] = vc->dp[i+1]&0xFF;
	    break;
	  default:
	    printf("    Error in data size.\n");
	    printf("    Command is not being executed\n");
	    err_num = 2;
	    break;
	  }
	}
      }
    }
  }
  if(nwbuf>MAX_DATA_PKT){
    err_num=4;
    nwbuf=cur_nwbuf;
  }
  if(err_num==0){
    wbuf[2]=((++nvme_cmds)>>8)&0xFF;
    wbuf[3]=(nvme_cmds)&0xFF;
  }
  else {
    return -err_num;
  }
  return nvme_cmds;
}



struct rspn_t look4_vme_pkt(enum pkt_t exp_type, void *buf, int sz_of_buf)
{
  int i,n;
  union hdr_stat hdr;
  enum pkt_t pkt_type;
  enum src_id srcid;
  enum ack_st ackn;

  int spont,frag,new,prio;
  int maxbytes,maxwrds,maxints,maxlongs;
  int numwrds;
  unsigned char *cp;
  unsigned short int *hp;
  unsigned short int code;
  unsigned int *ip,*lph,*lpl;

  unsigned char opcode;
  struct ucw *fopptr;
  struct rspn_t rsp;

  maxbytes=sz_of_buf;
  maxwrds=sz_of_buf/2;
  maxints=sz_of_buf/4;
  maxlongs=sz_of_buf/8;
  cp = buf;
  hp = buf;
  ip = buf;
  lph = buf;
  lpl = buf;
  lpl+=maxlongs;

  rsp.npkt=0;
  rsp.nspt=0;
  rsp.nerr=0;
  rsp.nberr=0;
  rsp.nbto=0;
  rsp.nwrn=0;
  rsp.ninf=0;
  rsp.nintr=0;
  rsp.ndat=0;
  rsp.nack_only=0;
  rsp.nbad=0;
  rsp.buf_cnt=0;
  rsp.buf_typ=0;
  rsp.totwrds=0;
  rsp.ackn=0;


  while((n=eth_read())>6){
    rsp.npkt++;
    hdr.full = rbuf[HDR_OFF];
    spont = hdr.tg.spnt;
    frag  = hdr.tg.frag;
    new   = hdr.tg.new;
    prio  = hdr.tg.prio;
    pkt_type = rbuf[PKT_TYP_OFF] & 0xFF;
    numwrds = DAT_WRD_CNT(rbuf);
    ackn = AK_STATUS(rbuf);
    opcode = rbuf[CMND_ACK_OFF];
    fopptr = (struct ucw *)ptr_bin_srch((int)opcode,foptab,nopcodes);
    /*Packet printing code for debugging*/
/*      for(i=0;i<n;i++){ */
/*        if(i==MAC_SRC_OFF || i==PKT_LEN_OFF || i==FRAG_NUM_OFF || i==WRD_CNT_OFF)printf(":"); */
/*        if(i==HDR_OFF || i==DATA_OFF)printf(":\n  "); */
/*        printf("%02X",rbuf[i]&0xFF); */
/*        if((i-DATA_OFF)%78 ==0 && i!=DATA_OFF)printf("\n  "); */
/*      } */
/*      printf("\n"); */
    if(spont){
      rsp.nspt++;
      if(pkt_type>=INFO_PKT){
        printf("    Message from controller:\n");
        printf("    %s", dcode_msg_pkt(rbuf));
        fprintf(fplog,"    Message from controller:\n");
        fprintf(fplog,"    %s", dcode_msg_pkt(rbuf));
        code = UNV_CODE_WRD(rbuf);
        switch(pkt_type){
	case INFO_PKT:
	  rsp.ninf++;
	  break;
	case WARN_PKT:
	  rsp.nwrn++;
	  break;
	case ERR_PKT:
 	  rsp.nerr++;
	  if(code == VM_BERR_Slv || code == VI_BERR_Slv){
            rsp.nberr++;
          }
          if(code == VM_BTO || code == VI_BTO){
            rsp.nbto++;
	  }
	  break;
	default:
	  break;
	}
      }
      else if(pkt_type>=IHD08_STAT_ID_PKT && pkt_type<=IHD32_STAT_ID_PKT){
        rsp.nintr++;
        switch(pkt_type){
        case IHD08_STAT_ID_PKT:
	  cp[0] = rbuf[DATA_OFF+1]&0xFF;
	  rsp.buf_typ = 0;
	  rsp.buf_cnt = 1;
	  break;
        case IHD16_STAT_ID_PKT:
	  hp[0] = ((rbuf[DATA_OFF]&0xFF)<<8)|(rbuf[DATA_OFF+1]&0xFF);
	  rsp.buf_typ = 1;
	  rsp.buf_cnt = 1;
	  break;
        case IHD32_STAT_ID_PKT:
	  ip[0] = ((rbuf[DATA_OFF+0]&0xFF)<<24)|
	    ((rbuf[DATA_OFF+1]&0xFF)<<16)|
	    ((rbuf[DATA_OFF+2]&0xFF)<<8)|
	    (rbuf[DATA_OFF+3]&0xFF);
	  rsp.buf_typ = 2;
	  rsp.buf_cnt = 1;
	  break;
	default:
	  break;
	}
	rsp.totwrds = numwrds;
        if(pkt_type != exp_type){
	  rsp.buf_cnt = 0;

	  switch(exp_type){
          case IHD08_STAT_ID_PKT:
          case IHD16_STAT_ID_PKT:
          case IHD32_STAT_ID_PKT:
	    printf("    Warning: Received unexpected status size for interrupt packet!\n");
	    fprintf(fplog,"    Warning: Received unexpected status size for interrupt packet!\n");
	    break;
          default:
	    printf("    Unexpectedly Received Interrupt packet type!\n");
	    fprintf(fplog,"    Unexpectedly Received Interrupt packet type!\n");
	    break;
	  }
	}
      }
      else {
	printf("    Unexpected Spontaneous packet type: %02X\n",pkt_type&0xFF);
	fprintf(fplog,"    Unexpected Spontaneous packet type: %02X\n",pkt_type&0xFF);
      }
    }
    else if(new || frag){
      switch(pkt_type){
      case NO_DATA_PKT:
	rsp.nack_only++;
	rsp.ackn=ackn;
	printf("    Received Acknowledgment Packet - no data.\n");
	printf("      Status: %01X:%-6s:%20s %s\n",ackn,ak_status[ackn].mnem,fopptr->mnem,ak_status[ackn].status);
	fprintf(fplog,"    Received Acknowledgment Packet - no data.\n");
	fprintf(fplog,"      Status: %01X:%-6s:%20s %s\n",ackn,ak_status[ackn].mnem,fopptr->mnem,ak_status[ackn].status);
	break;
      case VMED08_PKT:
	rsp.ndat++;
	rsp.buf_cnt= new?0:rsp.buf_cnt;
	rsp.buf_typ = pkt_type-VMED08_PKT;
	rsp.totwrds = new?0:rsp.totwrds;
	rsp.ackn=ackn;
	for(i=0;i<numwrds && rsp.buf_cnt<maxbytes;i++){
	  cp[rsp.buf_cnt++] = rbuf[DATA_OFF+i];
	}
        break;
      case VMED16_PKT:
	rsp.ndat++;
	rsp.buf_cnt= new?0:rsp.buf_cnt;
	rsp.buf_typ = pkt_type-VMED08_PKT;
	rsp.totwrds = new?0:rsp.totwrds;
	rsp.ackn=ackn;
	for(i=0;i<numwrds && rsp.buf_cnt<maxwrds;i++){
	  hp[rsp.buf_cnt++] = ((rbuf[2*i+DATA_OFF+0]&0xFF)<<8)|
                       (rbuf[2*i+DATA_OFF+1]&0xFF);
	}
        break;
      case VMED32_PKT:
	rsp.ndat++;
	rsp.buf_cnt= new?0:rsp.buf_cnt;
	rsp.buf_typ = pkt_type-VMED08_PKT;
	rsp.totwrds = new?0:rsp.totwrds;
	rsp.ackn=ackn;
	for(i=0;i<numwrds/2 && rsp.buf_cnt<maxints;i++){
	  ip[i] = ((rbuf[4*i+DATA_OFF+0]&0xFF)<<24)|
                  ((rbuf[4*i+DATA_OFF+1]&0xFF)<<16)|
                  ((rbuf[4*i+DATA_OFF+2]&0xFF)<<8)|
	           (rbuf[4*i+DATA_OFF+3]&0xFF);
          rsp.buf_cnt++;
	}
        break;
      case VMED64_PKT:
	rsp.ndat++;
	rsp.buf_cnt= new?0:rsp.buf_cnt;
	rsp.buf_typ = pkt_type-VMED08_PKT;
	rsp.totwrds = new?0:rsp.totwrds;
	rsp.ackn=ackn;
	for(i=0;i<numwrds/4 && rsp.buf_cnt<maxlongs;i++){
	  lph[i] = ((rbuf[8*i+DATA_OFF+0]&0xFF)<<24)|
                   ((rbuf[8*i+DATA_OFF+1]&0xFF)<<16)|
                   ((rbuf[8*i+DATA_OFF+2]&0xFF)<<8)|
	            (rbuf[8*i+DATA_OFF+3]&0xFF);
	  lpl[i] = ((rbuf[8*i+DATA_OFF+4]&0xFF)<<24)|
                   ((rbuf[8*i+DATA_OFF+5]&0xFF)<<16)|
                   ((rbuf[8*i+DATA_OFF+6]&0xFF)<<8)|
	            (rbuf[8*i+DATA_OFF+7]&0xFF);
          rsp.buf_cnt++;
	}
        break;
      default:
	printf("    Received Packet is not VME Data\n");
	printf("      Packet type is : 0x%02X\n",pkt_type&0xFF);
	fprintf(fplog,"    Received Packet is not VME Data\n");
	fprintf(fplog,"      Packet type is : 0x%02X\n",pkt_type&0xFF);
        for(i=0;i<DATA_OFF+2*numwrds;i++){
          printf("%02X",rbuf[i]&0xFF);
        }
        printf("\n");
        break;
      }
      rsp.totwrds += numwrds;
    }
    else {
      rsp.nbad++;
      printf("    Illegal Header encountered\n");
      fprintf(fplog,"    Illegal Header encountered\n");
    }
  }
  return rsp;
}

